/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail;

import com.liferay.portal.PortalException;

/**
 * <a href="AccountSettingException.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 *
 */
public class AccountSettingException extends PortalException {

	public static final int AUTHENTICATION_FAILED = 1;

	public static final int CONNECTION_FAILED = 2;

	public static final int INCOMING_CONNECTION_FAILED = 3;

	public static final int OUTGOING_CONNECTION_FAILED = 4;

	public AccountSettingException() {
		super();
	}

	public AccountSettingException(String msg) {
		super(msg);
	}

	public AccountSettingException(String msg, Throwable cause) {
		super(msg, cause);
	}

	public AccountSettingException(Throwable cause) {
		super(cause);
	}

	public AccountSettingException(int type) {
		_type = type;
	}

	public AccountSettingException(int type, Throwable cause) {
		super(cause);

		_type = type;
	}

	public int getType() {
		return _type;
	}

	private int _type;

}