/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.model;

import com.liferay.portal.SystemException;
import com.liferay.portal.model.BaseModel;

import java.util.Date;

/**
 * <a href="AccountEntryModel.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public interface AccountEntryModel extends BaseModel<AccountEntry> {
	public long getPrimaryKey();

	public void setPrimaryKey(long pk);

	public long getAccountEntryId();

	public void setAccountEntryId(long accountEntryId);

	public long getCompanyId();

	public void setCompanyId(long companyId);

	public long getUserId();

	public void setUserId(long userId);

	public String getUserUuid() throws SystemException;

	public void setUserUuid(String userUuid);

	public Date getCreateDate();

	public void setCreateDate(Date createDate);

	public Date getModifiedDate();

	public void setModifiedDate(Date modifiedDate);

	public String getType();

	public void setType(String type);

	public String getMessageAddress();

	public void setMessageAddress(String messageAddress);

	public long getInboxFolderId();

	public void setInboxFolderId(long inboxFolderId);

	public long getDraftFolderId();

	public void setDraftFolderId(long draftFolderId);

	public long getSentFolderId();

	public void setSentFolderId(long sentFolderId);

	public long getTrashFolderId();

	public void setTrashFolderId(long trashFolderId);

	public String getUsername();

	public void setUsername(String username);

	public String getSenderName();

	public void setSenderName(String senderName);

	public String getPassword();

	public void setPassword(String password);

	public boolean getPasswordSaved();

	public boolean isPasswordSaved();

	public void setPasswordSaved(boolean passwordSaved);

	public boolean getInitialized();

	public boolean isInitialized();

	public void setInitialized(boolean initialized);

	public String getSignature();

	public void setSignature(String signature);

	public boolean getUseSignature();

	public boolean isUseSignature();

	public void setUseSignature(boolean useSignature);

	public AccountEntry toEscapedModel();
}