/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.model;

import com.liferay.portal.model.BaseModel;

import java.util.Date;

/**
 * <a href="AccountSettingModel.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public interface AccountSettingModel extends BaseModel<AccountSetting> {
	public long getPrimaryKey();

	public void setPrimaryKey(long pk);

	public long getAccountSettingId();

	public void setAccountSettingId(long accountSettingId);

	public long getCompanyId();

	public void setCompanyId(long companyId);

	public Date getCreateDate();

	public void setCreateDate(Date createDate);

	public Date getModifiedDate();

	public void setModifiedDate(Date modifiedDate);

	public long getAccountEntryId();

	public void setAccountEntryId(long accountEntryId);

	public String getType();

	public void setType(String type);

	public String getMailInHostName();

	public void setMailInHostName(String mailInHostName);

	public int getMailInPort();

	public void setMailInPort(int mailInPort);

	public boolean getMailInSecure();

	public boolean isMailInSecure();

	public void setMailInSecure(boolean mailInSecure);

	public String getMailOutHostName();

	public void setMailOutHostName(String mailOutHostName);

	public int getMailOutPort();

	public void setMailOutPort(int mailOutPort);

	public boolean getMailOutSecure();

	public boolean isMailOutSecure();

	public void setMailOutSecure(boolean mailOutSecure);

	public String getDefaultFolderPrefix();

	public void setDefaultFolderPrefix(String defaultFolderPrefix);

	public AccountSetting toEscapedModel();
}