/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.model;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <a href="AccountSettingSoap.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class AccountSettingSoap implements Serializable {
	public static AccountSettingSoap toSoapModel(AccountSetting model) {
		AccountSettingSoap soapModel = new AccountSettingSoap();

		soapModel.setAccountSettingId(model.getAccountSettingId());
		soapModel.setCompanyId(model.getCompanyId());
		soapModel.setCreateDate(model.getCreateDate());
		soapModel.setModifiedDate(model.getModifiedDate());
		soapModel.setAccountEntryId(model.getAccountEntryId());
		soapModel.setType(model.getType());
		soapModel.setMailInHostName(model.getMailInHostName());
		soapModel.setMailInPort(model.getMailInPort());
		soapModel.setMailInSecure(model.getMailInSecure());
		soapModel.setMailOutHostName(model.getMailOutHostName());
		soapModel.setMailOutPort(model.getMailOutPort());
		soapModel.setMailOutSecure(model.getMailOutSecure());
		soapModel.setDefaultFolderPrefix(model.getDefaultFolderPrefix());

		return soapModel;
	}

	public static AccountSettingSoap[] toSoapModels(AccountSetting[] models) {
		AccountSettingSoap[] soapModels = new AccountSettingSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static AccountSettingSoap[][] toSoapModels(AccountSetting[][] models) {
		AccountSettingSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new AccountSettingSoap[models.length][models[0].length];
		}
		else {
			soapModels = new AccountSettingSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static AccountSettingSoap[] toSoapModels(List<AccountSetting> models) {
		List<AccountSettingSoap> soapModels = new ArrayList<AccountSettingSoap>(models.size());

		for (AccountSetting model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new AccountSettingSoap[soapModels.size()]);
	}

	public AccountSettingSoap() {
	}

	public long getPrimaryKey() {
		return _accountSettingId;
	}

	public void setPrimaryKey(long pk) {
		setAccountSettingId(pk);
	}

	public long getAccountSettingId() {
		return _accountSettingId;
	}

	public void setAccountSettingId(long accountSettingId) {
		_accountSettingId = accountSettingId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public void setModifiedDate(Date modifiedDate) {
		_modifiedDate = modifiedDate;
	}

	public long getAccountEntryId() {
		return _accountEntryId;
	}

	public void setAccountEntryId(long accountEntryId) {
		_accountEntryId = accountEntryId;
	}

	public String getType() {
		return _type;
	}

	public void setType(String type) {
		_type = type;
	}

	public String getMailInHostName() {
		return _mailInHostName;
	}

	public void setMailInHostName(String mailInHostName) {
		_mailInHostName = mailInHostName;
	}

	public int getMailInPort() {
		return _mailInPort;
	}

	public void setMailInPort(int mailInPort) {
		_mailInPort = mailInPort;
	}

	public boolean getMailInSecure() {
		return _mailInSecure;
	}

	public boolean isMailInSecure() {
		return _mailInSecure;
	}

	public void setMailInSecure(boolean mailInSecure) {
		_mailInSecure = mailInSecure;
	}

	public String getMailOutHostName() {
		return _mailOutHostName;
	}

	public void setMailOutHostName(String mailOutHostName) {
		_mailOutHostName = mailOutHostName;
	}

	public int getMailOutPort() {
		return _mailOutPort;
	}

	public void setMailOutPort(int mailOutPort) {
		_mailOutPort = mailOutPort;
	}

	public boolean getMailOutSecure() {
		return _mailOutSecure;
	}

	public boolean isMailOutSecure() {
		return _mailOutSecure;
	}

	public void setMailOutSecure(boolean mailOutSecure) {
		_mailOutSecure = mailOutSecure;
	}

	public String getDefaultFolderPrefix() {
		return _defaultFolderPrefix;
	}

	public void setDefaultFolderPrefix(String defaultFolderPrefix) {
		_defaultFolderPrefix = defaultFolderPrefix;
	}

	private long _accountSettingId;
	private long _companyId;
	private Date _createDate;
	private Date _modifiedDate;
	private long _accountEntryId;
	private String _type;
	private String _mailInHostName;
	private int _mailInPort;
	private boolean _mailInSecure;
	private String _mailOutHostName;
	private int _mailOutPort;
	private boolean _mailOutSecure;
	private String _defaultFolderPrefix;
}