/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.model;

import com.liferay.portal.SystemException;
import com.liferay.portal.model.BaseModel;

import java.util.Date;

/**
 * <a href="MessageModel.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public interface MessageModel extends BaseModel<Message> {
	public long getPrimaryKey();

	public void setPrimaryKey(long pk);

	public long getMessageId();

	public void setMessageId(long messageId);

	public long getCompanyId();

	public void setCompanyId(long companyId);

	public long getUserId();

	public void setUserId(long userId);

	public String getUserUuid() throws SystemException;

	public void setUserUuid(String userUuid);

	public Date getCreateDate();

	public void setCreateDate(Date createDate);

	public Date getModifiedDate();

	public void setModifiedDate(Date modifiedDate);

	public long getFolderId();

	public void setFolderId(long folderId);

	public String getSender();

	public void setSender(String sender);

	public String getRecipientsTo();

	public void setRecipientsTo(String recipientsTo);

	public String getRecipientsCc();

	public void setRecipientsCc(String recipientsCc);

	public String getRecipientsBcc();

	public void setRecipientsBcc(String recipientsBcc);

	public Date getSentDate();

	public void setSentDate(Date sentDate);

	public String getSubject();

	public void setSubject(String subject);

	public String getPreview();

	public void setPreview(String preview);

	public String getBody();

	public void setBody(String body);

	public String getFlags();

	public void setFlags(String flags);

	public long getSize();

	public void setSize(long size);

	public long getRemoteMessageId();

	public void setRemoteMessageId(long remoteMessageId);

	public Message toEscapedModel();
}