/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ClassLoaderProxy;

/**
 * <a href="AccountEntryLocalServiceUtil.java.html"><b><i>View Source</i></b>
 * </a>
 *
 * @author Scott Lee
 */
public class AccountEntryLocalServiceUtil {
	public static com.liferay.mail.model.AccountEntry addAccountEntry(
		com.liferay.mail.model.AccountEntry accountEntry)
		throws com.liferay.portal.SystemException {
		return getService().addAccountEntry(accountEntry);
	}

	public static com.liferay.mail.model.AccountEntry createAccountEntry(
		long accountEntryId) {
		return getService().createAccountEntry(accountEntryId);
	}

	public static void deleteAccountEntry(long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().deleteAccountEntry(accountEntryId);
	}

	public static void deleteAccountEntry(
		com.liferay.mail.model.AccountEntry accountEntry)
		throws com.liferay.portal.SystemException {
		getService().deleteAccountEntry(accountEntry);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	public static com.liferay.mail.model.AccountEntry getAccountEntry(
		long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getAccountEntry(accountEntryId);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> getAccountEntries(
		int start, int end) throws com.liferay.portal.SystemException {
		return getService().getAccountEntries(start, end);
	}

	public static int getAccountEntriesCount()
		throws com.liferay.portal.SystemException {
		return getService().getAccountEntriesCount();
	}

	public static com.liferay.mail.model.AccountEntry updateAccountEntry(
		com.liferay.mail.model.AccountEntry accountEntry)
		throws com.liferay.portal.SystemException {
		return getService().updateAccountEntry(accountEntry);
	}

	public static com.liferay.mail.model.AccountEntry updateAccountEntry(
		com.liferay.mail.model.AccountEntry accountEntry, boolean merge)
		throws com.liferay.portal.SystemException {
		return getService().updateAccountEntry(accountEntry, merge);
	}

	public static com.liferay.mail.model.AccountEntry addAccountEntry(
		long userId, java.lang.String type, java.lang.String messageAddress,
		java.lang.String username, java.lang.String password,
		boolean passwordSaved, java.lang.String senderName,
		java.lang.String signature, boolean useSignature)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .addAccountEntry(userId, type, messageAddress, username,
			password, passwordSaved, senderName, signature, useSignature);
	}

	public static com.liferay.mail.model.AccountEntry createAccountEntry(
		long userId, java.lang.String type, java.lang.String messageAddress,
		java.lang.String username, java.lang.String password,
		boolean passwordSaved, java.lang.String senderName,
		java.lang.String signature, boolean useSignature)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .createAccountEntry(userId, type, messageAddress, username,
			password, passwordSaved, senderName, signature, useSignature);
	}

	public static com.liferay.mail.model.AccountEntry createMockAccountEntry(
		long userId, java.lang.String type, java.lang.String messageAddress,
		java.lang.String username, java.lang.String password,
		java.lang.String senderName, java.lang.String signature,
		boolean useSignature)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .createMockAccountEntry(userId, type, messageAddress,
			username, password, senderName, signature, useSignature);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> getCompanyAccountEntries(
		long companyId) throws com.liferay.portal.SystemException {
		return getService().getCompanyAccountEntries(companyId);
	}

	public static com.liferay.mail.model.AccountEntry getCompanyAccountEntry(
		long companyId, java.lang.String type, java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getService()
				   .getCompanyAccountEntry(companyId, type, messageAddress);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> getUserAccountEntries(
		long userId) throws com.liferay.portal.SystemException {
		return getService().getUserAccountEntries(userId);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> getUserAccountEntries(
		long userId, java.lang.String type)
		throws com.liferay.portal.SystemException {
		return getService().getUserAccountEntries(userId, type);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> getUserAccountEntries(
		long userId, java.lang.String type, boolean initialized)
		throws com.liferay.portal.SystemException {
		return getService().getUserAccountEntries(userId, type, initialized);
	}

	public static com.liferay.mail.model.AccountEntry getUserAccountEntry(
		long userId, java.lang.String type, java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getService().getUserAccountEntry(userId, type, messageAddress);
	}

	public static com.liferay.mail.model.AccountEntry updateAccountEntry(
		long accountEntryId, java.lang.String messageAddress,
		java.lang.String username, java.lang.String password,
		boolean passwordSaved, java.lang.String senderName,
		java.lang.String signature, boolean useSignature)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .updateAccountEntry(accountEntryId, messageAddress,
			username, password, passwordSaved, senderName, signature,
			useSignature);
	}

	public static void clearService() {
		_service = null;
	}

	public static AccountEntryLocalService getService() {
		if (_service == null) {
			Object obj = PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					AccountEntryLocalServiceUtil.class.getName());
			ClassLoader portletClassLoader = (ClassLoader)PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					"portletClassLoader");

			ClassLoaderProxy classLoaderProxy = new ClassLoaderProxy(obj,
					portletClassLoader);

			_service = new AccountEntryLocalServiceClp(classLoaderProxy);

			ClpSerializer.setClassLoader(portletClassLoader);
		}

		return _service;
	}

	public void setService(AccountEntryLocalService service) {
		_service = service;
	}

	private static AccountEntryLocalService _service;
}