/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.PortalException;
import com.liferay.portal.SystemException;
import com.liferay.portal.kernel.annotation.Isolation;
import com.liferay.portal.kernel.annotation.Propagation;
import com.liferay.portal.kernel.annotation.Transactional;

/**
 * <a href="AccountSettingLocalService.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
@Transactional(isolation = Isolation.PORTAL, rollbackFor =  {
	PortalException.class, SystemException.class})
public interface AccountSettingLocalService {
	public com.liferay.mail.model.AccountSetting addAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting createAccountSetting(
		long accountSettingId);

	public void deleteAccountSetting(long accountSettingId)
		throws com.liferay.portal.SystemException,
			com.liferay.portal.PortalException;

	public void deleteAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException;

	public java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException;

	public java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException;

	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public com.liferay.mail.model.AccountSetting getAccountSetting(
		long accountSettingId)
		throws com.liferay.portal.SystemException,
			com.liferay.portal.PortalException;

	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public java.util.List<com.liferay.mail.model.AccountSetting> getAccountSettings(
		int start, int end) throws com.liferay.portal.SystemException;

	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public int getAccountSettingsCount()
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting updateAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting updateAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting, boolean merge)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting addAccountSettings(
		long companyId, long accountEntryId, java.lang.String type,
		java.lang.String mailInHostName, int mailInPort, boolean mailInSecure,
		java.lang.String mailOutHostName, int mailOutPort,
		boolean mailOutSecure, java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting createAccountSettings(
		long companyId, long accountEntryId, java.lang.String type,
		java.lang.String mailInHostName, int mailInPort, boolean mailInSecure,
		java.lang.String mailOutHostName, int mailOutPort,
		boolean mailOutSecure, java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.SystemException;

	public void deleteAEAccountSetting(long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException;

	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public com.liferay.mail.model.AccountSetting getAEAccountSetting(
		long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting updateAccountSettings(
		long accountSettingId, java.lang.String mailInHostName, int mailInPort,
		boolean mailInSecure, java.lang.String mailOutHostName,
		int mailOutPort, boolean mailOutSecure,
		java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException;
}