/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.kernel.util.BooleanWrapper;
import com.liferay.portal.kernel.util.ClassLoaderProxy;
import com.liferay.portal.kernel.util.IntegerWrapper;
import com.liferay.portal.kernel.util.LongWrapper;
import com.liferay.portal.kernel.util.NullWrapper;

/**
 * <a href="AccountSettingLocalServiceClp.java.html"><b><i>View Source</i></b>
 * </a>
 *
 * @author Scott Lee
 */
public class AccountSettingLocalServiceClp implements AccountSettingLocalService {
	public AccountSettingLocalServiceClp(ClassLoaderProxy classLoaderProxy) {
		_classLoaderProxy = classLoaderProxy;
	}

	public com.liferay.mail.model.AccountSetting addAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = ClpSerializer.translateInput(accountSetting);

		if (accountSetting == null) {
			paramObj0 = new NullWrapper("com.liferay.mail.model.AccountSetting");
		}

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("addAccountSetting",
					new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public com.liferay.mail.model.AccountSetting createAccountSetting(
		long accountSettingId) {
		Object paramObj0 = new LongWrapper(accountSettingId);

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("createAccountSetting",
					new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public void deleteAccountSetting(long accountSettingId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(accountSettingId);

		try {
			_classLoaderProxy.invoke("deleteAccountSetting",
				new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.PortalException) {
				throw (com.liferay.portal.PortalException)t;
			}

			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}
	}

	public void deleteAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = ClpSerializer.translateInput(accountSetting);

		if (accountSetting == null) {
			paramObj0 = new NullWrapper("com.liferay.mail.model.AccountSetting");
		}

		try {
			_classLoaderProxy.invoke("deleteAccountSetting",
				new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}
	}

	public java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = ClpSerializer.translateInput(dynamicQuery);

		if (dynamicQuery == null) {
			paramObj0 = new NullWrapper(
					"com.liferay.portal.kernel.dao.orm.DynamicQuery");
		}

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("dynamicQuery",
					new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (java.util.List<Object>)ClpSerializer.translateOutput(returnObj);
	}

	public java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		Object paramObj0 = ClpSerializer.translateInput(dynamicQuery);

		if (dynamicQuery == null) {
			paramObj0 = new NullWrapper(
					"com.liferay.portal.kernel.dao.orm.DynamicQuery");
		}

		Object paramObj1 = new IntegerWrapper(start);

		Object paramObj2 = new IntegerWrapper(end);

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("dynamicQuery",
					new Object[] { paramObj0, paramObj1, paramObj2 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (java.util.List<Object>)ClpSerializer.translateOutput(returnObj);
	}

	public com.liferay.mail.model.AccountSetting getAccountSetting(
		long accountSettingId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(accountSettingId);

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("getAccountSetting",
					new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.PortalException) {
				throw (com.liferay.portal.PortalException)t;
			}

			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public java.util.List<com.liferay.mail.model.AccountSetting> getAccountSettings(
		int start, int end) throws com.liferay.portal.SystemException {
		Object paramObj0 = new IntegerWrapper(start);

		Object paramObj1 = new IntegerWrapper(end);

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("getAccountSettings",
					new Object[] { paramObj0, paramObj1 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (java.util.List<com.liferay.mail.model.AccountSetting>)ClpSerializer.translateOutput(returnObj);
	}

	public int getAccountSettingsCount()
		throws com.liferay.portal.SystemException {
		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("getAccountSettingsCount",
					new Object[0]);
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return ((Integer)returnObj).intValue();
	}

	public com.liferay.mail.model.AccountSetting updateAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = ClpSerializer.translateInput(accountSetting);

		if (accountSetting == null) {
			paramObj0 = new NullWrapper("com.liferay.mail.model.AccountSetting");
		}

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("updateAccountSetting",
					new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public com.liferay.mail.model.AccountSetting updateAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting, boolean merge)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = ClpSerializer.translateInput(accountSetting);

		if (accountSetting == null) {
			paramObj0 = new NullWrapper("com.liferay.mail.model.AccountSetting");
		}

		Object paramObj1 = new BooleanWrapper(merge);

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("updateAccountSetting",
					new Object[] { paramObj0, paramObj1 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public com.liferay.mail.model.AccountSetting addAccountSettings(
		long companyId, long accountEntryId, java.lang.String type,
		java.lang.String mailInHostName, int mailInPort, boolean mailInSecure,
		java.lang.String mailOutHostName, int mailOutPort,
		boolean mailOutSecure, java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(companyId);

		Object paramObj1 = new LongWrapper(accountEntryId);

		Object paramObj2 = ClpSerializer.translateInput(type);

		if (type == null) {
			paramObj2 = new NullWrapper("java.lang.String");
		}

		Object paramObj3 = ClpSerializer.translateInput(mailInHostName);

		if (mailInHostName == null) {
			paramObj3 = new NullWrapper("java.lang.String");
		}

		Object paramObj4 = new IntegerWrapper(mailInPort);

		Object paramObj5 = new BooleanWrapper(mailInSecure);

		Object paramObj6 = ClpSerializer.translateInput(mailOutHostName);

		if (mailOutHostName == null) {
			paramObj6 = new NullWrapper("java.lang.String");
		}

		Object paramObj7 = new IntegerWrapper(mailOutPort);

		Object paramObj8 = new BooleanWrapper(mailOutSecure);

		Object paramObj9 = ClpSerializer.translateInput(defaultFolderPrefix);

		if (defaultFolderPrefix == null) {
			paramObj9 = new NullWrapper("java.lang.String");
		}

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("addAccountSettings",
					new Object[] {
						paramObj0, paramObj1, paramObj2, paramObj3, paramObj4,
						paramObj5, paramObj6, paramObj7, paramObj8, paramObj9
					});
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public com.liferay.mail.model.AccountSetting createAccountSettings(
		long companyId, long accountEntryId, java.lang.String type,
		java.lang.String mailInHostName, int mailInPort, boolean mailInSecure,
		java.lang.String mailOutHostName, int mailOutPort,
		boolean mailOutSecure, java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(companyId);

		Object paramObj1 = new LongWrapper(accountEntryId);

		Object paramObj2 = ClpSerializer.translateInput(type);

		if (type == null) {
			paramObj2 = new NullWrapper("java.lang.String");
		}

		Object paramObj3 = ClpSerializer.translateInput(mailInHostName);

		if (mailInHostName == null) {
			paramObj3 = new NullWrapper("java.lang.String");
		}

		Object paramObj4 = new IntegerWrapper(mailInPort);

		Object paramObj5 = new BooleanWrapper(mailInSecure);

		Object paramObj6 = ClpSerializer.translateInput(mailOutHostName);

		if (mailOutHostName == null) {
			paramObj6 = new NullWrapper("java.lang.String");
		}

		Object paramObj7 = new IntegerWrapper(mailOutPort);

		Object paramObj8 = new BooleanWrapper(mailOutSecure);

		Object paramObj9 = ClpSerializer.translateInput(defaultFolderPrefix);

		if (defaultFolderPrefix == null) {
			paramObj9 = new NullWrapper("java.lang.String");
		}

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("createAccountSettings",
					new Object[] {
						paramObj0, paramObj1, paramObj2, paramObj3, paramObj4,
						paramObj5, paramObj6, paramObj7, paramObj8, paramObj9
					});
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public void deleteAEAccountSetting(long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(accountEntryId);

		try {
			_classLoaderProxy.invoke("deleteAEAccountSetting",
				new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.PortalException) {
				throw (com.liferay.portal.PortalException)t;
			}

			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}
	}

	public com.liferay.mail.model.AccountSetting getAEAccountSetting(
		long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(accountEntryId);

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("getAEAccountSetting",
					new Object[] { paramObj0 });
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.PortalException) {
				throw (com.liferay.portal.PortalException)t;
			}

			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	public com.liferay.mail.model.AccountSetting updateAccountSettings(
		long accountSettingId, java.lang.String mailInHostName, int mailInPort,
		boolean mailInSecure, java.lang.String mailOutHostName,
		int mailOutPort, boolean mailOutSecure,
		java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		Object paramObj0 = new LongWrapper(accountSettingId);

		Object paramObj1 = ClpSerializer.translateInput(mailInHostName);

		if (mailInHostName == null) {
			paramObj1 = new NullWrapper("java.lang.String");
		}

		Object paramObj2 = new IntegerWrapper(mailInPort);

		Object paramObj3 = new BooleanWrapper(mailInSecure);

		Object paramObj4 = ClpSerializer.translateInput(mailOutHostName);

		if (mailOutHostName == null) {
			paramObj4 = new NullWrapper("java.lang.String");
		}

		Object paramObj5 = new IntegerWrapper(mailOutPort);

		Object paramObj6 = new BooleanWrapper(mailOutSecure);

		Object paramObj7 = ClpSerializer.translateInput(defaultFolderPrefix);

		if (defaultFolderPrefix == null) {
			paramObj7 = new NullWrapper("java.lang.String");
		}

		Object returnObj = null;

		try {
			returnObj = _classLoaderProxy.invoke("updateAccountSettings",
					new Object[] {
						paramObj0, paramObj1, paramObj2, paramObj3, paramObj4,
						paramObj5, paramObj6, paramObj7
					});
		}
		catch (Throwable t) {
			if (t instanceof com.liferay.portal.PortalException) {
				throw (com.liferay.portal.PortalException)t;
			}

			if (t instanceof com.liferay.portal.SystemException) {
				throw (com.liferay.portal.SystemException)t;
			}

			if (t instanceof RuntimeException) {
				throw (RuntimeException)t;
			}
			else {
				throw new RuntimeException(t.getClass().getName() +
					" is not a valid exception");
			}
		}

		return (com.liferay.mail.model.AccountSetting)ClpSerializer.translateOutput(returnObj);
	}

	private ClassLoaderProxy _classLoaderProxy;
}