/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ClassLoaderProxy;

/**
 * <a href="AccountSettingLocalServiceUtil.java.html"><b><i>View Source</i></b>
 * </a>
 *
 * @author Scott Lee
 */
public class AccountSettingLocalServiceUtil {
	public static com.liferay.mail.model.AccountSetting addAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException {
		return getService().addAccountSetting(accountSetting);
	}

	public static com.liferay.mail.model.AccountSetting createAccountSetting(
		long accountSettingId) {
		return getService().createAccountSetting(accountSettingId);
	}

	public static void deleteAccountSetting(long accountSettingId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().deleteAccountSetting(accountSettingId);
	}

	public static void deleteAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException {
		getService().deleteAccountSetting(accountSetting);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	public static com.liferay.mail.model.AccountSetting getAccountSetting(
		long accountSettingId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getAccountSetting(accountSettingId);
	}

	public static java.util.List<com.liferay.mail.model.AccountSetting> getAccountSettings(
		int start, int end) throws com.liferay.portal.SystemException {
		return getService().getAccountSettings(start, end);
	}

	public static int getAccountSettingsCount()
		throws com.liferay.portal.SystemException {
		return getService().getAccountSettingsCount();
	}

	public static com.liferay.mail.model.AccountSetting updateAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException {
		return getService().updateAccountSetting(accountSetting);
	}

	public static com.liferay.mail.model.AccountSetting updateAccountSetting(
		com.liferay.mail.model.AccountSetting accountSetting, boolean merge)
		throws com.liferay.portal.SystemException {
		return getService().updateAccountSetting(accountSetting, merge);
	}

	public static com.liferay.mail.model.AccountSetting addAccountSettings(
		long companyId, long accountEntryId, java.lang.String type,
		java.lang.String mailInHostName, int mailInPort, boolean mailInSecure,
		java.lang.String mailOutHostName, int mailOutPort,
		boolean mailOutSecure, java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.SystemException {
		return getService()
				   .addAccountSettings(companyId, accountEntryId, type,
			mailInHostName, mailInPort, mailInSecure, mailOutHostName,
			mailOutPort, mailOutSecure, defaultFolderPrefix);
	}

	public static com.liferay.mail.model.AccountSetting createAccountSettings(
		long companyId, long accountEntryId, java.lang.String type,
		java.lang.String mailInHostName, int mailInPort, boolean mailInSecure,
		java.lang.String mailOutHostName, int mailOutPort,
		boolean mailOutSecure, java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.SystemException {
		return getService()
				   .createAccountSettings(companyId, accountEntryId, type,
			mailInHostName, mailInPort, mailInSecure, mailOutHostName,
			mailOutPort, mailOutSecure, defaultFolderPrefix);
	}

	public static void deleteAEAccountSetting(long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().deleteAEAccountSetting(accountEntryId);
	}

	public static com.liferay.mail.model.AccountSetting getAEAccountSetting(
		long accountEntryId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getAEAccountSetting(accountEntryId);
	}

	public static com.liferay.mail.model.AccountSetting updateAccountSettings(
		long accountSettingId, java.lang.String mailInHostName, int mailInPort,
		boolean mailInSecure, java.lang.String mailOutHostName,
		int mailOutPort, boolean mailOutSecure,
		java.lang.String defaultFolderPrefix)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .updateAccountSettings(accountSettingId, mailInHostName,
			mailInPort, mailInSecure, mailOutHostName, mailOutPort,
			mailOutSecure, defaultFolderPrefix);
	}

	public static void clearService() {
		_service = null;
	}

	public static AccountSettingLocalService getService() {
		if (_service == null) {
			Object obj = PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					AccountSettingLocalServiceUtil.class.getName());
			ClassLoader portletClassLoader = (ClassLoader)PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					"portletClassLoader");

			ClassLoaderProxy classLoaderProxy = new ClassLoaderProxy(obj,
					portletClassLoader);

			_service = new AccountSettingLocalServiceClp(classLoaderProxy);

			ClpSerializer.setClassLoader(portletClassLoader);
		}

		return _service;
	}

	public void setService(AccountSettingLocalService service) {
		_service = service;
	}

	private static AccountSettingLocalService _service;
}