/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ClassLoaderProxy;

/**
 * <a href="AttachmentLocalServiceUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class AttachmentLocalServiceUtil {
	public static com.liferay.mail.model.Attachment addAttachment(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException {
		return getService().addAttachment(attachment);
	}

	public static com.liferay.mail.model.Attachment createAttachment(
		long attachmentId) {
		return getService().createAttachment(attachmentId);
	}

	public static void deleteAttachment(long attachmentId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().deleteAttachment(attachmentId);
	}

	public static void deleteAttachment(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException {
		getService().deleteAttachment(attachment);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	public static com.liferay.mail.model.Attachment getAttachment(
		long attachmentId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getAttachment(attachmentId);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> getAttachments(
		int start, int end) throws com.liferay.portal.SystemException {
		return getService().getAttachments(start, end);
	}

	public static int getAttachmentsCount()
		throws com.liferay.portal.SystemException {
		return getService().getAttachmentsCount();
	}

	public static com.liferay.mail.model.Attachment updateAttachment(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException {
		return getService().updateAttachment(attachment);
	}

	public static com.liferay.mail.model.Attachment updateAttachment(
		com.liferay.mail.model.Attachment attachment, boolean merge)
		throws com.liferay.portal.SystemException {
		return getService().updateAttachment(attachment, merge);
	}

	public static com.liferay.mail.model.Attachment addAttachment(
		long messageId, java.lang.String filename, long size)
		throws com.liferay.portal.SystemException {
		return getService().addAttachment(messageId, filename, size);
	}

	public static com.liferay.mail.model.Attachment addAttachment(
		long messageId, java.lang.String filename, long size,
		java.lang.String contentPath) throws com.liferay.portal.SystemException {
		return getService().addAttachment(messageId, filename, size, contentPath);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> getAttachments(
		long messageId) throws com.liferay.portal.SystemException {
		return getService().getAttachments(messageId);
	}

	public static void clearService() {
		_service = null;
	}

	public static AttachmentLocalService getService() {
		if (_service == null) {
			Object obj = PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					AttachmentLocalServiceUtil.class.getName());
			ClassLoader portletClassLoader = (ClassLoader)PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					"portletClassLoader");

			ClassLoaderProxy classLoaderProxy = new ClassLoaderProxy(obj,
					portletClassLoader);

			_service = new AttachmentLocalServiceClp(classLoaderProxy);

			ClpSerializer.setClassLoader(portletClassLoader);
		}

		return _service;
	}

	public void setService(AttachmentLocalService service) {
		_service = service;
	}

	private static AttachmentLocalService _service;
}