/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.mail.model.AccountEntryClp;
import com.liferay.mail.model.AccountSettingClp;
import com.liferay.mail.model.AttachmentClp;
import com.liferay.mail.model.ContactClp;
import com.liferay.mail.model.FolderClp;
import com.liferay.mail.model.MessageClp;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.model.BaseModel;

import java.lang.reflect.Method;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <a href="ClpSerializer.java.html"><b><i>View Source</i></b></a>
 *
 * @author Brian Wing Shun Chan
 */
public class ClpSerializer {
	public static final String SERVLET_CONTEXT_NAME = "mail-portlet";

	public static void setClassLoader(ClassLoader classLoader) {
		_classLoader = classLoader;
	}

	public static Object translateInput(BaseModel oldModel) {
		Class<?> oldModelClass = oldModel.getClass();

		String oldModelClassName = oldModelClass.getName();

		if (oldModelClassName.equals(AccountEntryClp.class.getName())) {
			AccountEntryClp oldCplModel = (AccountEntryClp)oldModel;

			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					Class<?> newModelClass = Class.forName("com.liferay.mail.model.impl.AccountEntryImpl",
							true, _classLoader);

					Object newModel = newModelClass.newInstance();

					Method method0 = newModelClass.getMethod("setAccountEntryId",
							new Class[] { Long.TYPE });

					Long value0 = new Long(oldCplModel.getAccountEntryId());

					method0.invoke(newModel, value0);

					Method method1 = newModelClass.getMethod("setCompanyId",
							new Class[] { Long.TYPE });

					Long value1 = new Long(oldCplModel.getCompanyId());

					method1.invoke(newModel, value1);

					Method method2 = newModelClass.getMethod("setUserId",
							new Class[] { Long.TYPE });

					Long value2 = new Long(oldCplModel.getUserId());

					method2.invoke(newModel, value2);

					Method method3 = newModelClass.getMethod("setCreateDate",
							new Class[] { Date.class });

					Date value3 = oldCplModel.getCreateDate();

					method3.invoke(newModel, value3);

					Method method4 = newModelClass.getMethod("setModifiedDate",
							new Class[] { Date.class });

					Date value4 = oldCplModel.getModifiedDate();

					method4.invoke(newModel, value4);

					Method method5 = newModelClass.getMethod("setType",
							new Class[] { String.class });

					String value5 = oldCplModel.getType();

					method5.invoke(newModel, value5);

					Method method6 = newModelClass.getMethod("setMessageAddress",
							new Class[] { String.class });

					String value6 = oldCplModel.getMessageAddress();

					method6.invoke(newModel, value6);

					Method method7 = newModelClass.getMethod("setInboxFolderId",
							new Class[] { Long.TYPE });

					Long value7 = new Long(oldCplModel.getInboxFolderId());

					method7.invoke(newModel, value7);

					Method method8 = newModelClass.getMethod("setDraftFolderId",
							new Class[] { Long.TYPE });

					Long value8 = new Long(oldCplModel.getDraftFolderId());

					method8.invoke(newModel, value8);

					Method method9 = newModelClass.getMethod("setSentFolderId",
							new Class[] { Long.TYPE });

					Long value9 = new Long(oldCplModel.getSentFolderId());

					method9.invoke(newModel, value9);

					Method method10 = newModelClass.getMethod("setTrashFolderId",
							new Class[] { Long.TYPE });

					Long value10 = new Long(oldCplModel.getTrashFolderId());

					method10.invoke(newModel, value10);

					Method method11 = newModelClass.getMethod("setUsername",
							new Class[] { String.class });

					String value11 = oldCplModel.getUsername();

					method11.invoke(newModel, value11);

					Method method12 = newModelClass.getMethod("setSenderName",
							new Class[] { String.class });

					String value12 = oldCplModel.getSenderName();

					method12.invoke(newModel, value12);

					Method method13 = newModelClass.getMethod("setPassword",
							new Class[] { String.class });

					String value13 = oldCplModel.getPassword();

					method13.invoke(newModel, value13);

					Method method14 = newModelClass.getMethod("setPasswordSaved",
							new Class[] { Boolean.TYPE });

					Boolean value14 = new Boolean(oldCplModel.getPasswordSaved());

					method14.invoke(newModel, value14);

					Method method15 = newModelClass.getMethod("setInitialized",
							new Class[] { Boolean.TYPE });

					Boolean value15 = new Boolean(oldCplModel.getInitialized());

					method15.invoke(newModel, value15);

					Method method16 = newModelClass.getMethod("setSignature",
							new Class[] { String.class });

					String value16 = oldCplModel.getSignature();

					method16.invoke(newModel, value16);

					Method method17 = newModelClass.getMethod("setUseSignature",
							new Class[] { Boolean.TYPE });

					Boolean value17 = new Boolean(oldCplModel.getUseSignature());

					method17.invoke(newModel, value17);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(AccountSettingClp.class.getName())) {
			AccountSettingClp oldCplModel = (AccountSettingClp)oldModel;

			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					Class<?> newModelClass = Class.forName("com.liferay.mail.model.impl.AccountSettingImpl",
							true, _classLoader);

					Object newModel = newModelClass.newInstance();

					Method method0 = newModelClass.getMethod("setAccountSettingId",
							new Class[] { Long.TYPE });

					Long value0 = new Long(oldCplModel.getAccountSettingId());

					method0.invoke(newModel, value0);

					Method method1 = newModelClass.getMethod("setCompanyId",
							new Class[] { Long.TYPE });

					Long value1 = new Long(oldCplModel.getCompanyId());

					method1.invoke(newModel, value1);

					Method method2 = newModelClass.getMethod("setCreateDate",
							new Class[] { Date.class });

					Date value2 = oldCplModel.getCreateDate();

					method2.invoke(newModel, value2);

					Method method3 = newModelClass.getMethod("setModifiedDate",
							new Class[] { Date.class });

					Date value3 = oldCplModel.getModifiedDate();

					method3.invoke(newModel, value3);

					Method method4 = newModelClass.getMethod("setAccountEntryId",
							new Class[] { Long.TYPE });

					Long value4 = new Long(oldCplModel.getAccountEntryId());

					method4.invoke(newModel, value4);

					Method method5 = newModelClass.getMethod("setType",
							new Class[] { String.class });

					String value5 = oldCplModel.getType();

					method5.invoke(newModel, value5);

					Method method6 = newModelClass.getMethod("setMailInHostName",
							new Class[] { String.class });

					String value6 = oldCplModel.getMailInHostName();

					method6.invoke(newModel, value6);

					Method method7 = newModelClass.getMethod("setMailInPort",
							new Class[] { Integer.TYPE });

					Integer value7 = new Integer(oldCplModel.getMailInPort());

					method7.invoke(newModel, value7);

					Method method8 = newModelClass.getMethod("setMailInSecure",
							new Class[] { Boolean.TYPE });

					Boolean value8 = new Boolean(oldCplModel.getMailInSecure());

					method8.invoke(newModel, value8);

					Method method9 = newModelClass.getMethod("setMailOutHostName",
							new Class[] { String.class });

					String value9 = oldCplModel.getMailOutHostName();

					method9.invoke(newModel, value9);

					Method method10 = newModelClass.getMethod("setMailOutPort",
							new Class[] { Integer.TYPE });

					Integer value10 = new Integer(oldCplModel.getMailOutPort());

					method10.invoke(newModel, value10);

					Method method11 = newModelClass.getMethod("setMailOutSecure",
							new Class[] { Boolean.TYPE });

					Boolean value11 = new Boolean(oldCplModel.getMailOutSecure());

					method11.invoke(newModel, value11);

					Method method12 = newModelClass.getMethod("setDefaultFolderPrefix",
							new Class[] { String.class });

					String value12 = oldCplModel.getDefaultFolderPrefix();

					method12.invoke(newModel, value12);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(AttachmentClp.class.getName())) {
			AttachmentClp oldCplModel = (AttachmentClp)oldModel;

			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					Class<?> newModelClass = Class.forName("com.liferay.mail.model.impl.AttachmentImpl",
							true, _classLoader);

					Object newModel = newModelClass.newInstance();

					Method method0 = newModelClass.getMethod("setAttachmentId",
							new Class[] { Long.TYPE });

					Long value0 = new Long(oldCplModel.getAttachmentId());

					method0.invoke(newModel, value0);

					Method method1 = newModelClass.getMethod("setMessageId",
							new Class[] { Long.TYPE });

					Long value1 = new Long(oldCplModel.getMessageId());

					method1.invoke(newModel, value1);

					Method method2 = newModelClass.getMethod("setFilename",
							new Class[] { String.class });

					String value2 = oldCplModel.getFilename();

					method2.invoke(newModel, value2);

					Method method3 = newModelClass.getMethod("setSize",
							new Class[] { Long.TYPE });

					Long value3 = new Long(oldCplModel.getSize());

					method3.invoke(newModel, value3);

					Method method4 = newModelClass.getMethod("setContentPath",
							new Class[] { String.class });

					String value4 = oldCplModel.getContentPath();

					method4.invoke(newModel, value4);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(ContactClp.class.getName())) {
			ContactClp oldCplModel = (ContactClp)oldModel;

			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					Class<?> newModelClass = Class.forName("com.liferay.mail.model.impl.ContactImpl",
							true, _classLoader);

					Object newModel = newModelClass.newInstance();

					Method method0 = newModelClass.getMethod("setContactId",
							new Class[] { Long.TYPE });

					Long value0 = new Long(oldCplModel.getContactId());

					method0.invoke(newModel, value0);

					Method method1 = newModelClass.getMethod("setCompanyId",
							new Class[] { Long.TYPE });

					Long value1 = new Long(oldCplModel.getCompanyId());

					method1.invoke(newModel, value1);

					Method method2 = newModelClass.getMethod("setUserId",
							new Class[] { Long.TYPE });

					Long value2 = new Long(oldCplModel.getUserId());

					method2.invoke(newModel, value2);

					Method method3 = newModelClass.getMethod("setName",
							new Class[] { String.class });

					String value3 = oldCplModel.getName();

					method3.invoke(newModel, value3);

					Method method4 = newModelClass.getMethod("setMessageAddress",
							new Class[] { String.class });

					String value4 = oldCplModel.getMessageAddress();

					method4.invoke(newModel, value4);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(FolderClp.class.getName())) {
			FolderClp oldCplModel = (FolderClp)oldModel;

			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					Class<?> newModelClass = Class.forName("com.liferay.mail.model.impl.FolderImpl",
							true, _classLoader);

					Object newModel = newModelClass.newInstance();

					Method method0 = newModelClass.getMethod("setFolderId",
							new Class[] { Long.TYPE });

					Long value0 = new Long(oldCplModel.getFolderId());

					method0.invoke(newModel, value0);

					Method method1 = newModelClass.getMethod("setCompanyId",
							new Class[] { Long.TYPE });

					Long value1 = new Long(oldCplModel.getCompanyId());

					method1.invoke(newModel, value1);

					Method method2 = newModelClass.getMethod("setCreateDate",
							new Class[] { Date.class });

					Date value2 = oldCplModel.getCreateDate();

					method2.invoke(newModel, value2);

					Method method3 = newModelClass.getMethod("setModifiedDate",
							new Class[] { Date.class });

					Date value3 = oldCplModel.getModifiedDate();

					method3.invoke(newModel, value3);

					Method method4 = newModelClass.getMethod("setAccountEntryId",
							new Class[] { Long.TYPE });

					Long value4 = new Long(oldCplModel.getAccountEntryId());

					method4.invoke(newModel, value4);

					Method method5 = newModelClass.getMethod("setFullName",
							new Class[] { String.class });

					String value5 = oldCplModel.getFullName();

					method5.invoke(newModel, value5);

					Method method6 = newModelClass.getMethod("setName",
							new Class[] { String.class });

					String value6 = oldCplModel.getName();

					method6.invoke(newModel, value6);

					Method method7 = newModelClass.getMethod("setInitialized",
							new Class[] { Boolean.TYPE });

					Boolean value7 = new Boolean(oldCplModel.getInitialized());

					method7.invoke(newModel, value7);

					Method method8 = newModelClass.getMethod("setRemoteMessageCount",
							new Class[] { Integer.TYPE });

					Integer value8 = new Integer(oldCplModel.getRemoteMessageCount());

					method8.invoke(newModel, value8);

					Method method9 = newModelClass.getMethod("setSynchronizedDate",
							new Class[] { Date.class });

					Date value9 = oldCplModel.getSynchronizedDate();

					method9.invoke(newModel, value9);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(MessageClp.class.getName())) {
			MessageClp oldCplModel = (MessageClp)oldModel;

			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					Class<?> newModelClass = Class.forName("com.liferay.mail.model.impl.MessageImpl",
							true, _classLoader);

					Object newModel = newModelClass.newInstance();

					Method method0 = newModelClass.getMethod("setMessageId",
							new Class[] { Long.TYPE });

					Long value0 = new Long(oldCplModel.getMessageId());

					method0.invoke(newModel, value0);

					Method method1 = newModelClass.getMethod("setCompanyId",
							new Class[] { Long.TYPE });

					Long value1 = new Long(oldCplModel.getCompanyId());

					method1.invoke(newModel, value1);

					Method method2 = newModelClass.getMethod("setUserId",
							new Class[] { Long.TYPE });

					Long value2 = new Long(oldCplModel.getUserId());

					method2.invoke(newModel, value2);

					Method method3 = newModelClass.getMethod("setCreateDate",
							new Class[] { Date.class });

					Date value3 = oldCplModel.getCreateDate();

					method3.invoke(newModel, value3);

					Method method4 = newModelClass.getMethod("setModifiedDate",
							new Class[] { Date.class });

					Date value4 = oldCplModel.getModifiedDate();

					method4.invoke(newModel, value4);

					Method method5 = newModelClass.getMethod("setFolderId",
							new Class[] { Long.TYPE });

					Long value5 = new Long(oldCplModel.getFolderId());

					method5.invoke(newModel, value5);

					Method method6 = newModelClass.getMethod("setSender",
							new Class[] { String.class });

					String value6 = oldCplModel.getSender();

					method6.invoke(newModel, value6);

					Method method7 = newModelClass.getMethod("setRecipientsTo",
							new Class[] { String.class });

					String value7 = oldCplModel.getRecipientsTo();

					method7.invoke(newModel, value7);

					Method method8 = newModelClass.getMethod("setRecipientsCc",
							new Class[] { String.class });

					String value8 = oldCplModel.getRecipientsCc();

					method8.invoke(newModel, value8);

					Method method9 = newModelClass.getMethod("setRecipientsBcc",
							new Class[] { String.class });

					String value9 = oldCplModel.getRecipientsBcc();

					method9.invoke(newModel, value9);

					Method method10 = newModelClass.getMethod("setSentDate",
							new Class[] { Date.class });

					Date value10 = oldCplModel.getSentDate();

					method10.invoke(newModel, value10);

					Method method11 = newModelClass.getMethod("setSubject",
							new Class[] { String.class });

					String value11 = oldCplModel.getSubject();

					method11.invoke(newModel, value11);

					Method method12 = newModelClass.getMethod("setPreview",
							new Class[] { String.class });

					String value12 = oldCplModel.getPreview();

					method12.invoke(newModel, value12);

					Method method13 = newModelClass.getMethod("setBody",
							new Class[] { String.class });

					String value13 = oldCplModel.getBody();

					method13.invoke(newModel, value13);

					Method method14 = newModelClass.getMethod("setFlags",
							new Class[] { String.class });

					String value14 = oldCplModel.getFlags();

					method14.invoke(newModel, value14);

					Method method15 = newModelClass.getMethod("setSize",
							new Class[] { Long.TYPE });

					Long value15 = new Long(oldCplModel.getSize());

					method15.invoke(newModel, value15);

					Method method16 = newModelClass.getMethod("setRemoteMessageId",
							new Class[] { Long.TYPE });

					Long value16 = new Long(oldCplModel.getRemoteMessageId());

					method16.invoke(newModel, value16);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		return oldModel;
	}

	public static Object translateInput(List<Object> oldList) {
		List<Object> newList = new ArrayList<Object>(oldList.size());

		for (int i = 0; i < oldList.size(); i++) {
			Object curObj = oldList.get(i);

			newList.add(translateInput(curObj));
		}

		return newList;
	}

	public static Object translateInput(Object obj) {
		if (obj instanceof BaseModel) {
			return translateInput((BaseModel)obj);
		}
		else if (obj instanceof List) {
			return translateInput((List<Object>)obj);
		}
		else {
			return obj;
		}
	}

	public static Object translateOutput(BaseModel oldModel) {
		Class<?> oldModelClass = oldModel.getClass();

		String oldModelClassName = oldModelClass.getName();

		if (oldModelClassName.equals(
					"com.liferay.mail.model.impl.AccountEntryImpl")) {
			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					AccountEntryClp newModel = new AccountEntryClp();

					Method method0 = oldModelClass.getMethod(
							"getAccountEntryId");

					Long value0 = (Long)method0.invoke(oldModel, (Object[])null);

					newModel.setAccountEntryId(value0.longValue());

					Method method1 = oldModelClass.getMethod("getCompanyId");

					Long value1 = (Long)method1.invoke(oldModel, (Object[])null);

					newModel.setCompanyId(value1.longValue());

					Method method2 = oldModelClass.getMethod("getUserId");

					Long value2 = (Long)method2.invoke(oldModel, (Object[])null);

					newModel.setUserId(value2.longValue());

					Method method3 = oldModelClass.getMethod("getCreateDate");

					Date value3 = (Date)method3.invoke(oldModel, (Object[])null);

					newModel.setCreateDate(value3);

					Method method4 = oldModelClass.getMethod("getModifiedDate");

					Date value4 = (Date)method4.invoke(oldModel, (Object[])null);

					newModel.setModifiedDate(value4);

					Method method5 = oldModelClass.getMethod("getType");

					String value5 = (String)method5.invoke(oldModel,
							(Object[])null);

					newModel.setType(value5);

					Method method6 = oldModelClass.getMethod(
							"getMessageAddress");

					String value6 = (String)method6.invoke(oldModel,
							(Object[])null);

					newModel.setMessageAddress(value6);

					Method method7 = oldModelClass.getMethod("getInboxFolderId");

					Long value7 = (Long)method7.invoke(oldModel, (Object[])null);

					newModel.setInboxFolderId(value7.longValue());

					Method method8 = oldModelClass.getMethod("getDraftFolderId");

					Long value8 = (Long)method8.invoke(oldModel, (Object[])null);

					newModel.setDraftFolderId(value8.longValue());

					Method method9 = oldModelClass.getMethod("getSentFolderId");

					Long value9 = (Long)method9.invoke(oldModel, (Object[])null);

					newModel.setSentFolderId(value9.longValue());

					Method method10 = oldModelClass.getMethod(
							"getTrashFolderId");

					Long value10 = (Long)method10.invoke(oldModel,
							(Object[])null);

					newModel.setTrashFolderId(value10.longValue());

					Method method11 = oldModelClass.getMethod("getUsername");

					String value11 = (String)method11.invoke(oldModel,
							(Object[])null);

					newModel.setUsername(value11);

					Method method12 = oldModelClass.getMethod("getSenderName");

					String value12 = (String)method12.invoke(oldModel,
							(Object[])null);

					newModel.setSenderName(value12);

					Method method13 = oldModelClass.getMethod("getPassword");

					String value13 = (String)method13.invoke(oldModel,
							(Object[])null);

					newModel.setPassword(value13);

					Method method14 = oldModelClass.getMethod(
							"getPasswordSaved");

					Boolean value14 = (Boolean)method14.invoke(oldModel,
							(Object[])null);

					newModel.setPasswordSaved(value14.booleanValue());

					Method method15 = oldModelClass.getMethod("getInitialized");

					Boolean value15 = (Boolean)method15.invoke(oldModel,
							(Object[])null);

					newModel.setInitialized(value15.booleanValue());

					Method method16 = oldModelClass.getMethod("getSignature");

					String value16 = (String)method16.invoke(oldModel,
							(Object[])null);

					newModel.setSignature(value16);

					Method method17 = oldModelClass.getMethod("getUseSignature");

					Boolean value17 = (Boolean)method17.invoke(oldModel,
							(Object[])null);

					newModel.setUseSignature(value17.booleanValue());

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(
					"com.liferay.mail.model.impl.AccountSettingImpl")) {
			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					AccountSettingClp newModel = new AccountSettingClp();

					Method method0 = oldModelClass.getMethod(
							"getAccountSettingId");

					Long value0 = (Long)method0.invoke(oldModel, (Object[])null);

					newModel.setAccountSettingId(value0.longValue());

					Method method1 = oldModelClass.getMethod("getCompanyId");

					Long value1 = (Long)method1.invoke(oldModel, (Object[])null);

					newModel.setCompanyId(value1.longValue());

					Method method2 = oldModelClass.getMethod("getCreateDate");

					Date value2 = (Date)method2.invoke(oldModel, (Object[])null);

					newModel.setCreateDate(value2);

					Method method3 = oldModelClass.getMethod("getModifiedDate");

					Date value3 = (Date)method3.invoke(oldModel, (Object[])null);

					newModel.setModifiedDate(value3);

					Method method4 = oldModelClass.getMethod(
							"getAccountEntryId");

					Long value4 = (Long)method4.invoke(oldModel, (Object[])null);

					newModel.setAccountEntryId(value4.longValue());

					Method method5 = oldModelClass.getMethod("getType");

					String value5 = (String)method5.invoke(oldModel,
							(Object[])null);

					newModel.setType(value5);

					Method method6 = oldModelClass.getMethod(
							"getMailInHostName");

					String value6 = (String)method6.invoke(oldModel,
							(Object[])null);

					newModel.setMailInHostName(value6);

					Method method7 = oldModelClass.getMethod("getMailInPort");

					Integer value7 = (Integer)method7.invoke(oldModel,
							(Object[])null);

					newModel.setMailInPort(value7.intValue());

					Method method8 = oldModelClass.getMethod("getMailInSecure");

					Boolean value8 = (Boolean)method8.invoke(oldModel,
							(Object[])null);

					newModel.setMailInSecure(value8.booleanValue());

					Method method9 = oldModelClass.getMethod(
							"getMailOutHostName");

					String value9 = (String)method9.invoke(oldModel,
							(Object[])null);

					newModel.setMailOutHostName(value9);

					Method method10 = oldModelClass.getMethod("getMailOutPort");

					Integer value10 = (Integer)method10.invoke(oldModel,
							(Object[])null);

					newModel.setMailOutPort(value10.intValue());

					Method method11 = oldModelClass.getMethod(
							"getMailOutSecure");

					Boolean value11 = (Boolean)method11.invoke(oldModel,
							(Object[])null);

					newModel.setMailOutSecure(value11.booleanValue());

					Method method12 = oldModelClass.getMethod(
							"getDefaultFolderPrefix");

					String value12 = (String)method12.invoke(oldModel,
							(Object[])null);

					newModel.setDefaultFolderPrefix(value12);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals(
					"com.liferay.mail.model.impl.AttachmentImpl")) {
			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					AttachmentClp newModel = new AttachmentClp();

					Method method0 = oldModelClass.getMethod("getAttachmentId");

					Long value0 = (Long)method0.invoke(oldModel, (Object[])null);

					newModel.setAttachmentId(value0.longValue());

					Method method1 = oldModelClass.getMethod("getMessageId");

					Long value1 = (Long)method1.invoke(oldModel, (Object[])null);

					newModel.setMessageId(value1.longValue());

					Method method2 = oldModelClass.getMethod("getFilename");

					String value2 = (String)method2.invoke(oldModel,
							(Object[])null);

					newModel.setFilename(value2);

					Method method3 = oldModelClass.getMethod("getSize");

					Long value3 = (Long)method3.invoke(oldModel, (Object[])null);

					newModel.setSize(value3.longValue());

					Method method4 = oldModelClass.getMethod("getContentPath");

					String value4 = (String)method4.invoke(oldModel,
							(Object[])null);

					newModel.setContentPath(value4);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals("com.liferay.mail.model.impl.ContactImpl")) {
			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					ContactClp newModel = new ContactClp();

					Method method0 = oldModelClass.getMethod("getContactId");

					Long value0 = (Long)method0.invoke(oldModel, (Object[])null);

					newModel.setContactId(value0.longValue());

					Method method1 = oldModelClass.getMethod("getCompanyId");

					Long value1 = (Long)method1.invoke(oldModel, (Object[])null);

					newModel.setCompanyId(value1.longValue());

					Method method2 = oldModelClass.getMethod("getUserId");

					Long value2 = (Long)method2.invoke(oldModel, (Object[])null);

					newModel.setUserId(value2.longValue());

					Method method3 = oldModelClass.getMethod("getName");

					String value3 = (String)method3.invoke(oldModel,
							(Object[])null);

					newModel.setName(value3);

					Method method4 = oldModelClass.getMethod(
							"getMessageAddress");

					String value4 = (String)method4.invoke(oldModel,
							(Object[])null);

					newModel.setMessageAddress(value4);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals("com.liferay.mail.model.impl.FolderImpl")) {
			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					FolderClp newModel = new FolderClp();

					Method method0 = oldModelClass.getMethod("getFolderId");

					Long value0 = (Long)method0.invoke(oldModel, (Object[])null);

					newModel.setFolderId(value0.longValue());

					Method method1 = oldModelClass.getMethod("getCompanyId");

					Long value1 = (Long)method1.invoke(oldModel, (Object[])null);

					newModel.setCompanyId(value1.longValue());

					Method method2 = oldModelClass.getMethod("getCreateDate");

					Date value2 = (Date)method2.invoke(oldModel, (Object[])null);

					newModel.setCreateDate(value2);

					Method method3 = oldModelClass.getMethod("getModifiedDate");

					Date value3 = (Date)method3.invoke(oldModel, (Object[])null);

					newModel.setModifiedDate(value3);

					Method method4 = oldModelClass.getMethod(
							"getAccountEntryId");

					Long value4 = (Long)method4.invoke(oldModel, (Object[])null);

					newModel.setAccountEntryId(value4.longValue());

					Method method5 = oldModelClass.getMethod("getFullName");

					String value5 = (String)method5.invoke(oldModel,
							(Object[])null);

					newModel.setFullName(value5);

					Method method6 = oldModelClass.getMethod("getName");

					String value6 = (String)method6.invoke(oldModel,
							(Object[])null);

					newModel.setName(value6);

					Method method7 = oldModelClass.getMethod("getInitialized");

					Boolean value7 = (Boolean)method7.invoke(oldModel,
							(Object[])null);

					newModel.setInitialized(value7.booleanValue());

					Method method8 = oldModelClass.getMethod(
							"getRemoteMessageCount");

					Integer value8 = (Integer)method8.invoke(oldModel,
							(Object[])null);

					newModel.setRemoteMessageCount(value8.intValue());

					Method method9 = oldModelClass.getMethod(
							"getSynchronizedDate");

					Date value9 = (Date)method9.invoke(oldModel, (Object[])null);

					newModel.setSynchronizedDate(value9);

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		if (oldModelClassName.equals("com.liferay.mail.model.impl.MessageImpl")) {
			ClassLoader contextClassLoader = Thread.currentThread()
												   .getContextClassLoader();

			try {
				Thread.currentThread().setContextClassLoader(_classLoader);

				try {
					MessageClp newModel = new MessageClp();

					Method method0 = oldModelClass.getMethod("getMessageId");

					Long value0 = (Long)method0.invoke(oldModel, (Object[])null);

					newModel.setMessageId(value0.longValue());

					Method method1 = oldModelClass.getMethod("getCompanyId");

					Long value1 = (Long)method1.invoke(oldModel, (Object[])null);

					newModel.setCompanyId(value1.longValue());

					Method method2 = oldModelClass.getMethod("getUserId");

					Long value2 = (Long)method2.invoke(oldModel, (Object[])null);

					newModel.setUserId(value2.longValue());

					Method method3 = oldModelClass.getMethod("getCreateDate");

					Date value3 = (Date)method3.invoke(oldModel, (Object[])null);

					newModel.setCreateDate(value3);

					Method method4 = oldModelClass.getMethod("getModifiedDate");

					Date value4 = (Date)method4.invoke(oldModel, (Object[])null);

					newModel.setModifiedDate(value4);

					Method method5 = oldModelClass.getMethod("getFolderId");

					Long value5 = (Long)method5.invoke(oldModel, (Object[])null);

					newModel.setFolderId(value5.longValue());

					Method method6 = oldModelClass.getMethod("getSender");

					String value6 = (String)method6.invoke(oldModel,
							(Object[])null);

					newModel.setSender(value6);

					Method method7 = oldModelClass.getMethod("getRecipientsTo");

					String value7 = (String)method7.invoke(oldModel,
							(Object[])null);

					newModel.setRecipientsTo(value7);

					Method method8 = oldModelClass.getMethod("getRecipientsCc");

					String value8 = (String)method8.invoke(oldModel,
							(Object[])null);

					newModel.setRecipientsCc(value8);

					Method method9 = oldModelClass.getMethod("getRecipientsBcc");

					String value9 = (String)method9.invoke(oldModel,
							(Object[])null);

					newModel.setRecipientsBcc(value9);

					Method method10 = oldModelClass.getMethod("getSentDate");

					Date value10 = (Date)method10.invoke(oldModel,
							(Object[])null);

					newModel.setSentDate(value10);

					Method method11 = oldModelClass.getMethod("getSubject");

					String value11 = (String)method11.invoke(oldModel,
							(Object[])null);

					newModel.setSubject(value11);

					Method method12 = oldModelClass.getMethod("getPreview");

					String value12 = (String)method12.invoke(oldModel,
							(Object[])null);

					newModel.setPreview(value12);

					Method method13 = oldModelClass.getMethod("getBody");

					String value13 = (String)method13.invoke(oldModel,
							(Object[])null);

					newModel.setBody(value13);

					Method method14 = oldModelClass.getMethod("getFlags");

					String value14 = (String)method14.invoke(oldModel,
							(Object[])null);

					newModel.setFlags(value14);

					Method method15 = oldModelClass.getMethod("getSize");

					Long value15 = (Long)method15.invoke(oldModel,
							(Object[])null);

					newModel.setSize(value15.longValue());

					Method method16 = oldModelClass.getMethod(
							"getRemoteMessageId");

					Long value16 = (Long)method16.invoke(oldModel,
							(Object[])null);

					newModel.setRemoteMessageId(value16.longValue());

					return newModel;
				}
				catch (Exception e) {
					_log.error(e, e);
				}
			}
			finally {
				Thread.currentThread().setContextClassLoader(contextClassLoader);
			}
		}

		return oldModel;
	}

	public static Object translateOutput(List<Object> oldList) {
		List<Object> newList = new ArrayList<Object>(oldList.size());

		for (int i = 0; i < oldList.size(); i++) {
			Object curObj = oldList.get(i);

			newList.add(translateOutput(curObj));
		}

		return newList;
	}

	public static Object translateOutput(Object obj) {
		if (obj instanceof BaseModel) {
			return translateOutput((BaseModel)obj);
		}
		else if (obj instanceof List) {
			return translateOutput((List<Object>)obj);
		}
		else {
			return obj;
		}
	}

	private static Log _log = LogFactoryUtil.getLog(ClpSerializer.class);
	private static ClassLoader _classLoader;
}