/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ClassLoaderProxy;

/**
 * <a href="ContactLocalServiceUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class ContactLocalServiceUtil {
	public static com.liferay.mail.model.Contact addContact(
		com.liferay.mail.model.Contact contact)
		throws com.liferay.portal.SystemException {
		return getService().addContact(contact);
	}

	public static com.liferay.mail.model.Contact createContact(long contactId) {
		return getService().createContact(contactId);
	}

	public static void deleteContact(long contactId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().deleteContact(contactId);
	}

	public static void deleteContact(com.liferay.mail.model.Contact contact)
		throws com.liferay.portal.SystemException {
		getService().deleteContact(contact);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	public static com.liferay.mail.model.Contact getContact(long contactId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getContact(contactId);
	}

	public static java.util.List<com.liferay.mail.model.Contact> getContacts(
		int start, int end) throws com.liferay.portal.SystemException {
		return getService().getContacts(start, end);
	}

	public static int getContactsCount()
		throws com.liferay.portal.SystemException {
		return getService().getContactsCount();
	}

	public static com.liferay.mail.model.Contact updateContact(
		com.liferay.mail.model.Contact contact)
		throws com.liferay.portal.SystemException {
		return getService().updateContact(contact);
	}

	public static com.liferay.mail.model.Contact updateContact(
		com.liferay.mail.model.Contact contact, boolean merge)
		throws com.liferay.portal.SystemException {
		return getService().updateContact(contact, merge);
	}

	public static com.liferay.mail.model.Contact addContact(long userId,
		java.lang.String name, java.lang.String messageAddress)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().addContact(userId, name, messageAddress);
	}

	public static java.util.List<com.liferay.mail.model.Contact> getUserContacts(
		long userId) throws com.liferay.portal.SystemException {
		return getService().getUserContacts(userId);
	}

	public static com.liferay.mail.model.Contact getUserContact(long userId,
		java.lang.String messageAddress)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getUserContact(userId, messageAddress);
	}

	public static com.liferay.mail.model.Contact updateContact(long contactId,
		java.lang.String name, java.lang.String messageAddress)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().updateContact(contactId, name, messageAddress);
	}

	public static void clearService() {
		_service = null;
	}

	public static ContactLocalService getService() {
		if (_service == null) {
			Object obj = PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					ContactLocalServiceUtil.class.getName());
			ClassLoader portletClassLoader = (ClassLoader)PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					"portletClassLoader");

			ClassLoaderProxy classLoaderProxy = new ClassLoaderProxy(obj,
					portletClassLoader);

			_service = new ContactLocalServiceClp(classLoaderProxy);

			ClpSerializer.setClassLoader(portletClassLoader);
		}

		return _service;
	}

	public void setService(ContactLocalService service) {
		_service = service;
	}

	private static ContactLocalService _service;
}