/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ClassLoaderProxy;

/**
 * <a href="MessageLocalServiceUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class MessageLocalServiceUtil {
	public static com.liferay.mail.model.Message addMessage(
		com.liferay.mail.model.Message message)
		throws com.liferay.portal.SystemException {
		return getService().addMessage(message);
	}

	public static com.liferay.mail.model.Message createMessage(long messageId) {
		return getService().createMessage(messageId);
	}

	public static void deleteMessage(long messageId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().deleteMessage(messageId);
	}

	public static void deleteMessage(com.liferay.mail.model.Message message)
		throws com.liferay.portal.SystemException {
		getService().deleteMessage(message);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	public static com.liferay.mail.model.Message getMessage(long messageId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getMessage(messageId);
	}

	public static java.util.List<com.liferay.mail.model.Message> getMessages(
		int start, int end) throws com.liferay.portal.SystemException {
		return getService().getMessages(start, end);
	}

	public static int getMessagesCount()
		throws com.liferay.portal.SystemException {
		return getService().getMessagesCount();
	}

	public static com.liferay.mail.model.Message updateMessage(
		com.liferay.mail.model.Message message)
		throws com.liferay.portal.SystemException {
		return getService().updateMessage(message);
	}

	public static com.liferay.mail.model.Message updateMessage(
		com.liferay.mail.model.Message message, boolean merge)
		throws com.liferay.portal.SystemException {
		return getService().updateMessage(message, merge);
	}

	public static com.liferay.mail.model.Message addMessage(long userId,
		long folderId, java.lang.String sender, java.lang.String recipientsTo,
		java.lang.String recipientsCc, java.lang.String recipientsBcc,
		java.util.Date sentDate, java.lang.String subject,
		java.lang.String body, java.lang.String flags, long size,
		long remoteMessageId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .addMessage(userId, folderId, sender, recipientsTo,
			recipientsCc, recipientsBcc, sentDate, subject, body, flags, size,
			remoteMessageId);
	}

	public static com.liferay.mail.model.Message getFolderMessage(
		long folderId, long remoteMessageId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().getFolderMessage(folderId, remoteMessageId);
	}

	public static int getFolderMessageCount(long folderId)
		throws com.liferay.portal.SystemException {
		return getService().getFolderMessageCount(folderId);
	}

	public static java.util.List<com.liferay.mail.model.Message> getFolderMessages(
		long folderId) throws com.liferay.portal.SystemException {
		return getService().getFolderMessages(folderId);
	}

	public static java.util.List<com.liferay.mail.model.Message> getFolderMessages(
		long folderId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getService().getFolderMessages(folderId, start, end, obc);
	}

	public static long getFolderNewMessageCount(long folderId)
		throws com.liferay.portal.SystemException {
		return getService().getFolderNewMessageCount(folderId);
	}

	public static long getAccountEntryNewMessageCount(long accountEntryId)
		throws com.liferay.portal.SystemException {
		return getService().getAccountEntryNewMessageCount(accountEntryId);
	}

	public static void moveMessage(long messageId, long destinationFolderId,
		boolean updateSentDate)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().moveMessage(messageId, destinationFolderId, updateSentDate);
	}

	public static com.liferay.mail.model.Message updateMessage(long messageId,
		long folderId, java.lang.String sender, java.lang.String recipientsTo,
		java.lang.String recipientsCc, java.lang.String recipientsBcc,
		java.util.Date sentDate, java.lang.String subject,
		java.lang.String body, java.lang.String flags, long size,
		long remoteMessageId)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService()
				   .updateMessage(messageId, folderId, sender, recipientsTo,
			recipientsCc, recipientsBcc, sentDate, subject, body, flags, size,
			remoteMessageId);
	}

	public static void updateFlag(long messageId, int flag, boolean value)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		getService().updateFlag(messageId, flag, value);
	}

	public static com.liferay.mail.model.Message updateSize(long messageId,
		long size)
		throws com.liferay.portal.PortalException,
			com.liferay.portal.SystemException {
		return getService().updateSize(messageId, size);
	}

	public static void clearService() {
		_service = null;
	}

	public static MessageLocalService getService() {
		if (_service == null) {
			Object obj = PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					MessageLocalServiceUtil.class.getName());
			ClassLoader portletClassLoader = (ClassLoader)PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					"portletClassLoader");

			ClassLoaderProxy classLoaderProxy = new ClassLoaderProxy(obj,
					portletClassLoader);

			_service = new MessageLocalServiceClp(classLoaderProxy);

			ClpSerializer.setClassLoader(portletClassLoader);
		}

		return _service;
	}

	public void setService(MessageLocalService service) {
		_service = service;
	}

	private static MessageLocalService _service;
}