/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

/**
 * <a href="AccountEntryUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class AccountEntryUtil {
	public static void cacheResult(
		com.liferay.mail.model.AccountEntry accountEntry) {
		getPersistence().cacheResult(accountEntry);
	}

	public static void cacheResult(
		java.util.List<com.liferay.mail.model.AccountEntry> accountEntries) {
		getPersistence().cacheResult(accountEntries);
	}

	public static void clearCache() {
		getPersistence().clearCache();
	}

	public static com.liferay.mail.model.AccountEntry create(
		long accountEntryId) {
		return getPersistence().create(accountEntryId);
	}

	public static com.liferay.mail.model.AccountEntry remove(
		long accountEntryId)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().remove(accountEntryId);
	}

	public static com.liferay.mail.model.AccountEntry remove(
		com.liferay.mail.model.AccountEntry accountEntry)
		throws com.liferay.portal.SystemException {
		return getPersistence().remove(accountEntry);
	}

	public static com.liferay.mail.model.AccountEntry update(
		com.liferay.mail.model.AccountEntry accountEntry)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(accountEntry);
	}

	public static com.liferay.mail.model.AccountEntry update(
		com.liferay.mail.model.AccountEntry accountEntry, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(accountEntry, merge);
	}

	public static com.liferay.mail.model.AccountEntry updateImpl(
		com.liferay.mail.model.AccountEntry accountEntry, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().updateImpl(accountEntry, merge);
	}

	public static com.liferay.mail.model.AccountEntry findByPrimaryKey(
		long accountEntryId)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByPrimaryKey(accountEntryId);
	}

	public static com.liferay.mail.model.AccountEntry fetchByPrimaryKey(
		long accountEntryId) throws com.liferay.portal.SystemException {
		return getPersistence().fetchByPrimaryKey(accountEntryId);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByCompanyId(
		long companyId) throws com.liferay.portal.SystemException {
		return getPersistence().findByCompanyId(companyId);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByCompanyId(
		long companyId, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByCompanyId(companyId, start, end);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByCompanyId(
		long companyId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByCompanyId(companyId, start, end, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByCompanyId_First(
		long companyId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByCompanyId_First(companyId, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByCompanyId_Last(
		long companyId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByCompanyId_Last(companyId, obc);
	}

	public static com.liferay.mail.model.AccountEntry[] findByCompanyId_PrevAndNext(
		long accountEntryId, long companyId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByCompanyId_PrevAndNext(accountEntryId, companyId, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByC_T_M(
		long companyId, java.lang.String type, java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByC_T_M(companyId, type, messageAddress);
	}

	public static com.liferay.mail.model.AccountEntry fetchByC_T_M(
		long companyId, java.lang.String type, java.lang.String messageAddress)
		throws com.liferay.portal.SystemException {
		return getPersistence().fetchByC_T_M(companyId, type, messageAddress);
	}

	public static com.liferay.mail.model.AccountEntry fetchByC_T_M(
		long companyId, java.lang.String type, java.lang.String messageAddress,
		boolean retrieveFromCache) throws com.liferay.portal.SystemException {
		return getPersistence()
				   .fetchByC_T_M(companyId, type, messageAddress,
			retrieveFromCache);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByUserId(
		long userId) throws com.liferay.portal.SystemException {
		return getPersistence().findByUserId(userId);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByUserId(
		long userId, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByUserId(userId, start, end);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByUserId(
		long userId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByUserId(userId, start, end, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByUserId_First(
		long userId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByUserId_First(userId, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByUserId_Last(
		long userId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByUserId_Last(userId, obc);
	}

	public static com.liferay.mail.model.AccountEntry[] findByUserId_PrevAndNext(
		long accountEntryId, long userId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByUserId_PrevAndNext(accountEntryId, userId, obc);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByU_T(
		long userId, java.lang.String type)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByU_T(userId, type);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByU_T(
		long userId, java.lang.String type, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByU_T(userId, type, start, end);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByU_T(
		long userId, java.lang.String type, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByU_T(userId, type, start, end, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByU_T_First(
		long userId, java.lang.String type,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByU_T_First(userId, type, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByU_T_Last(
		long userId, java.lang.String type,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByU_T_Last(userId, type, obc);
	}

	public static com.liferay.mail.model.AccountEntry[] findByU_T_PrevAndNext(
		long accountEntryId, long userId, java.lang.String type,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByU_T_PrevAndNext(accountEntryId, userId, type, obc);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByU_T_I(
		long userId, java.lang.String type, boolean initialized)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByU_T_I(userId, type, initialized);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByU_T_I(
		long userId, java.lang.String type, boolean initialized, int start,
		int end) throws com.liferay.portal.SystemException {
		return getPersistence()
				   .findByU_T_I(userId, type, initialized, start, end);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findByU_T_I(
		long userId, java.lang.String type, boolean initialized, int start,
		int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence()
				   .findByU_T_I(userId, type, initialized, start, end, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByU_T_I_First(
		long userId, java.lang.String type, boolean initialized,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByU_T_I_First(userId, type, initialized, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByU_T_I_Last(
		long userId, java.lang.String type, boolean initialized,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByU_T_I_Last(userId, type, initialized, obc);
	}

	public static com.liferay.mail.model.AccountEntry[] findByU_T_I_PrevAndNext(
		long accountEntryId, long userId, java.lang.String type,
		boolean initialized,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByU_T_I_PrevAndNext(accountEntryId, userId, type,
			initialized, obc);
	}

	public static com.liferay.mail.model.AccountEntry findByU_T_M(long userId,
		java.lang.String type, java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		return getPersistence().findByU_T_M(userId, type, messageAddress);
	}

	public static com.liferay.mail.model.AccountEntry fetchByU_T_M(
		long userId, java.lang.String type, java.lang.String messageAddress)
		throws com.liferay.portal.SystemException {
		return getPersistence().fetchByU_T_M(userId, type, messageAddress);
	}

	public static com.liferay.mail.model.AccountEntry fetchByU_T_M(
		long userId, java.lang.String type, java.lang.String messageAddress,
		boolean retrieveFromCache) throws com.liferay.portal.SystemException {
		return getPersistence()
				   .fetchByU_T_M(userId, type, messageAddress, retrieveFromCache);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findAll()
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll();
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findAll(
		int start, int end) throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end);
	}

	public static java.util.List<com.liferay.mail.model.AccountEntry> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end, obc);
	}

	public static void removeByCompanyId(long companyId)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByCompanyId(companyId);
	}

	public static void removeByC_T_M(long companyId, java.lang.String type,
		java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		getPersistence().removeByC_T_M(companyId, type, messageAddress);
	}

	public static void removeByUserId(long userId)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByUserId(userId);
	}

	public static void removeByU_T(long userId, java.lang.String type)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByU_T(userId, type);
	}

	public static void removeByU_T_I(long userId, java.lang.String type,
		boolean initialized) throws com.liferay.portal.SystemException {
		getPersistence().removeByU_T_I(userId, type, initialized);
	}

	public static void removeByU_T_M(long userId, java.lang.String type,
		java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchAccountEntryException,
			com.liferay.portal.SystemException {
		getPersistence().removeByU_T_M(userId, type, messageAddress);
	}

	public static void removeAll() throws com.liferay.portal.SystemException {
		getPersistence().removeAll();
	}

	public static int countByCompanyId(long companyId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByCompanyId(companyId);
	}

	public static int countByC_T_M(long companyId, java.lang.String type,
		java.lang.String messageAddress)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByC_T_M(companyId, type, messageAddress);
	}

	public static int countByUserId(long userId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByUserId(userId);
	}

	public static int countByU_T(long userId, java.lang.String type)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByU_T(userId, type);
	}

	public static int countByU_T_I(long userId, java.lang.String type,
		boolean initialized) throws com.liferay.portal.SystemException {
		return getPersistence().countByU_T_I(userId, type, initialized);
	}

	public static int countByU_T_M(long userId, java.lang.String type,
		java.lang.String messageAddress)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByU_T_M(userId, type, messageAddress);
	}

	public static int countAll() throws com.liferay.portal.SystemException {
		return getPersistence().countAll();
	}

	public static AccountEntryPersistence getPersistence() {
		return _persistence;
	}

	public void setPersistence(AccountEntryPersistence persistence) {
		_persistence = persistence;
	}

	private static AccountEntryPersistence _persistence;
}