/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

import com.liferay.portal.service.persistence.BasePersistence;

/**
 * <a href="AccountSettingPersistence.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public interface AccountSettingPersistence extends BasePersistence {
	public void cacheResult(
		com.liferay.mail.model.AccountSetting accountSetting);

	public void cacheResult(
		java.util.List<com.liferay.mail.model.AccountSetting> accountSettings);

	public void clearCache();

	public com.liferay.mail.model.AccountSetting create(long accountSettingId);

	public com.liferay.mail.model.AccountSetting remove(long accountSettingId)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting remove(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting update(
		com.liferay.mail.model.AccountSetting accountSetting)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting update(
		com.liferay.mail.model.AccountSetting accountSetting, boolean merge)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting updateImpl(
		com.liferay.mail.model.AccountSetting accountSetting, boolean merge)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting findByPrimaryKey(
		long accountSettingId)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting fetchByPrimaryKey(
		long accountSettingId) throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting findByAccountEntryId(
		long accountEntryId)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting fetchByAccountEntryId(
		long accountEntryId) throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting fetchByAccountEntryId(
		long accountEntryId, boolean retrieveFromCache)
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findByCompanyId(
		long companyId) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findByCompanyId(
		long companyId, int start, int end)
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findByCompanyId(
		long companyId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting findByCompanyId_First(
		long companyId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting findByCompanyId_Last(
		long companyId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting[] findByCompanyId_PrevAndNext(
		long accountSettingId, long companyId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findByC_T(
		long companyId, java.lang.String type)
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findByC_T(
		long companyId, java.lang.String type, int start, int end)
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findByC_T(
		long companyId, java.lang.String type, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting findByC_T_First(
		long companyId, java.lang.String type,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting findByC_T_Last(
		long companyId, java.lang.String type,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.AccountSetting[] findByC_T_PrevAndNext(
		long accountSettingId, long companyId, java.lang.String type,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException;

	public java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findAll()
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findAll(
		int start, int end) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.AccountSetting> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException;

	public void removeByAccountEntryId(long accountEntryId)
		throws com.liferay.mail.NoSuchAccountSettingException,
			com.liferay.portal.SystemException;

	public void removeByCompanyId(long companyId)
		throws com.liferay.portal.SystemException;

	public void removeByC_T(long companyId, java.lang.String type)
		throws com.liferay.portal.SystemException;

	public void removeAll() throws com.liferay.portal.SystemException;

	public int countByAccountEntryId(long accountEntryId)
		throws com.liferay.portal.SystemException;

	public int countByCompanyId(long companyId)
		throws com.liferay.portal.SystemException;

	public int countByC_T(long companyId, java.lang.String type)
		throws com.liferay.portal.SystemException;

	public int countAll() throws com.liferay.portal.SystemException;
}