/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

import com.liferay.portal.service.persistence.BasePersistence;

/**
 * <a href="AttachmentPersistence.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public interface AttachmentPersistence extends BasePersistence {
	public void cacheResult(com.liferay.mail.model.Attachment attachment);

	public void cacheResult(
		java.util.List<com.liferay.mail.model.Attachment> attachments);

	public void clearCache();

	public com.liferay.mail.model.Attachment create(long attachmentId);

	public com.liferay.mail.model.Attachment remove(long attachmentId)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment remove(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment update(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment update(
		com.liferay.mail.model.Attachment attachment, boolean merge)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment updateImpl(
		com.liferay.mail.model.Attachment attachment, boolean merge)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment findByPrimaryKey(long attachmentId)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment fetchByPrimaryKey(
		long attachmentId) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.Attachment> findByMessageId(
		long messageId) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.Attachment> findByMessageId(
		long messageId, int start, int end)
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.Attachment> findByMessageId(
		long messageId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment findByMessageId_First(
		long messageId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment findByMessageId_Last(
		long messageId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException;

	public com.liferay.mail.model.Attachment[] findByMessageId_PrevAndNext(
		long attachmentId, long messageId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException;

	public java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException;

	public java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.Attachment> findAll()
		throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.Attachment> findAll(
		int start, int end) throws com.liferay.portal.SystemException;

	public java.util.List<com.liferay.mail.model.Attachment> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException;

	public void removeByMessageId(long messageId)
		throws com.liferay.portal.SystemException;

	public void removeAll() throws com.liferay.portal.SystemException;

	public int countByMessageId(long messageId)
		throws com.liferay.portal.SystemException;

	public int countAll() throws com.liferay.portal.SystemException;
}