/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

/**
 * <a href="AttachmentUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class AttachmentUtil {
	public static void cacheResult(com.liferay.mail.model.Attachment attachment) {
		getPersistence().cacheResult(attachment);
	}

	public static void cacheResult(
		java.util.List<com.liferay.mail.model.Attachment> attachments) {
		getPersistence().cacheResult(attachments);
	}

	public static void clearCache() {
		getPersistence().clearCache();
	}

	public static com.liferay.mail.model.Attachment create(long attachmentId) {
		return getPersistence().create(attachmentId);
	}

	public static com.liferay.mail.model.Attachment remove(long attachmentId)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException {
		return getPersistence().remove(attachmentId);
	}

	public static com.liferay.mail.model.Attachment remove(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException {
		return getPersistence().remove(attachment);
	}

	public static com.liferay.mail.model.Attachment update(
		com.liferay.mail.model.Attachment attachment)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(attachment);
	}

	public static com.liferay.mail.model.Attachment update(
		com.liferay.mail.model.Attachment attachment, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(attachment, merge);
	}

	public static com.liferay.mail.model.Attachment updateImpl(
		com.liferay.mail.model.Attachment attachment, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().updateImpl(attachment, merge);
	}

	public static com.liferay.mail.model.Attachment findByPrimaryKey(
		long attachmentId)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException {
		return getPersistence().findByPrimaryKey(attachmentId);
	}

	public static com.liferay.mail.model.Attachment fetchByPrimaryKey(
		long attachmentId) throws com.liferay.portal.SystemException {
		return getPersistence().fetchByPrimaryKey(attachmentId);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> findByMessageId(
		long messageId) throws com.liferay.portal.SystemException {
		return getPersistence().findByMessageId(messageId);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> findByMessageId(
		long messageId, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByMessageId(messageId, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> findByMessageId(
		long messageId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByMessageId(messageId, start, end, obc);
	}

	public static com.liferay.mail.model.Attachment findByMessageId_First(
		long messageId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException {
		return getPersistence().findByMessageId_First(messageId, obc);
	}

	public static com.liferay.mail.model.Attachment findByMessageId_Last(
		long messageId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException {
		return getPersistence().findByMessageId_Last(messageId, obc);
	}

	public static com.liferay.mail.model.Attachment[] findByMessageId_PrevAndNext(
		long attachmentId, long messageId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchAttachmentException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByMessageId_PrevAndNext(attachmentId, messageId, obc);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> findAll()
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll();
	}

	public static java.util.List<com.liferay.mail.model.Attachment> findAll(
		int start, int end) throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end);
	}

	public static java.util.List<com.liferay.mail.model.Attachment> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end, obc);
	}

	public static void removeByMessageId(long messageId)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByMessageId(messageId);
	}

	public static void removeAll() throws com.liferay.portal.SystemException {
		getPersistence().removeAll();
	}

	public static int countByMessageId(long messageId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByMessageId(messageId);
	}

	public static int countAll() throws com.liferay.portal.SystemException {
		return getPersistence().countAll();
	}

	public static AttachmentPersistence getPersistence() {
		return _persistence;
	}

	public void setPersistence(AttachmentPersistence persistence) {
		_persistence = persistence;
	}

	private static AttachmentPersistence _persistence;
}