/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

/**
 * <a href="ContactUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class ContactUtil {
	public static void cacheResult(com.liferay.mail.model.Contact contact) {
		getPersistence().cacheResult(contact);
	}

	public static void cacheResult(
		java.util.List<com.liferay.mail.model.Contact> contacts) {
		getPersistence().cacheResult(contacts);
	}

	public static void clearCache() {
		getPersistence().clearCache();
	}

	public static com.liferay.mail.model.Contact create(long contactId) {
		return getPersistence().create(contactId);
	}

	public static com.liferay.mail.model.Contact remove(long contactId)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		return getPersistence().remove(contactId);
	}

	public static com.liferay.mail.model.Contact remove(
		com.liferay.mail.model.Contact contact)
		throws com.liferay.portal.SystemException {
		return getPersistence().remove(contact);
	}

	public static com.liferay.mail.model.Contact update(
		com.liferay.mail.model.Contact contact)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(contact);
	}

	public static com.liferay.mail.model.Contact update(
		com.liferay.mail.model.Contact contact, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(contact, merge);
	}

	public static com.liferay.mail.model.Contact updateImpl(
		com.liferay.mail.model.Contact contact, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().updateImpl(contact, merge);
	}

	public static com.liferay.mail.model.Contact findByPrimaryKey(
		long contactId)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		return getPersistence().findByPrimaryKey(contactId);
	}

	public static com.liferay.mail.model.Contact fetchByPrimaryKey(
		long contactId) throws com.liferay.portal.SystemException {
		return getPersistence().fetchByPrimaryKey(contactId);
	}

	public static java.util.List<com.liferay.mail.model.Contact> findByUserId(
		long userId) throws com.liferay.portal.SystemException {
		return getPersistence().findByUserId(userId);
	}

	public static java.util.List<com.liferay.mail.model.Contact> findByUserId(
		long userId, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByUserId(userId, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Contact> findByUserId(
		long userId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByUserId(userId, start, end, obc);
	}

	public static com.liferay.mail.model.Contact findByUserId_First(
		long userId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		return getPersistence().findByUserId_First(userId, obc);
	}

	public static com.liferay.mail.model.Contact findByUserId_Last(
		long userId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		return getPersistence().findByUserId_Last(userId, obc);
	}

	public static com.liferay.mail.model.Contact[] findByUserId_PrevAndNext(
		long contactId, long userId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		return getPersistence().findByUserId_PrevAndNext(contactId, userId, obc);
	}

	public static com.liferay.mail.model.Contact findByU_M(long userId,
		java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		return getPersistence().findByU_M(userId, messageAddress);
	}

	public static com.liferay.mail.model.Contact fetchByU_M(long userId,
		java.lang.String messageAddress)
		throws com.liferay.portal.SystemException {
		return getPersistence().fetchByU_M(userId, messageAddress);
	}

	public static com.liferay.mail.model.Contact fetchByU_M(long userId,
		java.lang.String messageAddress, boolean retrieveFromCache)
		throws com.liferay.portal.SystemException {
		return getPersistence()
				   .fetchByU_M(userId, messageAddress, retrieveFromCache);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Contact> findAll()
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll();
	}

	public static java.util.List<com.liferay.mail.model.Contact> findAll(
		int start, int end) throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end);
	}

	public static java.util.List<com.liferay.mail.model.Contact> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end, obc);
	}

	public static void removeByUserId(long userId)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByUserId(userId);
	}

	public static void removeByU_M(long userId, java.lang.String messageAddress)
		throws com.liferay.mail.NoSuchContactException,
			com.liferay.portal.SystemException {
		getPersistence().removeByU_M(userId, messageAddress);
	}

	public static void removeAll() throws com.liferay.portal.SystemException {
		getPersistence().removeAll();
	}

	public static int countByUserId(long userId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByUserId(userId);
	}

	public static int countByU_M(long userId, java.lang.String messageAddress)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByU_M(userId, messageAddress);
	}

	public static int countAll() throws com.liferay.portal.SystemException {
		return getPersistence().countAll();
	}

	public static ContactPersistence getPersistence() {
		return _persistence;
	}

	public void setPersistence(ContactPersistence persistence) {
		_persistence = persistence;
	}

	private static ContactPersistence _persistence;
}