/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

/**
 * <a href="FolderUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class FolderUtil {
	public static void cacheResult(com.liferay.mail.model.Folder folder) {
		getPersistence().cacheResult(folder);
	}

	public static void cacheResult(
		java.util.List<com.liferay.mail.model.Folder> folders) {
		getPersistence().cacheResult(folders);
	}

	public static void clearCache() {
		getPersistence().clearCache();
	}

	public static com.liferay.mail.model.Folder create(long folderId) {
		return getPersistence().create(folderId);
	}

	public static com.liferay.mail.model.Folder remove(long folderId)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		return getPersistence().remove(folderId);
	}

	public static com.liferay.mail.model.Folder remove(
		com.liferay.mail.model.Folder folder)
		throws com.liferay.portal.SystemException {
		return getPersistence().remove(folder);
	}

	public static com.liferay.mail.model.Folder update(
		com.liferay.mail.model.Folder folder)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(folder);
	}

	public static com.liferay.mail.model.Folder update(
		com.liferay.mail.model.Folder folder, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(folder, merge);
	}

	public static com.liferay.mail.model.Folder updateImpl(
		com.liferay.mail.model.Folder folder, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().updateImpl(folder, merge);
	}

	public static com.liferay.mail.model.Folder findByPrimaryKey(long folderId)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		return getPersistence().findByPrimaryKey(folderId);
	}

	public static com.liferay.mail.model.Folder fetchByPrimaryKey(long folderId)
		throws com.liferay.portal.SystemException {
		return getPersistence().fetchByPrimaryKey(folderId);
	}

	public static java.util.List<com.liferay.mail.model.Folder> findByAccountEntryId(
		long accountEntryId) throws com.liferay.portal.SystemException {
		return getPersistence().findByAccountEntryId(accountEntryId);
	}

	public static java.util.List<com.liferay.mail.model.Folder> findByAccountEntryId(
		long accountEntryId, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByAccountEntryId(accountEntryId, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Folder> findByAccountEntryId(
		long accountEntryId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence()
				   .findByAccountEntryId(accountEntryId, start, end, obc);
	}

	public static com.liferay.mail.model.Folder findByAccountEntryId_First(
		long accountEntryId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		return getPersistence().findByAccountEntryId_First(accountEntryId, obc);
	}

	public static com.liferay.mail.model.Folder findByAccountEntryId_Last(
		long accountEntryId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		return getPersistence().findByAccountEntryId_Last(accountEntryId, obc);
	}

	public static com.liferay.mail.model.Folder[] findByAccountEntryId_PrevAndNext(
		long folderId, long accountEntryId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByAccountEntryId_PrevAndNext(folderId, accountEntryId,
			obc);
	}

	public static com.liferay.mail.model.Folder findByA_N(long accountEntryId,
		java.lang.String fullName)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		return getPersistence().findByA_N(accountEntryId, fullName);
	}

	public static com.liferay.mail.model.Folder fetchByA_N(
		long accountEntryId, java.lang.String fullName)
		throws com.liferay.portal.SystemException {
		return getPersistence().fetchByA_N(accountEntryId, fullName);
	}

	public static com.liferay.mail.model.Folder fetchByA_N(
		long accountEntryId, java.lang.String fullName,
		boolean retrieveFromCache) throws com.liferay.portal.SystemException {
		return getPersistence()
				   .fetchByA_N(accountEntryId, fullName, retrieveFromCache);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Folder> findAll()
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll();
	}

	public static java.util.List<com.liferay.mail.model.Folder> findAll(
		int start, int end) throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end);
	}

	public static java.util.List<com.liferay.mail.model.Folder> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end, obc);
	}

	public static void removeByAccountEntryId(long accountEntryId)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByAccountEntryId(accountEntryId);
	}

	public static void removeByA_N(long accountEntryId,
		java.lang.String fullName)
		throws com.liferay.mail.NoSuchFolderException,
			com.liferay.portal.SystemException {
		getPersistence().removeByA_N(accountEntryId, fullName);
	}

	public static void removeAll() throws com.liferay.portal.SystemException {
		getPersistence().removeAll();
	}

	public static int countByAccountEntryId(long accountEntryId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByAccountEntryId(accountEntryId);
	}

	public static int countByA_N(long accountEntryId, java.lang.String fullName)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByA_N(accountEntryId, fullName);
	}

	public static int countAll() throws com.liferay.portal.SystemException {
		return getPersistence().countAll();
	}

	public static FolderPersistence getPersistence() {
		return _persistence;
	}

	public void setPersistence(FolderPersistence persistence) {
		_persistence = persistence;
	}

	private static FolderPersistence _persistence;
}