/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.service.persistence;

/**
 * <a href="MessageUtil.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 */
public class MessageUtil {
	public static void cacheResult(com.liferay.mail.model.Message message) {
		getPersistence().cacheResult(message);
	}

	public static void cacheResult(
		java.util.List<com.liferay.mail.model.Message> messages) {
		getPersistence().cacheResult(messages);
	}

	public static void clearCache() {
		getPersistence().clearCache();
	}

	public static com.liferay.mail.model.Message create(long messageId) {
		return getPersistence().create(messageId);
	}

	public static com.liferay.mail.model.Message remove(long messageId)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		return getPersistence().remove(messageId);
	}

	public static com.liferay.mail.model.Message remove(
		com.liferay.mail.model.Message message)
		throws com.liferay.portal.SystemException {
		return getPersistence().remove(message);
	}

	public static com.liferay.mail.model.Message update(
		com.liferay.mail.model.Message message)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(message);
	}

	public static com.liferay.mail.model.Message update(
		com.liferay.mail.model.Message message, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().update(message, merge);
	}

	public static com.liferay.mail.model.Message updateImpl(
		com.liferay.mail.model.Message message, boolean merge)
		throws com.liferay.portal.SystemException {
		return getPersistence().updateImpl(message, merge);
	}

	public static com.liferay.mail.model.Message findByPrimaryKey(
		long messageId)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		return getPersistence().findByPrimaryKey(messageId);
	}

	public static com.liferay.mail.model.Message fetchByPrimaryKey(
		long messageId) throws com.liferay.portal.SystemException {
		return getPersistence().fetchByPrimaryKey(messageId);
	}

	public static java.util.List<com.liferay.mail.model.Message> findByFolderId(
		long folderId) throws com.liferay.portal.SystemException {
		return getPersistence().findByFolderId(folderId);
	}

	public static java.util.List<com.liferay.mail.model.Message> findByFolderId(
		long folderId, int start, int end)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByFolderId(folderId, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Message> findByFolderId(
		long folderId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findByFolderId(folderId, start, end, obc);
	}

	public static com.liferay.mail.model.Message findByFolderId_First(
		long folderId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		return getPersistence().findByFolderId_First(folderId, obc);
	}

	public static com.liferay.mail.model.Message findByFolderId_Last(
		long folderId, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		return getPersistence().findByFolderId_Last(folderId, obc);
	}

	public static com.liferay.mail.model.Message[] findByFolderId_PrevAndNext(
		long messageId, long folderId,
		com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		return getPersistence()
				   .findByFolderId_PrevAndNext(messageId, folderId, obc);
	}

	public static com.liferay.mail.model.Message findByF_R(long folderId,
		long remoteMessageId)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		return getPersistence().findByF_R(folderId, remoteMessageId);
	}

	public static com.liferay.mail.model.Message fetchByF_R(long folderId,
		long remoteMessageId) throws com.liferay.portal.SystemException {
		return getPersistence().fetchByF_R(folderId, remoteMessageId);
	}

	public static com.liferay.mail.model.Message fetchByF_R(long folderId,
		long remoteMessageId, boolean retrieveFromCache)
		throws com.liferay.portal.SystemException {
		return getPersistence()
				   .fetchByF_R(folderId, remoteMessageId, retrieveFromCache);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	public static java.util.List<Object> findWithDynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	public static java.util.List<com.liferay.mail.model.Message> findAll()
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll();
	}

	public static java.util.List<com.liferay.mail.model.Message> findAll(
		int start, int end) throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end);
	}

	public static java.util.List<com.liferay.mail.model.Message> findAll(
		int start, int end, com.liferay.portal.kernel.util.OrderByComparator obc)
		throws com.liferay.portal.SystemException {
		return getPersistence().findAll(start, end, obc);
	}

	public static void removeByFolderId(long folderId)
		throws com.liferay.portal.SystemException {
		getPersistence().removeByFolderId(folderId);
	}

	public static void removeByF_R(long folderId, long remoteMessageId)
		throws com.liferay.mail.NoSuchMessageException,
			com.liferay.portal.SystemException {
		getPersistence().removeByF_R(folderId, remoteMessageId);
	}

	public static void removeAll() throws com.liferay.portal.SystemException {
		getPersistence().removeAll();
	}

	public static int countByFolderId(long folderId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByFolderId(folderId);
	}

	public static int countByF_R(long folderId, long remoteMessageId)
		throws com.liferay.portal.SystemException {
		return getPersistence().countByF_R(folderId, remoteMessageId);
	}

	public static int countAll() throws com.liferay.portal.SystemException {
		return getPersistence().countAll();
	}

	public static MessagePersistence getPersistence() {
		return _persistence;
	}

	public void setPersistence(MessagePersistence persistence) {
		_persistence = persistence;
	}

	private static MessagePersistence _persistence;
}