create table Mail_AccountEntry (
	accountEntryId LONG not null primary key,
	companyId LONG,
	userId LONG,
	createDate DATE null,
	modifiedDate DATE null,
	type_ VARCHAR(75) null,
	messageAddress VARCHAR(75) null,
	inboxFolderId LONG,
	draftFolderId LONG,
	sentFolderId LONG,
	trashFolderId LONG,
	username VARCHAR(75) null,
	senderName VARCHAR(75) null,
	password_ VARCHAR(75) null,
	passwordSaved BOOLEAN,
	initialized BOOLEAN,
	signature STRING null,
	useSignature BOOLEAN
);

create table Mail_AccountSetting (
	accountSettingId LONG not null primary key,
	companyId LONG,
	createDate DATE null,
	modifiedDate DATE null,
	accountEntryId LONG,
	type_ VARCHAR(75) null,
	mailInHostName VARCHAR(75) null,
	mailInPort INTEGER,
	mailInSecure BOOLEAN,
	mailOutHostName VARCHAR(75) null,
	mailOutPort INTEGER,
	mailOutSecure BOOLEAN,
	defaultFolderPrefix VARCHAR(75) null
);

create table Mail_Attachment (
	attachmentId LONG not null primary key,
	messageId LONG,
	filename VARCHAR(150) null,
	size_ LONG,
	contentPath VARCHAR(75) null
);

create table Mail_Contact (
	contactId LONG not null primary key,
	companyId LONG,
	userId LONG,
	name VARCHAR(75) null,
	messageAddress VARCHAR(75) null
);

create table Mail_Folder (
	folderId LONG not null primary key,
	companyId LONG,
	createDate DATE null,
	modifiedDate DATE null,
	accountEntryId LONG,
	fullName VARCHAR(75) null,
	name VARCHAR(75) null,
	initialized BOOLEAN,
	remoteMessageCount INTEGER,
	synchronizedDate DATE null
);

create table Mail_Message (
	messageId LONG not null primary key,
	companyId LONG,
	userId LONG,
	createDate DATE null,
	modifiedDate DATE null,
	folderId LONG,
	sender VARCHAR(75) null,
	recipientsTo STRING null,
	recipientsCc STRING null,
	recipientsBcc STRING null,
	sentDate DATE null,
	subject STRING null,
	preview VARCHAR(150) null,
	body STRING null,
	flags VARCHAR(75) null,
	size_ LONG,
	remoteMessageId LONG
);
