/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail;

import com.liferay.mail.util.FileConvertorUtil;
import com.liferay.portal.kernel.util.StringPool;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

/**
 * <a href="MailFile.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 *
 */
public class MailFile {

	public MailFile(String filename, long size, File file) {
		_filename = filename;
		_size = size;
		_file = file;
	}

	public MailFile(String filename, long size, InputStream inputStream) {
		_filename = filename;
		_size = size;

		try {
			_file = FileConvertorUtil.convertToFile(inputStream);
		}
		catch (IOException ioe) {
		}
	}

	public MailFile(String filename, long size, String contentPath) {
		_filename = filename;
		_size = size;
		_contentPath = contentPath;
	}

	public String getContentPath() {
		return _contentPath;
	}

	public File getFile() {
		return _file;
	}

	public String getFilename() {
		return _filename;
	}

	public long getSize() {
		return _size;
	}

	private String _contentPath = StringPool.BLANK;
	private File _file = null;
	private String _filename = StringPool.BLANK;
	private long _size = 0;

}