/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.mail.util;

import com.liferay.mail.ConversionException;
import com.liferay.mail.Recipient;
import com.liferay.portal.kernel.json.JSONObject;

import java.io.Serializable;

import java.util.List;

import javax.mail.internet.InternetAddress;

/**
 * <a href="MessageAddressConverter.java.html"><b><i>View Source</i></b></a>
 *
 * @author Scott Lee
 *
 */
public interface MessageAddressConverter extends Serializable {

	public String convert(Recipient[] recipients);

	public InternetAddress[] convertToInternetAddresses(
			Recipient[] recipients, Recipient.RecipientType recipientType)
		throws ConversionException;

	public JSONObject convertToJSON(List<Recipient> recipients)
		throws ConversionException;

	public Recipient[] convertToRecipients(
			String messageAddresses, Recipient.RecipientType recipientType,
			boolean strict)
		throws ConversionException;

}