
package com.vaadin.liferay.mail;

import com.liferay.mail.Recipient;
import com.vaadin.liferay.mail.Composer.ComposerListener;
import com.vaadin.liferay.mail.util.Lang;
import com.vaadin.ui.Window;

@SuppressWarnings("serial")
public class ComposeWindow extends Window {

	private Composer composer;

	public ComposeWindow(Composer composer) {

		super(Lang.get("compose-message"));
		setWidth("60%");
		setHeight("80%");

		this.composer = composer;
		setContent(composer);

		composer.addListener(new ComposerListener() {

			public void messageDiscarded(Composer composer) {

				((Window) getParent()).removeWindow(ComposeWindow.this);
			}

			public void messageSaved(Composer composer) {

				((Window) getParent()).showNotification(
					Lang.get("your-message-was-saved"),
					Notification.TYPE_TRAY_NOTIFICATION);
				((Window) getParent()).removeWindow(ComposeWindow.this);
			}

			public void messageSent(Composer composer) {

				String to = null;
				for (Recipient r : composer.getRecipients()) {
					if (to == null) {
						to = r.getMessageAddress();
					}
					else {
						to += ", " + r.getMessageAddress();
					}
				}
				((Window) getParent()).showNotification(
					Lang.get("your-message-has-been-sent"), Lang.get("to") +
						":</br>" + to + "<br/>" + Lang.get("subject") + ": " +
						composer.getSubject() + "<br/>" +
						composer.getAttachments().size() + " " +
						Lang.get("attachments"),
					Notification.TYPE_TRAY_NOTIFICATION);
				((Window) getParent()).removeWindow(ComposeWindow.this);
			}

		});
	}
}
