<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/init.jsp" %>

<%
long accountEntryId = ParamUtil.getLong(request, "accountEntryId");
boolean admin = ParamUtil.getBoolean(request, "admin");
boolean preconfigured = ParamUtil.getBoolean(request, "preconfigured");
String actionURL = ParamUtil.getString(request, "actionURL");
String titleLanguageKey = ParamUtil.getString(request, "titleLanguageKey");
String descriptionLanguageKey = ParamUtil.getString(request, "descriptionLanguageKey");
String messageAddress = ParamUtil.getString(request, "messageAddress");
String username = ParamUtil.getString(request, "username");
boolean passwordSaved = ParamUtil.getBoolean(request, "passwordSaved");
boolean useLocalPartOfEmailAddressAsUsername = ParamUtil.getBoolean(request, "useLocalPartOfEmailAddressAsUsername");
boolean hideSettings = ParamUtil.getBoolean(request, "hideSettings");
String mailInHostName = ParamUtil.getString(request, "mailInHostName");
int mailInPort = ParamUtil.getInteger(request, "mailInPort");
boolean mailInSecure = ParamUtil.getBoolean(request, "mailInSecure");
String mailOutHostName = ParamUtil.getString(request, "mailOutHostName");
int mailOutPort = ParamUtil.getInteger(request, "mailOutPort");
boolean mailOutSecure = ParamUtil.getBoolean(request, "mailOutSecure");
String defaultFolderPrefix = ParamUtil.getString(request, "defaultFolderPrefix");
String senderName = ParamUtil.getString(request,"senderName");
String signature = ParamUtil.getString(request, "signature");
boolean useSignature = ParamUtil.getBoolean(request, "useSignature");

MessageManager messageManager = MessageManager.getInstance(request);

boolean passwordRequired = true;

if (Validator.isNotNull(messageManager) && Validator.isNotNull(accountEntryId)) {
	passwordRequired = !messageManager.isPasswordSaved(accountEntryId);
}

int[] incomingPorts = GetterUtil.getIntegerValues(PortletProps.get("incoming.ports").split(","));
int[] outgoingPorts = GetterUtil.getIntegerValues(PortletProps.get("outgoing.ports").split(","));
%>

<div class="mail-portlet">
	<form class="uni-form" action="<%= actionURL %>" id="<portlet:namespace />accountEntryFm" method="post">
	<input name="<portlet:namespace /><%= Constants.CMD %>" type="hidden" value="updatePreconfiguredAccount" />
	<input name="<portlet:namespace />accountEntryId" type="hidden" value="<%= accountEntryId %>" />
	<input name="<portlet:namespace />oldTitleLanguageKey" type="hidden" value="<%= HtmlUtil.escape(titleLanguageKey) %>" />

	<div class="form-section">
		<div id="<portlet:namespace />accountEntryPopupStatus" />

		<c:choose>
			<c:when test="<%= admin %>">
				<h3><liferay-ui:message key="account-settings" /></h3>

				<fieldset class="block-labels">
					<div class="ctrl-holder">
						<label><liferay-ui:message key="title-language-key" /></label>

						<input class="lfr-input-text" name="<portlet:namespace />titleLanguageKey" value="<%= HtmlUtil.escape(titleLanguageKey) %>" />
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="description-language-key" /></label>

						<input class="lfr-input-text" name="<portlet:namespace />descriptionLanguageKey" value="<%= HtmlUtil.escape(descriptionLanguageKey) %>" />
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="default-email-address" /></label>

						<input class="lfr-input-text" name="<portlet:namespace />messageAddress" value="<%= HtmlUtil.escape(messageAddress) %>" />
					</div>

					<div class="ctrl-holder">
						<label class="inline-label"><liferay-ui:message key="use-email-address-as-username" /></label>

						<input name="<portlet:namespace />useLocalPartOfEmailAddressAsUsername" type="checkbox" <%= (useLocalPartOfEmailAddressAsUsername) ? "checked='checked'" : "" %> />
					</div>

					<div class="ctrl-holder">
						<label class="inline-label"><liferay-ui:message key="hide-server-settings-from-users" /></label>

						<input name="<portlet:namespace />hideSettings" type="checkbox" <%= (hideSettings) ? "checked='checked'" : "" %> />
					</div>
				</fieldset>
			</c:when>
			<c:otherwise>
				<c:choose>
					<c:when test="<%= preconfigured %>">
						<h3><liferay-ui:message key="account-settings" /> (<%= LanguageUtil.get(pageContext, HtmlUtil.escape(titleLanguageKey)) %>)</h3>
					</c:when>
					<c:otherwise>
						<h3><liferay-ui:message key="account-settings" /> (<%= HtmlUtil.escape(messageAddress) %>)</h3>
					</c:otherwise>
				</c:choose>

				<input name="<portlet:namespace />useLocalPartOfEmailAddressAsUsername" type="hidden" value="<%= useLocalPartOfEmailAddressAsUsername %>" />

				<fieldset class="block-labels">
					<c:if test="<%= Validator.isNotNull(descriptionLanguageKey) %>">
						<div class="ctrl-holder">
							<label><%= LanguageUtil.get(pageContext, HtmlUtil.escape(descriptionLanguageKey)) %></label>
						</div>
					</c:if>

					<c:choose>
						<c:when test="<%= preconfigured %>">
							<div class="ctrl-holder">
								<label><liferay-ui:message key="email-address" /></label>

								<input class="lfr-input-text" name="<portlet:namespace />messageAddress" value="<%= HtmlUtil.escape(messageAddress) %>" />
							</div>
						</c:when>
						<c:otherwise>
								<input name="<portlet:namespace />messageAddress" type="hidden" value="<%= HtmlUtil.escape(messageAddress) %>" />
						</c:otherwise>
					</c:choose>

					<c:if test="<%= !useLocalPartOfEmailAddressAsUsername %>">
						<div class="ctrl-holder">
							<label><liferay-ui:message key="user-name" /></label>

							<input class="lfr-input-text" name="<portlet:namespace />username" type="text" value="<%= HtmlUtil.escape(username) %>" />
						</div>
					</c:if>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="password" /></label>

						<input class="lfr-input-text password" name="<portlet:namespace />password" type="password" value="" />
					</div>

					<div class="ctrl-holder">
						<label class="inline-label"><liferay-ui:message key="save-password" /></label>

						<c:choose>
							<c:when test="<%= passwordSaved %>">
								<input name="<portlet:namespace />passwordSaved" type="checkbox" checked="checked" />
							</c:when>
							<c:otherwise>
								<input name="<portlet:namespace />passwordSaved" type="checkbox" />
							</c:otherwise>
						</c:choose>
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="sender-name"/></label>
						
						<input class="lfr-input-text" name="<portlet:namespace />senderName" type="text" value="<%= HtmlUtil.escape(senderName) %>" />
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="signature" /></label>
						
						<textarea  class="lfr-textarea" name="<portlet:namespace />signature" ><%= HtmlUtil.escape(signature) %></textarea>
					</div>

					<div class="ctrl-holder">	
						<label class="inline-label"><liferay-ui:message key="use-signature" /></label>	
						
						<input name="<portlet:namespace />useSignature" type="checkbox" <%= (useSignature) ? "checked='checked'" : "" %> />					
					</div>
				</fieldset>
			</c:otherwise>
		</c:choose>

		<c:choose>
			<c:when test="<%= !admin && preconfigured && hideSettings %>">
				<input name="<portlet:namespace />mailInHostName" type="hidden" value="<%= HtmlUtil.escape(mailInHostName) %>" />

				<input name="<portlet:namespace />mailInPort" type="hidden" value="<%= mailInPort %>" />

				<input name="<portlet:namespace />mailInSecure" type="hidden" value="<%= mailInSecure %>" />

				<input name="<portlet:namespace />mailOutHostName" type="hidden" value="<%= HtmlUtil.escape(mailOutHostName) %>" />

				<input name="<portlet:namespace />mailOutPort" type="hidden" value="<%= mailOutPort %>" />

				<input name="<portlet:namespace />mailOutSecure" type="hidden" value="<%= mailOutSecure %>" />

				<input name="<portlet:namespace />defaultFolderPrefix" type="hidden" value="<%= HtmlUtil.escape(defaultFolderPrefix) %>" />
			</c:when>
			<c:otherwise>
				<h3><liferay-ui:message key="server-settings" /></h3>

				<fieldset class="block-labels">
					<div class="ctrl-holder">
						<label><liferay-ui:message key="incoming-imap-server" /></label>

						<input class="lfr-input-text mail-in-host-name" name="<portlet:namespace />mailInHostName" type="text" value="<%= HtmlUtil.escape(mailInHostName) %>" />
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="incoming-port" /></label>

						<select name="<portlet:namespace />mailInPort">

						<%
						for (int i : incomingPorts) {
						%>

							<option value="<%= i %>" <%= (mailInPort == i) ? "selected" : "" %>><%= i %></option>

						<%
						}
						%>

						</select>
					</div>

					<div class="ctrl-holder">
						<label class="inline-label"><liferay-ui:message key="use-secure-incoming-connection" /></label>

						<input name="<portlet:namespace />mailInSecure" type="checkbox" <%= (mailInSecure) ? "checked='checked'" : "" %> />
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="outgoing-smtp-server" /></label>

						<input class="lfr-input-text mail-out-host-name" name="<portlet:namespace />mailOutHostName" type="text" value="<%= HtmlUtil.escape(mailOutHostName) %>" />
					</div>

					<div class="ctrl-holder">
						<label><liferay-ui:message key="outgoing-port" /></label>

						<select name="<portlet:namespace />mailOutPort">

						<%
						for (int i : outgoingPorts) {
						%>

							<option value="<%= i %>" <%= (mailOutPort == i) ? "selected" : "" %>><%= i %></option>

						<%
						}
						%>

						</select>
					</div>

					<div class="ctrl-holder">
						<label class="inline-label"><liferay-ui:message key="use-secure-outgoing-connection" /></label>

						<input name="<portlet:namespace />mailOutSecure" type="checkbox" <%= (mailOutSecure) ? "checked='checked'" : "" %> />
					</div>

					<div class="ctrl-holder">
						<label class="inline-label"><liferay-ui:message key="default-folder-prefix" /></label>

						<input class="lfr-input-text" name="<portlet:namespace />defaultFolderPrefix" type="text" value="<%= HtmlUtil.escape(defaultFolderPrefix) %>" />
					</div>
				</fieldset>
			</c:otherwise>
		</c:choose>

		<input class="save-account" passwordRequired="<%= passwordRequired %>" type="submit" value="<liferay-ui:message key="save" />" />

		<input class="cancel-setup" type="button" value="<liferay-ui:message key="cancel" />" />
	</div>

	</form>
</div>