<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/init.jsp" %>

<div class="mail-portlet">
	<form action="<liferay-portlet:actionURL portletConfiguration="true" />" class="uni-form" id="<portlet:namespace />fm" method="post" name="<portlet:namespace />fm">
		<input id="<portlet:namespace /><%= Constants.CMD %>" name="<portlet:namespace /><%= Constants.CMD %>" type="hidden" value="updateSettings" />
		<input id="<portlet:namespace />titleLanguageKey" name="<portlet:namespace />titleLanguageKey" type="hidden" value="" />

		<h3>Mail Accounts</h3>

		<fieldset class="block-labels">
			<div class="ctrl-holder">
				<label class="inline-label"><liferay-ui:message key="enable-mail-accounts" /></label>

				<liferay-ui:input-checkbox defaultValue="<%= enableMailAccountEntries %>" id='<%= renderResponse.getNamespace() + "enableMailAccountEntries" %>' param="enableMailAccountEntries"  />
			</div>

			<div id="<portlet:namespace />mailAccountsContainer">
				<h4><liferay-ui:message key="preconfigured-mail-accounts" /> <input class="update-preconfigured-account" type="button" value="<liferay-ui:message key="add" />" /></h4>

				<div class="ctrl-holder preconfigured-accounts-list" id="<portlet:namespace />preconfiguredAccountsList" />
			</div>
		</fieldset>

		<h3>Private Messaging Accounts</h3>

		<fieldset class="block-labels">
			<div class="ctrl-holder">
				<label class="inline-label"><liferay-ui:message key="enable-private-messaging-account" /></label>

				<liferay-ui:input-checkbox defaultValue="<%= enablePrivateAccountEntry %>" id='<%= renderResponse.getNamespace() + "enablePrivateAccountEntry" %>' param="enablePrivateAccountEntry" />
			</div>

			<div id="<portlet:namespace />privateMessagingAccountsContainer" />
		</fieldset>

		<input type="button" value="<liferay-ui:message key="save" />" onClick="submitForm(document.<portlet:namespace />fm);" />
	</form>
</div>

<script type="text/javascript">
jQuery(
	function(){
		var preconfiguredMailAccounts = <%= preferences.getValue("preconfiguredMailAccounts", PortletProps.get("preconfigured.mail.accounts")) %>;
		var preconfiguredAccountsList = jQuery('#<portlet:namespace />preconfiguredAccountsList');

		function getPreconfiguredMailAccount(titleLanguageKey) {
			for (i = 0; i < preconfiguredMailAccounts.accountEntries.length; i++) {
				var tempAccountEntry = preconfiguredMailAccounts.accountEntries[i];

				if (tempAccountEntry.titleLanguageKey == titleLanguageKey) {
					return tempAccountEntry;
				}
			}

			return null;
		}

		Liferay.Util.toggleBoxes('<portlet:namespace />enableMailAccountEntriesCheckbox', '<portlet:namespace />mailAccountsContainer');
		Liferay.Util.toggleBoxes('<portlet:namespace />enablePrivateAccountEntryCheckbox', '<portlet:namespace />privateMessagingAccountsContainer');

		jQuery('.delete-preconfigured-account').livequery('click', function () {
			var titleLanguageKey = jQuery(this).attr('titleLanguageKey');

			var accountEntry = getPreconfiguredMailAccount(titleLanguageKey);

			var answer = confirm('<liferay-ui:message key="are-you-sure-you-want-to-delete-this-preconfigured-account-entry" />');

			if (answer) {
				jQuery('#<portlet:namespace /><%= Constants.CMD %>').val('deletePreconfiguredAccount');
				jQuery('#<portlet:namespace />titleLanguageKey').val(titleLanguageKey);
				jQuery('#<portlet:namespace />fm').submit();
			}
		});

		jQuery('.cancel-setup').livequery('click', function() {
			Liferay.Popup.close('#<portlet:namespace />accountEntryFm');
		});

		jQuery('.update-preconfigured-account').livequery('click', function () {
			var accountEntry = getPreconfiguredMailAccount(jQuery(this).attr('titleLanguageKey'));

			var titleLanguageKey = '';
			var descriptionLanguageKey = '';
			var messageAddress = '';
			var useLocalPartOfEmailAddressAsUsername = false;
			var hideSettings = false;
			var mailInHostName = '';
			var mailInPort = '';
			var mailInSecure = '';
			var mailOutHostName = '';
			var mailOutPort = '';
			var mailOutSecure = '';
			var defaultFolderPrefix = '';

			if (accountEntry != null) {
				titleLanguageKey = accountEntry.titleLanguageKey;
				descriptionLanguageKey = accountEntry.descriptionLanguageKey;
				messageAddress = accountEntry.messageAddress;
				useLocalPartOfEmailAddressAsUsername = accountEntry.useLocalPartOfEmailAddressAsUsername;
				hideSettings = accountEntry.hideSettings;
				mailInHostName = accountEntry.mailInHostName;
				mailInPort = accountEntry.mailInPort;
				mailInSecure = accountEntry.mailInSecure;
				mailOutHostName = accountEntry.mailOutHostName;
				mailOutPort = accountEntry.mailOutPort;
				mailOutSecure = accountEntry.mailOutSecure;
				defaultFolderPrefix = accountEntry.defaultFolderPrefix;
			}

			// Eventually replace with popup, but when submitting form, no parameters are availble.. so must generate code with js
			// (See edit.jsp)

			var incomingPorts = [ <%= PortletProps.get("incoming.ports") %> ];
			var outgoingPorts = [ <%= PortletProps.get("outgoing.ports") %> ];

			var accountEntryHtml = [];

			accountEntryHtml.push('<div class="mail-portlet">');
			accountEntryHtml.push('<form class="uni-form" action="<liferay-portlet:actionURL portletConfiguration="true" />" id="<portlet:namespace />accountEntryFm" method="post">');
			accountEntryHtml.push('<input name="<portlet:namespace /><%= Constants.CMD %>" type="hidden" value="updatePreconfiguredAccount" />');
			accountEntryHtml.push('<input name="<portlet:namespace />oldTitleLanguageKey" type="hidden" value="' + titleLanguageKey + '" />');
			accountEntryHtml.push('<div class="form-section">');

			accountEntryHtml.push('<div id="<portlet:namespace />setupPredefinedAccountStatus" />');

			accountEntryHtml.push('<h3><liferay-ui:message key="account-settings" /></h3>');
			accountEntryHtml.push('<fieldset class="block-labels">');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="title-language-key" /></label>');
			accountEntryHtml.push('<input class="lfr-input-text" name="<portlet:namespace />titleLanguageKey" value="' + titleLanguageKey + '" />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="description-language-key" /></label>');
			accountEntryHtml.push('<input class="lfr-input-text" name="<portlet:namespace />descriptionLanguageKey" value="' + descriptionLanguageKey + '" />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="default-email-address" /></label>');
			accountEntryHtml.push('<input class="lfr-input-text" name="<portlet:namespace />messageAddress" value="' + messageAddress + '" />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label class="inline-label"><liferay-ui:message key="use-local-part-of-email-address-as-username" /></label>');
			accountEntryHtml.push('<input name="<portlet:namespace />useLocalPartOfEmailAddressAsUsername" type="checkbox" ' + ((useLocalPartOfEmailAddressAsUsername) ? 'checked="checked"' : '') + ' />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label class="inline-label"><liferay-ui:message key="hide-server-settings-from-users" /></label>');
			accountEntryHtml.push('<input name="<portlet:namespace />hideSettings" type="checkbox" ' + ((hideSettings) ? 'checked="checked"' : '') + ' />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('</fieldset>');

			accountEntryHtml.push('<h3><liferay-ui:message key="server-settings" /></h3>');
			accountEntryHtml.push('<fieldset class="block-labels">');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="incoming-imap-server" /></label>');
			accountEntryHtml.push('<input class="lfr-input-text" name="<portlet:namespace />mailInHostName" value="' + mailInHostName + '" />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="incoming-port" /></label>');
			accountEntryHtml.push('<select name="<portlet:namespace />mailInPort">');

			for (i = 0; i < incomingPorts.length; i++) {
				if (incomingPorts[i] == mailInPort) {
					accountEntryHtml.push('<option value="' + incomingPorts[i] + '" selected>' + incomingPorts[i] + '</option>');
				}
				else {
					accountEntryHtml.push('<option value="' + incomingPorts[i] + '">' + incomingPorts[i] + '</option>');
				}
			}

			accountEntryHtml.push('</select>');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label class="inline-label"><liferay-ui:message key="use-secure-incoming-connection" /></label>');
			accountEntryHtml.push('<input name="<portlet:namespace />mailInSecure" type="checkbox" ' + ((mailInSecure) ? 'checked="checked"' : '') + ' />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="outgoing-smtp-server" /></label>');
			accountEntryHtml.push('<input class="lfr-input-text" name="<portlet:namespace />mailOutHostName" value="' + mailOutHostName + '" />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="outgoing-port" /></label>');
			accountEntryHtml.push('<select name="<portlet:namespace />mailOutPort">');

			for (i = 0; i < outgoingPorts.length; i++) {
				if (outgoingPorts[i] == mailOutPort) {
					accountEntryHtml.push('<option value="' + outgoingPorts[i] + '" selected>' + outgoingPorts[i] + '</option>');
				}
				else {
					accountEntryHtml.push('<option value="' + outgoingPorts[i] + '">' + outgoingPorts[i] + '</option>');
				}
			}

			accountEntryHtml.push('</select>');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label class="inline-label"><liferay-ui:message key="use-secure-outgoing-connection" /></label>');
			accountEntryHtml.push('<input name="<portlet:namespace />mailOutSecure" type="checkbox" ' + ((mailOutSecure) ? 'checked="checked"' : '') + ' />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('<div class="ctrl-holder">');
			accountEntryHtml.push('<label><liferay-ui:message key="default-folder-prefix" /></label>');
			accountEntryHtml.push('<input class="lfr-input-text" name="<portlet:namespace />defaultFolderPrefix" value="' + defaultFolderPrefix + '" />');
			accountEntryHtml.push('</div>');

			accountEntryHtml.push('</fieldset>');

			accountEntryHtml.push('<input type="submit" value="<liferay-ui:message key="save" />" />');
			accountEntryHtml.push('<input class="cancel-setup" type="button" value="<liferay-ui:message key="cancel" />" />');

			accountEntryHtml.push('</div>');
			accountEntryHtml.push('</form>');
			accountEntryHtml.push('</div>');

			var popup = Liferay.Popup({
				title: '<liferay-ui:message key="setup-preconfigured-mail-account" />',
				draggable: true,
				handles: '',
				message: accountEntryHtml.join(''),
				modal: true,
				position: ['center', 100],
				width: 550
			});

			/*
			var popup = Liferay.Popup({
				title: '<liferay-ui:message key="setup-preconfigured-mail-account" />',
				draggable: true,
				handles: '',
				noCenter: true,
				url: themeDisplay.getLayoutURL() + '/-/mail/account_entry_popup',
				urlData: {
					admin: true,
					preconfigured: true,
					actionURL: '<liferay-portlet:actionURL portletConfiguration="true" />',
					titleLanguageKey: titleLanguageKey,
					descriptionLanguageKey: descriptionLanguageKey,
					messageAddress: messageAddress,
					useLocalPartOfEmailAddressAsUsername: useLocalPartOfEmailAddressAsUsername,
					hideSettings: hideSettings,
					mailInHostName: mailInHostName,
					mailInPort: mailInPort,
					mailInSecure: mailInSecure,
					mailOutHostName: mailOutHostName,
					mailOutPort: mailOutPort,
					mailOutSecure: mailOutSecure
				},
				modal: true,
				width: 550
			});
			*/

		});

		function refreshPreconfiguredAccounts() {
			var accountEntryHtml = [];

			accountEntryHtml.push('<table class="lfr-table">');

			for (i = 0; i < preconfiguredMailAccounts.accountEntries.length; i++) {
				var accountEntry = preconfiguredMailAccounts.accountEntries[i];

				accountEntryHtml.push('<tr>');
				accountEntryHtml.push('<td class="title-language-key">' + Liferay.Language.get(accountEntry.titleLanguageKey) + '</td>');
				accountEntryHtml.push('<td><input class="update-preconfigured-account" titleLanguageKey="' + accountEntry.titleLanguageKey + '" type="button" value="<liferay-ui:message key="edit" />" /></td>');
				accountEntryHtml.push('<td><input class="delete-preconfigured-account" titleLanguageKey="' + accountEntry.titleLanguageKey + '" type="button" value="<liferay-ui:message key="delete" />" /></td>');
				accountEntryHtml.push('</tr>');
			}

			accountEntryHtml.push('</table>');

			preconfiguredAccountsList.html(accountEntryHtml.join(''));
		}

		refreshPreconfiguredAccounts();
	}
);
</script>