<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/css_init.jsp" %>

/* ---------- Contacts ------------ */

.contact-list .contact-labels {
	height: 250px;
	overflow: auto;
}

/* ---------- Uni Form ---------- */

.mail-portlet .form-section h3 {
	margin: 10px 0;
}

.mail-portlet .uni-form fieldset {
}

.mail-portlet .uni-form .block-labels label {
	float: left;
	font-weight: bold;
	padding-right: 10px;
}

.mail-portlet .uni-form .block-labels .ctrl-holder {
	margin-bottom: 10px;
}

/* ---------- Configuration ------- */

.mail-portlet .preconfigured-accounts-list .title-language-key {
	width: 150px;
}

.mail-portlet h4 {
	padding-top: 15px;
}

/* ---------- Header row ---------- */

.mail-portlet .header-row {
	display: none;
	height: 35px;
	width: 100%;
}

.mail-portlet .header-row tr {
	vertical-align: top;
}

.mail-portlet .header-row .search {
	width: 202px;
}

.mail-portlet .header-row .selection {
	width: 300px;
}

.mail-portlet .header-row .selection select {
	margin-right: 10px;
}

.mail-portlet .header-row .status {
	text-align: center;
}

.mail-portlet .header-row .status .message {
	font-weight: bold;
	margin: 0px;
}

.mail-portlet .header-row .colored {
	background-color: #FFF1A8;
}

.mail-portlet .configuration-prompt {
	display: none;
}

/* ---------- Email container ---------- */

.mail-portlet .email-container {
	display: none;
	height: 400px;
	width: 100%;
}

.mail-portlet .email-container tr {
	vertical-align: top;
}

.mail-portlet .email-container td.email-left-column {
	vertical-align: top;
}

.mail-portlet .email-container .alert {
	font-size: 16px;
	height: 300px;
	text-align: center;
	vertical-align: middle;
	width: 100%;
}

.mail-portlet .email-container .email-left-column {
	border: 1px #000 solid;
	min-width: 200px;
	width: 13%;
}

.mail-portlet .email-container .email-left-column .folder a {
	text-decoration: none;
}

.mail-portlet .email-container .email-left-column .compose-message {
	cursor: pointer;
	font-size: 12px;
	margin-bottom: 20px;
	padding: 5px;
	width: 200px;
}

.mail-portlet .email-container .email-left-column .manage-folders {
	cursor: pointer;
	font-size: 12px;
	margin-top: 20px;
	padding: 5px;
}

.mail-portlet .email-container .email-left-column .manage-contacts {
	cursor: pointer;
	display: none;
	font-size: 12px;
	padding: 5px;
}

.mail-portlet .email-container .email-left-column .folder-selected {
	/* background-color: #C3D9FF; */
}

.mail-portlet .email-container td.email-right-column {
	vertical-align: top;
}

.mail-portlet .email-container .email-right-column {
	border: 1px #000 solid;
	max-width: 1000px;
	min-width: 550px;
	width: 90%;
}

.mail-portlet .email-container .email-left-column .folder {
	font-size: 12px;
	font-weight: bold;
	min-width: 80px;
	padding: 5px;
}

/* ---------- Message list ---------- */

.mail-portlet .email-container .folder-container .column-sorter:hover {
	cursor: pointer;
	cursor: hand;
	text-decoration: underline;
}

.mail-portlet .email-container .folder-container .folder-controls {
	/* background-color: #C3D9FF; */
	padding: 3px;
	width: 100%;
}

.mail-portlet .email-container .folder-container .folder-controls .actions {
	height: 45px;
}

.mail-portlet .email-container .folder-container .folder-controls .actions div {
	padding: 4px;
}

.mail-portlet .email-container .folder-container .folder-controls .navigation {
	padding: 5px;
	text-align: right;
}

.mail-portlet .email-container .folder-container .folder-controls .navigation .status {
	text-align: center;
	width: 40%;
}

.mail-portlet .email-container .folder-container .message:hover {
	cursor: pointer;
}

.mail-portlet .email-container .folder-container .message td {
	border-bottom: 1px solid #CCC;
	padding: 2px;
}

.mail-portlet .email-container .folder-container .message .message-from {
	padding-right: 5px;
}

.mail-portlet .email-container .folder-container .message .message-to {
	padding-right: 5px;
}

.mail-portlet .email-container .folder-container .message .message-body-preview {
	color: grey;
}

.mail-portlet .email-container .folder-container .message .message-col-1 {
	overflow: hidden;
	text-align: center;
	width: 25px;
}

.mail-portlet .email-container .folder-container .message .message-col-2 {
	padding: 0px 10px 0px 20px;
	width: 20px;
}

.mail-portlet .email-container .folder-container .message .message-col-3 {
	height: 17px;
	overflow: hidden;
	width: 200px;
}

.mail-portlet .email-container .folder-container .message .message-col-4 {
	height: 17px;
	overflow: hidden;
}

.mail-portlet .email-container .folder-container .message .message-col-5 {
	overflow: hidden;
	width: 75px;
}

.mail-portlet .email-container .folder-container .message .message-col-6 {
	padding-right: 20px;
	text-align: right;
	width: 55px;
}

.mail-portlet .email-container .folder-container .message-list {
	width: 100%;
}

.mail-portlet .email-container .folder-container .message-list tr {
	vertical-align: middle;
}

.mail-portlet .email-container .folder-container .message-list .arrow-asc {
	background: url(<%= themeImagesPath %>/arrows/01_down.png) no-repeat 40px 0;
}

.mail-portlet .email-container .folder-container .message-list .arrow-desc {
	background: url(<%= themeImagesPath %>/arrows/01_up.png) no-repeat 40px 0;
}

.mail-portlet .email-container .folder-container .message-list .flagged td {
	color: #E40000;
}

.mail-portlet .email-container .folder-container .message-list .read td {
	/* background: #E8EEF7; */
}

.mail-portlet .email-container .folder-container .message-list .unread td {
	/* background: #FFF; */
	font-weight: bold;
}

.mail-portlet .email-container .folder-container .status-number {
	font-weight: bold;
}

/* ---------- Contacts ---------- */

.mail-portlet .email-container .contacts-container .create-contact {
	padding: 10px;
}

.mail-portlet .email-container .contacts-container .contact td.name,
.mail-portlet .email-container .contacts-container .contact th.name {
	width: 200px;
}

.mail-portlet .email-container .contacts-container .contact td.message-address,
.mail-portlet .email-container .contacts-container .contact th.message-address {
	width: 200px;
}

.mail-portlet .email-container .contacts-container .listing {
	height: 400px;
	overflow: auto;
	padding: 10px;
}

.mail-portlet .email-container .contacts-container .listing a {
	text-decoration: none;
}

.mail-portlet .email-container .contacts-container .listing tr {
	height: 26px;
	vertical-align: middle;
}

.mail-portlet .email-container .contacts-container .listing .contact td.delete {
	width: 70px;
}

.mail-portlet .email-container .contacts-container .listing .contact td.edit {
	width: 100px;
}

.mail-portlet .email-container .contacts-container .controls {
	background-color: #EEEEEE;
	border-top: 1px solid #A5A5A5;
	border-bottom: 1px solid #A5A5A5;
	height: 70px;
}

/* ---------- Folder management ---------- */

.mail-portlet .email-container .manage-folders-container .create-folder {
	padding: 10px;
}

.mail-portlet .email-container .manage-folders-container .folder td.name,
.mail-portlet .email-container .manage-folders-container .folder th.name {
	width: 300px;
}

.mail-portlet .email-container .manage-folders-container .listing {
	height: 400px;
	overflow: auto;
	padding: 10px;
}

.mail-portlet .email-container .manage-folders-container .listing a {
	text-decoration: none;
}

.mail-portlet .email-container .manage-folders-container .listing tr {
	height: 26px;
	vertical-align: middle;
}

.mail-portlet .email-container .manage-folders-container .listing .folder td.delete {
	width: 100px;
}

.mail-portlet .email-container .manage-folders-container .listing .folder td.rename {
	width: 100px;
}

.mail-portlet .email-container .manage-folders-container .listing .folder .save-folder-name {
	background: transparent url(<%= themeImagesPath %>/dock/my_place_current.png) no-repeat scroll 0 50%;
	margin: 0 10px;
	padding-left: 20px;
}

.mail-portlet .email-container .manage-folders-container .controls {
	background-color: #EEEEEE;
	border-top: 1px solid #A5A5A5;
	border-bottom: 1px solid #A5A5A5;
	height: 70px;
}

/* ---------- Single message ---------- */

.mail-portlet .email-container .message-container {
	overflow: hidden;
}

.mail-portlet .email-container .message-container .message-controls {
	clear: both;
	overflow: hidden;
	width: auto;
}

.ie6 .mail-portlet .email-container .message-container .message-controls {
	height: 1%;
}

.mail-portlet .email-container .message-container .message-controls .actions {
	float: left;
	padding: 5px;
}

.mail-portlet .email-container .message-container .message-controls .back {
	padding: 5px 0;
}

.mail-portlet .email-container .message-container .message-controls .buttons {
	float: left;
	padding: 5px;
}

.mail-portlet .email-container .message-container .message-controls .navigation {
	float: right;
	padding: 5px;
	text-align: right;
}

.mail-portlet .email-container .message-container .message-controls .navigation-links {
	padding: 5px 0;
}

.mail-portlet .email-container .message-container .message-controls .newer,  .mail-portlet .message-controls .older, .mail-portlet .message-controls .back {
	cursor: pointer;
}

.mail-portlet .email-container .message-container .message-options {
	background-color: #EEEEEE;
	border-top: 1px solid #A5A5A5;
}

.mail-portlet .email-container .message-container .message-options td {
	cursor: pointer;
	padding: 5px;
}

.mail-portlet .email-container .message-container .message-read .details {
	background-color: #EEEEEE;
	border-bottom: 1px solid #A5A5A5;
	padding: 5px;
}

.mail-portlet .email-container .message-container .message-read .details table tr {
	vertical-align: middle;
}

.mail-portlet .email-container .message-container .message-read .label {
	color: #585858;
	padding: 2px 15px;
	text-align: right;
	width: 60px;
}

.mail-portlet .email-container .message-container .message-read .read-body {
	margin: 20px;
	min-height: 125px;
	padding: 5px;
}

.mail-portlet .email-container .message-container .message-send .details {
	padding: 10px;
	text-align: center;
}

.mail-portlet .email-container .message-container .message-send .details table {
	margin-bottom: 10px;
	text-align: left;
	width: 100%;
}

.mail-portlet .email-container .message-container .message-send .details .address-selector {
	margin-left: 12px;
	min-width: 150px;
	vertical-align: top;
	width: 20%;
}

.mail-portlet .email-container .message-container .message-send .details .attachments .attachment-row {
	margin-bottom: 0px;
	width: 390px;
}

.mail-portlet .email-container .message-container .message-send .details .attachments .attachment-row td {
	padding: 0px;
}

.mail-portlet .email-container .message-container .message-send .details .attachments .attachment-input {
	width: auto;
}

.mail-portlet .email-container .message-container .message-send .details .attachments .delete-attachment {
	padding-left: 10px;
}

.mail-portlet .email-container .message-container .message-send .details .attachments .remove-attachment {
	padding-left: 10px;
}

.mail-portlet .email-container .message-container .message-send .details .send-to {
	float: left;
	vertical-align: top;
	width: 95%;
}

.mail-portlet .email-container .message-container .message-send .details .send-body-span {
	height: 300px;
	overflow: auto;
}

.mail-portlet .email-container .message-container .message-send .details input, .mail-portlet .message-send .details select, .mail-portlet .message-send .details textarea {
	width: 95%;
}

.mail-portlet .email-container .message-container .message-send .label {
	font-weight: bold;
	text-align: right;
	padding: 2px 7px;
	width: 20px;
}

.mail-portlet .email-container .message-container .message-send .options {
	padding: 5px;
}

/* ---------- Icons ---------- */

.mail-portlet .icon-attachment {
	background: url(<%= themeImagesPath %>/mail/clip.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-compose {
	background: url(<%= themeImagesPath %>/mail/compose.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-contacts {
	background: url(<%= themeImagesPath %>/common/group.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-delete-contact {
	background: url(<%= themeImagesPath %>/message_boards/ban_user.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-delete-folder {
	background: url(<%= themeImagesPath %>/mail/delete_folder.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-draft {
	background: url(<%= themeImagesPath %>/mail/edit_draft.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-edit-contact {
	background: url(<%= themeImagesPath %>/common/assign_user_roles.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-folder {
	background: url(<%= themeImagesPath %>/common/folder.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
	text-decoration: none;
}

.mail-portlet .icon-inbox {
	background: url(<%= themeImagesPath %>/dock/home.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-manage-folder {
	background: url(<%= themeImagesPath %>/mail/edit_folder.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-rename-folder {
	background: url(<%= themeImagesPath %>/mail/rename_folder.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-save {
	background: url(<%= themeImagesPath %>/dock/my_place_current.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-sent {
	background: url(<%= themeImagesPath %>/mail/forward.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

.mail-portlet .icon-trash {
	background: url(<%= themeImagesPath %>/common/delete.png) no-repeat 0 50%;
	margin: 0.3em 0;
	padding-left: 20px;
}

/* ---------- Account summary ---------- */

.mail-portlet .summary .mail-message-summary,
.mail-portlet .summary .private-message-summary {
	padding-bottom: 10px;
}

.mail-portlet .summary .message-summary-listing  {
	padding-left: 10px;
}

/* ---------- Header styles ---------- */

.mail-portlet .results-header,
.mail-portlet .results-header a {
	color: #FFFFFF;
}