Liferay.Mail = {
	init: function(params) {
		var instance = this;

		instance.namespace = params.namespace;
		instance._flagAnswered = params.flagAnswered;
		instance._flagDraft = params.flagDraft;
		instance._flagFlagged = params.flagFlagged;
		instance._flagSeen = params.flagSeen;

		instance._orderByAddress = params.orderByAddress;
		instance._orderByDate = params.orderByDate;
		instance._orderBySize = params.orderBySize;
		instance._orderBySubject = params.orderBySubject;

		instance._initialAccountEntryId = params.initialAccountEntryId;
		instance._messagesPerPage = params.messagesPerPage;
		instance._synchronizeInterval = params.synchronizeInterval;

		// Commonly used jQuery expressions

		instance.accountContainerDiv = jQuery('.header-row');
		instance.accountEntrySelectionSelect = jQuery('#' + instance.namespace + 'accountEntrySelection');
		instance.composeMessageLink = jQuery('.compose-message');
		instance.configurationPromptDiv = jQuery('.configuration-prompt');
		instance.emailContainerDiv = jQuery('.email-container');
		instance.folderDiv = jQuery('#' + instance.namespace + 'folder');
		instance.foldersDiv = jQuery('#' + instance.namespace + 'folders');
		instance.folderControlsDeleteButton = jQuery('.folder-controls .delete');
		instance.folderControlsMessageMover = jQuery('.folder-controls .message-mover');
		instance.folderControlsNewestLink = jQuery('.folder-controls .newest');
		instance.folderControlsNewerLink = jQuery('.folder-controls .newer');
		instance.folderControlsOlderLink = jQuery('.folder-controls .older');
		instance.folderControlsOldestLink = jQuery('.folder-controls .oldest');
		instance.folderControlsSelectAction = jQuery('.folder-controls .select-actions');
		instance.folderControlsSelectAllLink = jQuery('.folder-controls .select-all');
		instance.folderControlsSelectNoneLink = jQuery('.folder-controls .select-none');
		instance.folderControlsSelectReadLink = jQuery('.folder-controls .select-read');
		instance.folderControlsSelectUnreadLink = jQuery('.folder-controls .select-unread');
		instance.manageContactsContainerDiv = jQuery('.contacts-container');
		instance.manageContactsControls = jQuery('.contacts-container .controls');
		instance.manageContactsCreateButton = jQuery('.contacts-container .create');
		instance.manageContactsLink = jQuery('.manage-contacts');
		instance.manageContactsListing = jQuery('.contacts-container .listing');
		instance.manageContactsMessageAddressInput = jQuery('.contacts-container .message-address');
		instance.manageContactsNameInput = jQuery('.contacts-container .name');
		instance.manageFoldersContainerDiv = jQuery('.manage-folders-container');
		instance.manageFoldersControls = jQuery('.manage-folders-container .controls');
		instance.manageFoldersCreateButton = jQuery('.manage-folders-container .create');
		instance.manageFoldersLink = jQuery('.manage-folders');
		instance.manageFoldersListing = jQuery('.manage-folders-container .listing');
		instance.manageFoldersNameInput = jQuery('.manage-folders-container .name');
		instance.messageControlsActions = jQuery('.message-controls .actions');
		instance.messageControlsBackLink = jQuery('.message-controls .back');
		instance.messageControlsButtonsDiv = jQuery('.message-controls .buttons');
		instance.messageControlsDeleteButton = jQuery('.message-controls .delete');
		instance.messageControlsDiv = jQuery('.message-controls');
		instance.messageControlsNavigationCol = jQuery('.message-controls .navigation');
		instance.messageControlsNewerLink = jQuery('.message-controls .newer');
		instance.messageControlsOlderLink = jQuery('.message-controls .older');
		instance.messageControlsStatus = jQuery('.message-controls .status');
		instance.messageDiv = jQuery('#' + instance.namespace + 'message');
		instance.messageListTable = jQuery('#' + instance.namespace + 'message-list');
		instance.messageOptionsDiv = jQuery('#' + instance.namespace + 'messageOptions');
		instance.messageOptionsRespondDivs = jQuery('#' + instance.namespace + 'reply,#' + instance.namespace + 'reply-all,#' + instance.namespace + 'forward');
		instance.messageReadDiv = jQuery('#' + instance.namespace + 'messageRead');
		instance.messageSendDiscardButton = jQuery('#' + instance.namespace + 'messageSend .discard');
		instance.messageSendDiv = jQuery('#' + instance.namespace + 'messageSend');
		instance.messageSendSaveButton = jQuery('#' + instance.namespace + 'messageSend .save');
		instance.messageSendSendButton = jQuery('#' + instance.namespace + 'messageSend .send');
		instance.newMessagesSummaryDiv = jQuery('.new-messages-summary');
		instance.searchButton = jQuery('.header-row .search .button');
		instance.searchTextInput = jQuery('.header-row .search .text');
		instance.sendAttachmentCount = jQuery('#' + instance.namespace + 'sendAttachmentCount');
		instance.sendAttachmentsAdd = jQuery('.message-send .details .attachments .add-attachment');
		instance.sendAttachmentsDiv = jQuery('#' + instance.namespace + 'sendAttachments');
		instance.sendAttachmentsRow = jQuery('.message-send .details .attachments');
		instance.sendBccInput = jQuery('#' + instance.namespace + 'sendBcc');
		instance.sendBccRow = jQuery('.message-send .details .bcc');
		instance.sendBodyEditor = params.sendBodyEditor;
		instance.sendBodySpan = jQuery('.send-body-span');
		instance.sendBodyHidden = jQuery('#' + instance.namespace + 'sendBody');
		instance.sendCcInput = jQuery('#' + instance.namespace + 'sendCc');
		instance.sendCcRow = jQuery('.message-send .details .cc');
		instance.sendAccountEntryIdHidden = jQuery('#' + instance.namespace + 'sendAccountEntryId');
		instance.sendDraftMessageIdHidden = jQuery('#' + instance.namespace + 'sendDraftMessageId');
		instance.sendForwardAttachmentIdsHidden = jQuery('#' + instance.namespace + 'sendForwardAttachmentIds');
		instance.sendForwardMessageIdHidden = jQuery('#' + instance.namespace + 'sendForwardMessageId');
		instance.sendForm = jQuery('#' + instance.namespace + 'fm');
		instance.sendFromRow = jQuery('.message-send .details .from');
		instance.sendMessageHidden = jQuery('#' + instance.namespace + 'sendMessage');
		instance.sendSubjectInput = jQuery('#' + instance.namespace + 'sendSubject');
		instance.sendSubjectRow = jQuery('.message-send .details .subject');
		instance.sendToInput = jQuery('#' + instance.namespace + 'sendTo');
		instance.sendToRow = jQuery('.message-send .details .to');
		instance.statusDiv = jQuery('.header-row .status');
		instance.readBodySpan = jQuery('#' + instance.namespace + 'read-body');
		instance.readCcSpan = jQuery('#' + instance.namespace + 'read-cc');
		instance.readDateSpan = jQuery('#' + instance.namespace + 'read-date');
		instance.readFromSpan = jQuery('#' + instance.namespace + 'read-from');
		instance.readMailedBySpan = jQuery('#' + instance.namespace + 'read-mailed-by');
		instance.readReplyToSpan = jQuery('#' + instance.namespace + 'read-reply-to');
		instance.readSubjectSpan = jQuery('#' + instance.namespace + 'read-subject');
		instance.readToSpan = jQuery('#' + instance.namespace + 'read-to');
		instance.updateAccountEntryId = jQuery('#' + instance.namespace + 'updateAccountEntryId')
		instance.updateForm = jQuery('#' + instance.namespace + 'update form')

		// Init methods

		instance.loadJSONAccountEntries(params.jsonAccountEntries);
		instance._assignEvents();
		instance.loadCompleteAccountEntryPreAction(instance._initialAccountEntryId);

		setTimeout('Liferay.Mail.autoRefresh()', 2000);
	},

	addAttachmentPlaceholder: function(messageId, attachmentId, attachmentFilename, attachmentSize, pseudoForwardedAttachment) {
		var instance = this;

		var attachmentHtml = '';

		attachmentHtml += '<div attachmentId="' + attachmentId + '" class="attachment-row" pseudoForwardedAttachment="' + pseudoForwardedAttachment + '" messageId="' + messageId + '">';
		attachmentHtml += '<a href="' + themeDisplay.getLayoutURL() + '/-/mail/attachment?accountEntryId=' + instance.getCurrentAccountEntryId() + '&attachmentId=' + attachmentId + '" target="_blank">' + attachmentFilename + '</a> - ' + attachmentSize;
		attachmentHtml += '<a href="javascript:;" class="delete-attachment">' + Liferay.Language.get('remove') + '</a>';
		attachmentHtml += '</div>';

		instance.sendAttachmentsDiv.prepend(attachmentHtml);

		if (pseudoForwardedAttachment) {

			// Add messageId and attachmentId to hidden input field

			instance.sendForwardMessageIdHidden.val(messageId);
			instance.sendForwardAttachmentIdsHidden.val(instance.sendForwardAttachmentIdsHidden.val() + attachmentId + ',');
		}
	},
	
	addAttachmentInputField: function() {
		var instance = this;

		// Add attachment input

		var newAttachmentId = instance.namespace + 'sendAttachment' + (instance.getAttachmentCount() + 1);

		var newAttachmentHtml = '<table class="attachment-row"><tr>';
		newAttachmentHtml += '<td><input class="attachment-input" id="' + newAttachmentId + '" name="' + newAttachmentId + '" size="50" type="file" /></td>';
		newAttachmentHtml += '<td><a href="javascript:;" class="remove-attachment">' + Liferay.Language.get('remove') + '</a></td>';
		newAttachmentHtml += '</tr></table>';

		instance.sendAttachmentsDiv.append(newAttachmentHtml);

		// Refresh event handler

		jQuery('.remove-attachment').click(function() {
			jQuery(this).parents('.attachment-row').html('').hide();
		});

		// Update attachment count

		instance.setAttachmentCount(instance.getAttachmentCount() + 1);
	},

	autoRefresh: function() {
		var instance = this;

		// Start background processes

		instance.autoRefreshAccountEntries();
		instance.autoRefreshMessages(true);
		instance.autoRefreshFolders();
		setTimeout('Liferay.Mail.autoSaveMessageDraft()', 10000);
	},

	autoRefreshAccountEntries: function() {
		var instance = this;

		if (instance.sessionExpirationCheck()) {
			return false;
		}

		instance.loadAccountEntries();

		if (themeDisplay.isSignedIn()) {
			setTimeout('Liferay.Mail.autoRefreshAccountEntries()', 300000);
		}
	},

	autoRefreshMessages: function(recursive) {
		var instance = this;

		if (instance.sessionExpirationCheck()) {
			return false;
		}

		if ((instance.getCurrentAccountEntryId() !== null) && (instance.getCurrentFolderId() !== null)) {
			if (instance.getView() == 'viewFolder') {
				instance.loadMessages(instance.getSelectedMessageIds(), true);
			}
		}

		if (recursive && themeDisplay.isSignedIn()) {
			setTimeout('Liferay.Mail.autoRefreshMessages(true)', 60000);
		}
	},

	autoRefreshFolders: function() {
		var instance = this;

		if (instance.sessionExpirationCheck()) {
			return false;
		}

		var accountEntryId = instance.getCurrentAccountEntryId();

		if ((accountEntryId !== null) && (!instance.isAccountEntryInitialized(accountEntryId))) {
			instance.loadFolders();

			setTimeout('Liferay.Mail.loadFolders()', 5000);
		}
	},

	autoSaveMessageDraft: function() {
		var instance = this;

		if (instance.sessionExpirationCheck()) {
			return false;
		}

		// If viewing draft and it has changed, autosave message

		if (instance.getCurrentAccountEntryId() !== null) {
			if (instance.isComposingMessage()) {
				if (instance.isMessageModifiedSinceLastSave()) {
					if (!instance._lockSaveAndSend) {
						instance.saveMessage();
					}
				}
			}
		}

		if (themeDisplay.isSignedIn()) {
			setTimeout('Liferay.Mail.autoSaveMessageDraft()', 30000);
		}
	},

	clearIncomingMessage: function() {
		var instance = this;

		instance.setCurrentMessage('');

		instance.readFromSpan.html('');
		instance.readReplyToSpan.html('');
		instance.readToSpan.html('');
		instance.readDateSpan.html('');
		instance.readSubjectSpan.html('');
		instance.readMailedBySpan.html('');
		instance.readBodySpan.html('');
	},

	clearMessages: function() {
		var instance = this;

		instance.setTotalPages(0);
		instance.setTotalMessages(0);
		instance.clearStatus();

		if ((instance.getCurrentFolderId() === '') || instance.getCurrentFolderId() === null) {
			instance.messageListTable.html('<tr><td class="alert">' + Liferay.Language.get('you-have-successfully-added-a-new-email-account') + '</td></tr>');
		}
		else {
			instance.messageListTable.html('<tr><td class="alert">' + Liferay.Language.get('no-messages-found') + '</td></tr>');
		}

		instance.refreshFolderControls();
	},

	clearOutgoingMessage: function() {
		var instance = this;

		instance.messageOptionsRespondDivs.removeClass('selected-response-type results-header');

		instance.sendBccInput.val('');
		instance.sendCcInput.val('');
		instance.sendDraftMessageIdHidden.val('');
		instance.sendSubjectInput.val('');
		instance.sendToInput.val('');

		// Reset editor

		instance.setEditorHTML('');
		instance._oldDraftMessageSummary = null;
		instance.sendBodySpan.hide();

		// Reset attachment input fields

		instance.setAttachmentCount(0);
		instance.sendAttachmentsDiv.html('');

		instance.sendForwardAttachmentIdsHidden.val('');
		instance.sendForwardMessageIdHidden.val('');
	},

	clearStatus: function() {
		var instance = this;

		instance.statusDiv.find('.message').fadeOut('slow');
	},

	deleteMessages: function(messageIds, preMessage, success) {
		var instance = this;

		instance.setStatus('info', preMessage);

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/messages_delete_by_id',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					folderId: instance.getCurrentFolderId(),
					messageIds: messageIds
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: success,
				type: 'POST'
			}
		);
	},

	generateDraftMessageSummary: function(body, subject, to) {
		var instance = this;

		if (body === null) {
			return null;
		}

		return body + subject + to;
	},

	getAccountEntry: function(accountEntryId) {
		var instance = this;

		if ((instance._jsonAccountEntries === null) || (instance._jsonAccountEntries === '')) {
			return null;
		}

		for (i = 0; i < instance._jsonAccountEntries.length; i++) {
			var accountEntry = instance._jsonAccountEntries[i];

			if (accountEntry.accountEntryId == accountEntryId) {
				return accountEntry;
			}
		}

		return null;
	},

	getAttachmentCount: function() {
		var instance = this;

		return parseInt(instance.sendAttachmentCount.val());
	},

	getCurrentAccountEntryId: function() {
		var instance = this;

		return instance._currentAccountEntryId;
	},

	getCurrentAccountEntry: function() {
		var instance = this;

		if ((instance._jsonAccountEntries === null) || (instance._jsonAccountEntries === '')) {
			return null;
		}

		for (i = 0; i < instance._jsonAccountEntries.length; i++) {
			var accountEntry = instance._jsonAccountEntries[i];

			if (accountEntry.accountEntryId == instance.getCurrentAccountEntryId()) {
				return accountEntry;
			}
		}

		return null;
	},

	getCurrentFolder: function() {
		var instance = this;

		if ((instance._jsonFolders === null) || (instance._jsonFolders === '')) {
			return null;
		}

		for (i = 0; i < instance._jsonFolders.folders.length; i++) {
			var folder = instance._jsonFolders.folders[i];

			if (folder.folderId == instance.getCurrentFolderId()) {
				return folder;
			}
		}

		return null;
	},

	getCurrentFolderId: function() {
		var instance = this;

		return instance._currentFolderId;
	},

	getCurrentMessage: function() {
		var instance = this;

		return instance._currentMessage;
	},

	getCurrentMessages: function() {
		var instance = this;

		return instance._jsonMessages;
	},

	getCurrentPageNumber: function() {
		var instance = this;

		return instance._currentPageNumber;
	},

	getDraftMessageSummary: function() {
		var instance = this;

		if (!instance.getEditorInitialized() || instance.getEditorHTML() == '') {
			return null;
		}

		return instance.generateDraftMessageSummary(
			instance.getEditorHTML(), instance.sendSubjectInput.val(),
			instance.sendToInput.val());
	},

	getEditorHTML: function() {
		var instance = this;

		if (instance.getEditorInitialized()) {
			return instance.sendBodyEditor.getHTML();
		}
		else {
			return '';
		}
	},

	getEditorInitialized: function() {
		var instance = this;

		return instance._editorInitialized;
	},

	getFirstMessageNumOnPage: function() {
		var instance = this;

		return (instance.getCurrentPageNumber() - 1) * instance.getMessagesPerPage() + 1;
	},

	getInitialDraftMessageSummary: function() {
		var instance = this;

		return instance._initialDraftMessageSummary;
	},

	getLastMessageNumOnPage: function() {
		var instance = this;

		if (instance.getTotalPages() == instance.getCurrentPageNumber()) {
			return instance.getTotalMessages();
		}
		else {
			return instance.getCurrentPageNumber() * instance.getMessagesPerPage();
		}
	},

	getLocalizedFolderName: function(folder) {
		var instance = this;

		var folderName = folder.name;
		var folderNameLowerCase = folderName.toLowerCase();

		if (folderNameLowerCase == 'inbox'
				|| folderNameLowerCase == 'drafts'
				|| folderNameLowerCase == 'sent messages'
				|| folderNameLowerCase == 'trash') {

			folderName = Liferay.Language.get(folderNameLowerCase.replace(' ', '-'));
		}

		return folderName;
	},

	getMessageResponseType: function() {
		var instance = this;

		return instance._messageResponseType;
	},

	getMessagesPerPage: function() {
		var instance = this;

		return instance._messagesPerPage;
	},

	getOldDraftMessageSummary: function() {
		var instance = this;

		return instance._oldDraftMessageSummary;
	},

	getSearchString: function() {
		var instance = this;

		if (instance.isSearchMode()) {
			return instance.searchTextInput.val();
		}
		else {
			return '';
		}
	},

	getSelectedMessageIds: function() {
		var instance = this;

		var checkedBoxes = jQuery('.message-checkbox:checked');
		var messageIds = '';

		jQuery.each(checkedBoxes, function() {
			messageIds += jQuery(this).parents('.message:first').attr('messageId') + ',';
		});

		return messageIds;
	},

	getTotalMessages: function() {
		var instance = this;

		return instance._totalMessages;
	},

	getTotalPages: function() {
		var instance = this;

		return instance._totalPages;
	},

	getView: function() {
		var instance = this;

		return instance._currentView;
	},

	isAccountEntryInitialized: function(accountEntryId) {
		var instance = this;

		for (i = 0; i < instance._jsonAccountEntries.length; i++) {
			var accountEntry = instance._jsonAccountEntries[i];

			var tempAccountEntryId = accountEntry.accountEntryId;

			if (tempAccountEntryId == accountEntryId) {
				return accountEntry.initialized;
			}
		}

		return false;
	},

	isCurrentFolderDraftFolder: function() {
		var instance = this;

		var currentFolderId = instance.getCurrentFolderId();
		var draftFolderId = instance.getCurrentAccountEntry().draftFolderId;

		return (currentFolderId == draftFolderId);
	},

	isCurrentFolderSentFolder: function() {
		var instance = this;

		var currentFolderId = instance.getCurrentFolderId();
		var sentFolderId = instance.getCurrentAccountEntry().sentFolderId;

		return (currentFolderId == sentFolderId);
	},

	isComposingMessage: function() {
		var instance = this;

		var viewMode = instance.getView();

		if (viewMode == 'replyOrForwardMessage') {
			return true;
		}
		else if (viewMode == 'composeMessage') {
			return true;
		}
		else if (viewMode == 'editMessageDraft') {
			return true;
		}

		return false;
	},

	isMessageModifiedSinceInitialLoad: function() {
		var instance = this;

		// Check if editor is ready

		if (instance.getDraftMessageSummary() === null) {
			return false;
		}

		// Check if initial message has been set

		var summary = instance.getDraftMessageSummary();

		if (instance.getInitialDraftMessageSummary() === null) {
			instance.setInitialDraftMessageSummary(summary);
			instance.setOldDraftMessageSummary(summary);

			return false;
		}

		// Check if current message is different than initial message

		if (instance.getInitialDraftMessageSummary() !== summary) {
			return true;
		}

		return false;
	},

	isMessageModifiedSinceLastSave: function() {
		var instance = this;

		if (instance.isMessageModifiedSinceInitialLoad()) {
			var summary = instance.getDraftMessageSummary();

			if (instance.getOldDraftMessageSummary() !== summary) {
				return true;
			}
		}

		return false;
	},

	isMessageSaved: function() {
		var instance = this;

		// Only auto populate if not saved and not modified

		if (instance.sendDraftMessageIdHidden.val() != '') {
			return true;
		}

		return false;
	},

	isSearchMode: function() {
		var instance = this;

		return instance._isSearchMode;
	},

	loadAccountEntries: function() {
		var instance = this;

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/account_entries',
				data: {
					includePrivateAccountEntry: true
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonAccountEntries) {
					instance.loadJSONAccountEntries(jsonAccountEntries);
				},
				type: 'POST'
			}
		);
	},

	loadContacts: function() {
 		var instance = this;

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/contacts',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId()
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonContacts) {
					instance.loadJSONContacts(jsonContacts);
				},
				type: 'POST'
			}
		);
	},

	loadColumnSorting: function() {
		var instance = this;

		var columnSortingTableRow = [];

		var addressOrderByClass = '';
		var subjectOrderByClass = '';
		var dateOrderByClass = '';
		var sizeOrderByClass = '';

		if (instance._orderByField == instance._orderByAddress) {
			if (instance._orderByType == 'asc') {
				addressOrderByClass = 'arrow-asc';
			}
			else {
				addressOrderByClass = 'arrow-desc';
			}
		}
		else if (instance._orderByField == instance._orderBySubject) {
			if (instance._orderByType == 'asc') {
				subjectOrderByClass = 'arrow-asc';
			}
			else {
				subjectOrderByClass = 'arrow-desc';
			}
		}
		else if (instance._orderByField == instance._orderByDate) {
			if (instance._orderByType == 'asc') {
				dateOrderByClass = 'arrow-asc';
			}
			else {
				dateOrderByClass = 'arrow-desc';
			}
		}
		else if (instance._orderByField == instance._orderBySize) {
			if (instance._orderByType == 'asc') {
				sizeOrderByClass = 'arrow-asc';
			}
			else {
				sizeOrderByClass = 'arrow-desc';
			}
		}

		columnSortingTableRow.push('<tr>');
		columnSortingTableRow.push('<td class="message-col-1">&nbsp;</td>');
		columnSortingTableRow.push('<td class="message-col-2">&nbsp;</td>');

		if (instance.isCurrentFolderSentFolder()) {
			columnSortingTableRow.push('<td class="message-col-3 column-sorter ' + addressOrderByClass + '" orderByField="' + instance._orderByAddress + '" orderByType="asc" title="' + Liferay.Language.get("click-to-sort-by-address") + '">' + Liferay.Language.get("to") + '</td>');
		}
		else {
			columnSortingTableRow.push('<td class="message-col-3 column-sorter ' + addressOrderByClass + '" orderByField="' + instance._orderByAddress + '" orderByType="asc" title="' + Liferay.Language.get("click-to-sort-by-address") + '">' + Liferay.Language.get("from") + '</td>');
		}

		columnSortingTableRow.push('<td class="message-col-4 column-sorter ' + subjectOrderByClass + '" orderByField="' + instance._orderBySubject + '" orderByType="asc" title="' + Liferay.Language.get("click-to-sort-by-subject") + '">' + Liferay.Language.get("subject") + '</td>');
		columnSortingTableRow.push('<td class="message-col-5 column-sorter ' + dateOrderByClass + '" orderByField="' + instance._orderByDate + '" orderByType="desc" title="' + Liferay.Language.get("click-to-sort-by-date") + '">' + Liferay.Language.get("date") + '</td>');
		columnSortingTableRow.push('<td class="message-col-6 column-sorter ' + sizeOrderByClass + '" orderByField="' + instance._orderBySize + '" orderByType="asc" title="' + Liferay.Language.get("click-to-sort-by-size") + '">' + Liferay.Language.get("size") + '</td>');
		columnSortingTableRow.push('</tr>');

		instance.messageListTable.prepend(columnSortingTableRow.join(''));
	},

	loadCompleteAccountEntryAction: function(selectedAccountEntryId) {
		var instance = this;

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/startup_data',
				data: {
					initialAccountEntryId: selectedAccountEntryId
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonResult) {

					// Load account entries

					instance.setCurrentAccountEntryId(jsonResult.initialAccountEntryId, false);
					instance.loadJSONAccountEntries(jsonResult.accountEntries);

					// Load addresses

					instance.loadContacts();

					// Load folders

					instance.setCurrentFolderId(instance.getCurrentAccountEntry().inboxFolderId);
					instance.loadJSONFolders(jsonResult.folders);

					// Load messages

					instance.setCurrentPageNumber(1);
					instance.loadJSONMessages(jsonResult.messages, '', true);

					instance.setView('viewFolder');
					instance.clearStatus();

					// Initial quick refresh

					if (instance.getCurrentAccountEntry().requiresSynchronization) {
						setTimeout('Liferay.Mail.autoRefreshMessages(false)', 5000);
						setTimeout('Liferay.Mail.autoRefreshMessages(false)', 10000);
						setTimeout('Liferay.Mail.autoRefreshMessages(false)', 15000);
						setTimeout('Liferay.Mail.autoRefreshMessages(false)', 20000);
						setTimeout('Liferay.Mail.autoRefreshMessages(false)', 25000);
					}
				},
				type: 'POST'
			}
		);
	},

	loadCompleteAccountEntryPreAction: function(accountEntryId) {
		var instance = this;

		instance.setStatus('info', Liferay.Language.get('loading-account'));

		var accountEntry = instance.getAccountEntry(accountEntryId);

		if (accountEntry.passwordSaved) {
			instance.loadCompleteAccountEntryAction(accountEntryId);
		}
		else {

			// Check if password has been saved in session

			jQuery.ajax(
				{
					url: themeDisplay.getLayoutURL() + '/-/mail/password_saved',
					data: {
						accountEntryId: accountEntryId
					},
					dataType: 'json',
					error: function (XMLHttpRequest, textStatus, errorThrown) {
						instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
					},
					success: function(jsonResult) {
						if (jsonResult) {
							instance.loadCompleteAccountEntryAction(accountEntryId);
						}
						else {
							instance.promptForPassword(accountEntryId);

							instance.setStatus('info', Liferay.Language.get('password-required'));
						}
					},
					type: 'POST'
				}
			);
		}

		return false;
	},

	loadFolders: function() {
 		var instance = this;

		var tempAccountEntryId = instance.getCurrentAccountEntryId();

		if (tempAccountEntryId === null || tempAccountEntryId === '') {
			return;
		}

		// Get JSON

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/folders',
				data: {
					accountEntryId: tempAccountEntryId
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonResult) {
					instance.loadJSONFolders(jsonResult);
				},
				type: 'POST'
			}
		);
	},

	loadJSONAccountEntries: function(jsonAccountEntries) {
		var instance = this;

		instance._jsonAccountEntries = jsonAccountEntries.accountEntries;

		// Prompt user to setup account entries if none are configured

		if (jsonAccountEntries.accountEntries.length === 0) {
			jQuery('.has-accounts').hide();
			jQuery('.has-no-accounts').show();

			return false;
		}
		else {
			jQuery('.has-accounts').show();
			jQuery('.has-no-accounts').hide();
		}

		// Parse JSON

		var htmlAccountEntryList = [];

		for (i = 0; i < jsonAccountEntries.accountEntries.length; i++) {
			var accountEntry = jsonAccountEntries.accountEntries[i];

			htmlAccountEntryList.push('<option value="');
			htmlAccountEntryList.push(accountEntry.accountEntryId);

			if (instance.getCurrentAccountEntryId() == accountEntry.accountEntryId) {
				htmlAccountEntryList.push('" selected="selected" >');
			}
			else {
				htmlAccountEntryList.push('">');
			}

			htmlAccountEntryList.push(accountEntry.messageAddress);
			htmlAccountEntryList.push('</option>');

			// Auto update accounts

			instance.sendUpdateMessage(accountEntry.accountEntryId);
		}

		// Inject HTML

		instance.accountEntrySelectionSelect.html(htmlAccountEntryList.join(''));
	},

	loadJSONContacts: function(jsonContacts) {
		var instance = this;

		instance._jsonContacts = jsonContacts;

		// Contact management

		var htmlContactManagementList = [];

		if (jsonContacts.contacts.length == 0) {
			htmlContactManagementList.push('<table class="alert"><tr><td>' + Liferay.Language.get('you-have-no-contacts') + '</td></tr></table>');
		}
		else {
			htmlContactManagementList.push('<table>');
			htmlContactManagementList.push('<tr class="contact">');
			htmlContactManagementList.push('<th class="message-address">' + Liferay.Language.get('message-address') + '</th>');
			htmlContactManagementList.push('<th class="name">' + Liferay.Language.get('name') + '</th>');
			htmlContactManagementList.push('<td></td>');
			htmlContactManagementList.push('<td></td>');
			htmlContactManagementList.push('</tr>');

			for (i = 0; i < jsonContacts.contacts.length; i++) {
				var contact = jsonContacts.contacts[i];

				var contactId = contact.contactId

				if (contactId == '') {
					continue;
				}

				var name = contact.name;
				var messageAddress = contact.messageAddress;

				htmlContactManagementList.push('<tr class="contact" contactId="' + contactId + '" contactMessageAddress="' + messageAddress + '" contactName="' + name + '">');
				htmlContactManagementList.push('<td class="message-address">' + messageAddress + '</td>');
				htmlContactManagementList.push('<td class="name">' + name + '</td>');
				htmlContactManagementList.push('<td class="edit"><a class="edit-contact" href="javascript:;"><span class="icon-edit-contact">' + Liferay.Language.get('edit') + '</span></a></td>');
				htmlContactManagementList.push('<td class="delete"><a class="delete-contact" href="javascript:;"><span class="icon-delete-contact">' + Liferay.Language.get('delete') + '</span></a></td>');
				htmlContactManagementList.push('</tr>');
			}

			htmlContactManagementList.push('</table>');
		}

		instance.manageContactsListing.html(htmlContactManagementList.join(''));

		// Autocomplete

		instance.sendToInput.autocomplete('destroy');
		instance.sendCcInput.autocomplete('destroy');
		instance.sendBccInput.autocomplete('destroy');

		var options = {
			source: function() {
				this.width = instance.sendToInput.width();
				var autocompleteItems = jsonContacts.contacts;

				var terms = [];

				for (i = 0; i < autocompleteItems.length; i++) {
					var itemValue = autocompleteItems[i].name + ' <' + autocompleteItems[i].messageAddress + '>';
					var itemEscaped = autocompleteItems[i].name + ' &lt;' + autocompleteItems[i].messageAddress + '&gt;';

					terms.push({ data: itemEscaped, result: itemValue, value: itemValue });
				}

				return terms;
			},
			width: instance.sendToInput.width(),
			formatItem: function(row, i, max, resultOriginal, term) {
				var re = new RegExp(term, 'i');

				if(!re.test(resultOriginal)) {
					 return false;
				}

				return row;
			},
			dataType: 'json',
			delay: 0,
			multiple: true,
			multipleSeparator: ',',
			cacheLength: 1,
			minChars: 1,
			hide: function(event, ui) {
				jQuery(this).removeClass('showing-list');
			},
			show: function(event, ui) {
				jQuery(this).addClass('showing-list');
				this._LFR_listShowing = true;
			},
			result: function(event, ui) {
				var caretPos = this.value.length;

				if (this.createTextRange) {
					var textRange = this.createTextRange();

					textRange.moveStart('character', caretPos);
					textRange.select();
				}
				else if (this.selectionStart) {
					this.selectionStart = caretPos;
					this.selectionEnd = caretPos;
				}
			}
		}

		instance.sendToInput.autocomplete(options);
		instance.sendCcInput.autocomplete(options);
		instance.sendBccInput.autocomplete(options);
	},

	loadJSONFolders: function(jsonFolders) {
		var instance = this;

		// Save folders in variable

		if ((jsonFolders !== null) && (jsonFolders !== '')) {
			instance._jsonFolders = jsonFolders;
		}

		var jsonAccountEntry = instance.getCurrentAccountEntry();

		// Parse JSON

		var htmlFolderExplorerTopList = [];
		var htmlFolderExplorerBottomList = [];
		var htmlFolderMessageMoverList = '';
		var htmlFolderManagementList = [];

		htmlFolderManagementList.push('<table>');
		htmlFolderManagementList.push('<tr class="folder">');
		htmlFolderManagementList.push('<th class="name">' + Liferay.Language.get('folder-name') + '</th>');
		htmlFolderManagementList.push('<td></td>');
		htmlFolderManagementList.push('<td></td>');
		htmlFolderManagementList.push('</tr>');

		for (i = 0; i < jsonFolders.folders.length; i++) {
			var folder = jsonFolders.folders[i];
			var folderLocalizedName = instance.getLocalizedFolderName(folder);
			var folderId = folder.folderId;

			// Folder explorer

			var newMessageCountHTML = '';

			if (folder.newMessageCount != 0) {
				newMessageCountHTML = ' (' + folder.newMessageCount + ')';
			}

			var htmlFolderExplorerRow = [];

			htmlFolderExplorerRow.push('<div class="folder" folderId="' + folderId + '"><a class="');

			if (folderId == jsonAccountEntry.inboxFolderId) {
				htmlFolderExplorerRow.push('icon-inbox');
			}
			else if (folderId == jsonAccountEntry.draftFolderId) {
				htmlFolderExplorerRow.push('icon-draft');
			}
			else if (folderId == jsonAccountEntry.sentFolderId) {
				htmlFolderExplorerRow.push('icon-sent');
			}
			else if (folderId == jsonAccountEntry.trashFolderId) {
				htmlFolderExplorerRow.push('icon-trash');
			}
			else {
				htmlFolderExplorerRow.push('icon-folder');
			}

			htmlFolderExplorerRow.push('" href="javascript:;">' + folderLocalizedName + newMessageCountHTML + '</span></a></div>');

			if (folderId == jsonAccountEntry.inboxFolderId) {
				htmlFolderExplorerTopList.push(htmlFolderExplorerRow.join(''));
			}
			else {
				htmlFolderExplorerBottomList.push(htmlFolderExplorerRow.join(''));
			}

			// Message mover

			var htmlFolderMessageMover = '<option value="' + folderId + '">- ' + folderLocalizedName + '</option>';

			if (folderId == jsonAccountEntry.inboxFolderId) {
				htmlFolderMessageMoverList = htmlFolderMessageMover + htmlFolderMessageMoverList;
			}
			else {
				htmlFolderMessageMoverList = htmlFolderMessageMoverList + htmlFolderMessageMover;
			}

			// Folder management

			htmlFolderManagementList.push('<tr class="folder" folderId="' + folderId + '" folderName="' + folder.name + '">');
			htmlFolderManagementList.push('<td class="name">' + folderLocalizedName + '</td>');
			htmlFolderManagementList.push('<td class="rename"><a class="rename-folder" href="javascript:;"><span class="icon-rename-folder">' + Liferay.Language.get('rename') + '</span></a></td>');
			htmlFolderManagementList.push('<td class="delete"><a class="delete-folder" href="javascript:;"><span class="icon-delete-folder">' + Liferay.Language.get('delete') + '</span></a></td>');
			htmlFolderManagementList.push('</tr>');
		}

		htmlFolderManagementList.push('</table>');

		// Inject HTML

		instance.foldersDiv.html(htmlFolderExplorerTopList.join('') + htmlFolderExplorerBottomList.join(''));
		instance.folderControlsMessageMover.html('<option value="none">' + Liferay.Language.get("move-to") + '</option>' + htmlFolderMessageMoverList);
		instance.manageFoldersListing.html(htmlFolderManagementList.join(''));

		// Refresh UI

		instance.refreshNavigationHighlighting();
	},

	loadJSONMessage: function() {
		var instance = this;

		var message = instance.getCurrentMessage();

		instance.setCurrentFolderId(message.folderId);
		instance.clearStatus();

		// Parse JSON object

		var messageId = message.messageId;
		var messageFrom = message.from;
		var messageTo = message.to;
		var messageCc = message.cc;
		var messageBcc = message.bcc;
		var messageSubject = message.subject;
		var messageBody = message.body;
		var messageBodyPlain = message.bodyPlain;
		var messageFullDate = message.fullDate;
		var messageDate = message.date;
		var messageSize = message.size;
		var messageHasAttachments = message.attachments;
		var messageAttachmentSummary = message.attachmentSummary;

		if (!instance.isCurrentFolderDraftFolder()) {

			// Add links to attachments

			if (messageHasAttachments) {
				if (messageAttachmentSummary.length > 0) {
					messageBody += '<br /><hr />' + messageAttachmentSummary.length + ' ' + Liferay.Language.get('attachments') + '<br /><ul>';

					for (i = 0; i < messageAttachmentSummary.length; i++) {
						var attachmentFilename = messageAttachmentSummary[i].filename;
						var attachmentId = messageAttachmentSummary[i].attachmentId;
						var attachmentSize = messageAttachmentSummary[i].size;

						messageBody += '<li><a href="' + themeDisplay.getLayoutURL() + '/-/mail/attachment?accountEntryId=' + instance.getCurrentAccountEntryId() + '&attachmentId=' + attachmentId + '" target="_blank">' + attachmentFilename + '</a> - ' + attachmentSize;
					}

					messageBody += '</ul>';
				}
			}

			// Inject HTML

			instance.readFromSpan.html(messageFrom);
			instance.readReplyToSpan.html('-');
			instance.readToSpan.html(messageTo);
			instance.readCcSpan.html(messageCc);
			instance.readDateSpan.html(messageFullDate);
			instance.readSubjectSpan.html(messageSubject);
			instance.readMailedBySpan.html('-');
			instance.readBodySpan.html(messageBody);

			// Links open in a new window

			instance.readBodySpan.find('a').attr('target', '_blank');
		}
		else {

			// Load draft

			instance.sendBccInput.val(messageBcc);
			instance.setEditorHTML(messageBody);
			instance.sendCcInput.val(messageCc);
			instance.sendDraftMessageIdHidden.val(messageId);
			instance.sendSubjectInput.val(messageSubject);
			instance.sendToInput.val(messageTo);

			instance._oldDraftMessageSummary = null;
		}

		instance.refreshMessageAttachments();

		// Update "back to [foldername]" link

		if (instance.isSearchMode())
		{
			jQuery('.message-controls .folder-name').html(Liferay.Language.get('search-results'));
		}
		else {
			jQuery('.message-controls .folder-name').html(instance.getLocalizedFolderName(instance.getCurrentFolder()));
		}

		// Update message navigation

		instance.refreshMessageControlsNavigation();

		// Update read status

		if (message.flags.indexOf(',' + instance._flagSeen + ',') == -1) {
			instance.setMessageFlags(messageId, instance._flagSeen, 'true', true);
		}
	},

	loadJSONMessages: function(jsonMessages, preSelectedMessageIds, silentUpdate) {
		var instance = this;

		if (jsonMessages == null) {
			return;
		}

		instance.setTotalPages(jsonMessages.pageCount);
		instance.setTotalMessages(jsonMessages.messageCount);
		instance.setCurrentMessages(jsonMessages.messages);

		if (!silentUpdate) {
			instance.clearStatus();
		}

		// Parse JSON

		var htmlMessageList = '';

		if (jsonMessages.messages.length === 0) {

			// Display appropriate message indicating there are no messages

			if (instance.getCurrentFolder() === null) {
				htmlMessageList += '<tr><td class="alert">' + Liferay.Language.get('loading-messages') + '</td></tr>';
			}
			else if (instance.getCurrentFolder().percentageDownloaded === 100) {
				htmlMessageList += '<tr><td class="alert">' + Liferay.Language.get('loading-messages') + '</td></tr>';
			}
			else if (instance.isSearchMode() || (instance.getCurrentFolder().messageCount === 0)) {
				htmlMessageList += '<tr><td class="alert">' + Liferay.Language.get('no-messages-found') + '</td></tr>';
			}
			else {
				htmlMessageList += '<tr><td class="alert">' + Liferay.Language.get('x-of-the-emails-in-this-folder-have-been-downloaded', [instance.getCurrentFolder().percentageDownloaded]) + '</td></tr>';
			}
		}
		else {

			// Display message listing

			var viewingSentFolder = false;

			if (instance.isCurrentFolderSentFolder()) {
				viewingSentFolder = true;
			}

			for (i = 0; i < jsonMessages.messages.length; i++) {
				var message = jsonMessages.messages[i];
				var checkedHtml = '';

				if (preSelectedMessageIds.indexOf(message.messageId + ',') != -1) {
					checkedHtml = ' checked="checked" ';
				}

				// Add 'read' and 'unread' flags

				var flagClasses = '';

				if (message.flags.indexOf(',' + instance._flagSeen + ',') != -1) {
					flagClasses += ' alt read ';
				}
				else {
					flagClasses += ' unread ';
				}

				if (message.flags.indexOf(',' + instance._flagFlagged + ',') != -1) {
					flagClasses += ' flagged ';
				}

				// Add 'attachment' icon

				var attachmentHtml = '';

				if (message.attachments) {
					attachmentHtml = '<div class="icon-attachment">&nbsp;</div>';
				}

				htmlMessageList += '<tr class="message results-row ' + flagClasses + '" messageId="' + message.messageId + '" messageNumber="' + message.messageNumber + '">';

				htmlMessageList += '	<td class="message-col-1"><input type="checkbox" ' + checkedHtml + ' class="message-checkbox" /></td>';
				htmlMessageList += '	<td class="message-col-2">' + attachmentHtml + '</td>';

				if (viewingSentFolder) {
					htmlMessageList += '	<td><div class="message-col-3"><span class="message-to">' + message.to + '</span></div></td>';
				}
				else {
					htmlMessageList += '	<td><div class="message-col-3"><span class="message-from">' + message.from + '</span></div></td>';
				}

				htmlMessageList += '	<td><div class="message-col-4"><span class="message-subject">' + message.subject + '</span> - <span class="message-body-preview">' + message.bodyPreview + '</span></div></td>';
				htmlMessageList += '	<td><div class="message-col-5"><span class="message-date">' + message.date + '</span></div></td>';
				htmlMessageList += '	<td><div class="message-col-6"><span class="message-size">' + message.size + '</span></div></td>';
				htmlMessageList += '</tr>';
			}
		}

		// Inject HTML

		instance.messageListTable.html(htmlMessageList);

		// Refresh html and event handlers

		if (jsonMessages.messages.length > 0) {
			instance.loadColumnSorting();
		}

		instance.refreshFolderControls();
		instance.loadFolders();
		instance.setView('viewFolder');
	},

	loadMessageId: function(messageId, silentUpdate) {
		var instance = this;

		instance.clearOutgoingMessage();

		if (!silentUpdate) {
			instance.setStatus('info', Liferay.Language.get('loading-message'));
		}

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/message',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					messageId: messageId
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonMessage) {
					if (jsonMessage !== null) {
						instance.setCurrentMessage(jsonMessage);

						instance.refreshMessageAttachments();

						if (!silentUpdate) {
							instance.loadJSONMessage();
						}
					}
				},
				type: 'POST'
			}
		);
	},

	loadMessageIdDelayed: function(messageId, silentUpdate) {
		var instance = this;

		setTimeout('Liferay.Mail.loadMessageId("' + messageId + '","' + silentUpdate + '")', 500);
	},

	loadMessageNumber: function(currentMessageNumber, offset, silentUpdate) {
		var instance = this;

		instance.clearOutgoingMessage();
		
		if (!silentUpdate) {
			instance.setStatus('info', Liferay.Language.get('loading-message'));
		}

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/message_number',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					folderId: instance.getCurrentFolderId(),
					messageNumber: currentMessageNumber,
					offset: offset,
					orderByField: instance._orderByField,
					orderByType: instance._orderByType,
					searchString: instance.getSearchString()
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonMessage) {
					if (jsonMessage !== null) {
						instance.setCurrentMessage(jsonMessage);

						if (!silentUpdate) {
							instance.loadJSONMessage();
						}
					}
				},
				type: 'POST'
			}
		);
	},

	loadMessages: function(preSelectedMessageIds, silentUpdate) {
		var instance = this;

		// Get JSON

		if (!silentUpdate) {
			instance.setStatus('info', Liferay.Language.get('loading-messages'));
		}

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/messages',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					folderId: instance.getCurrentFolderId(),
					pageNumber: instance.getCurrentPageNumber(),
					messagesPerPage: instance.getMessagesPerPage(),
					orderByField: instance._orderByField,
					orderByType: instance._orderByType,
					searchString: instance.getSearchString()
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonMessages) {
					instance.loadJSONMessages(jsonMessages, preSelectedMessageIds, silentUpdate);
				},
				type: 'POST'
			}
		);
	},

	loadMessagesDelayed: function(preSelectedMessageIds, silentUpdate, delay) {
		var instance = this;

		setTimeout('Liferay.Mail.loadMessages("' + preSelectedMessageIds + '","' + silentUpdate + '")', delay * 1000);
	},

	lockSaveAndSend: function() {
		var instance = this;

		instance.messageSendSaveButton.attr("disabled", true);
		instance.messageSendSendButton.attr("disabled", true);

		instance._lockSaveAndSend = true;
	},

	unlockSaveAndSend: function() {
		var instance = this;

		instance.messageSendSaveButton.removeAttr("disabled");
		instance.messageSendSendButton.removeAttr("disabled");

		instance._lockSaveAndSend = false;
	},

	moveMessages: function(messageIds, sourceFolderId, destinationFolderId) {
		var instance = this;

		instance.setStatus('info', Liferay.Language.get('moving-messages'));

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/move_messages',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					destinationFolderId: destinationFolderId,
					messageIds: messageIds,
					sourceFolderId: sourceFolderId
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonResult) {
					if (jsonResult.success) {
						instance.loadMessagesDelayed('', false, .5);

						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}
				},
				type: 'POST'
			}
		);
	},

	promptForPassword: function(accountEntryId) {
 		var instance = this;

 		var accountEntry = instance.getAccountEntry(accountEntryId);
 		var actionURL = Liferay.PortletURL.createActionURL();

 		actionURL.setPortletId('1_WAR_mailportlet');
 		actionURL.setName('storePasswordInSession');
 		actionURL.setWindowState('MAXIMIZED');

 		var title = Liferay.Language.get('password');
 		var contents =
			'<div>' +
				'<form action="' + actionURL + '" method="post" id="' + instance.namespace + 'promptForPasswordFm">' +
					'<input name="' + instance.namespace + 'accountEntryId" type="hidden" value="' + accountEntryId + '" />' +
					'<div id="' + instance.namespace + 'promptForPasswordStatus" style="display: none;"></div>' +
					Liferay.Language.get('please-enter-the-password-for') + ' ' + accountEntry.messageAddress + '"<br /><br />' +
					Liferay.Language.get('password') + ' ' + '<input id="' + instance.namespace + 'passwordPrompt" name="' + instance.namespace + 'password" type="password" value="" /> ' +
					'<input type="submit" value="' + Liferay.Language.get("submit") + '" />' +
				'</form>' +
			'</div>';

		var popup = Liferay.Popup({
			title: title,
			draggable: true,
			handles: '',
			message: contents,
			noCenter: false,
			onClose: function() {
				if (instance.getCurrentAccountEntryId() === null) {
					var renderURL = Liferay.PortletURL.createRenderURL();

					renderURL.setPortletId('1_WAR_mailportlet');
					renderURL.setWindowState('NORMAL');

					location.href = renderURL.toString();
				}
				else {
					instance.setCurrentAccountEntryId(instance.getCurrentAccountEntryId(), true);
				}
			},
			modal: true,
			width: 450
		});

		jQuery('#' + instance.namespace + 'passwordPrompt').focus();

		var promptForPasswordStatus = jQuery('#' + instance.namespace + 'promptForPasswordStatus');

		jQuery('#' + instance.namespace + 'promptForPasswordFm').ajaxForm(
			{
				beforeSubmit: function showRequest(formData, jqForm, options) {
					promptForPasswordStatus.attr('class', 'portlet-msg-info');
					promptForPasswordStatus.html(Liferay.Language.get('logging-in'));
					promptForPasswordStatus.show();
				},
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					promptForPasswordStatus.attr('class', 'portlet-msg-error');
					promptForPasswordStatus.html(Liferay.Language.get('unable-to-connect-with-mail-server'));
					promptForPasswordStatus.show();
				},
				success: function(responseText, statusText) {
					var jsonResult = eval('(' + responseText + ')');

					if (jsonResult.success) {
						promptForPasswordStatus.hide();

						instance.setStatus('success', Liferay.Language.get('loading-account'));

						instance.setCurrentAccountEntryId(accountEntryId, false);

						instance.loadCompleteAccountEntryAction(accountEntryId);

						Liferay.Popup.close('#' + instance.namespace + 'promptForPasswordFm');
					}
					else {
						promptForPasswordStatus.attr('class', 'portlet-msg-error');
						promptForPasswordStatus.html(jsonResult.message);
						promptForPasswordStatus.show();
					}
				}
			}
		);
	},

	refreshContactInputs: function() {
 		var instance = this;

 		instance.manageContactsNameInput.val('');
		instance.manageContactsMessageAddressInput.val('');
	},

	refreshFolderControls: function() {
 		var instance = this;

		// Folder Navigation

		instance.folderControlsNewestLink.css('display', 'inline');
		instance.folderControlsNewerLink.css('display', 'inline');
		instance.folderControlsOlderLink.css('display', 'inline');
		instance.folderControlsOldestLink.css('display', 'inline');

		if (instance.getTotalPages() === 0) {

			// No pages

			instance.folderControlsNewestLink.hide();
			instance.folderControlsNewerLink.hide();
			instance.folderControlsOlderLink.hide();
			instance.folderControlsOldestLink.hide();

			// Update page range count status

			jQuery('.folder-controls .status').html('');
		}
		else {

			// On first page

			if (instance.getCurrentPageNumber() == 1) {
				instance.folderControlsNewestLink.hide();
				instance.folderControlsNewerLink.hide();
			}

			// On second page

			if (instance.getCurrentPageNumber() == 2) {
				instance.folderControlsNewestLink.hide();
			}

			// On second to last page

			if (instance.getCurrentPageNumber() == instance.getTotalPages() - 1) {
				instance.folderControlsOldestLink.hide();
			}

			// On last page

			if (instance.getCurrentPageNumber() == instance.getTotalPages()) {
				instance.folderControlsOlderLink.hide();
				instance.folderControlsOldestLink.hide();
			}

			// Update page range count status

			jQuery('.folder-controls .status').html('<span class="status-number">' + instance.getFirstMessageNumOnPage() + ' - ' + instance.getLastMessageNumOnPage() + '</span>&nbsp;of&nbsp;<span class="status-number">' + instance.getTotalMessages() + '</span>');
		}

		// Folder Options

		instance.folderControlsSelectAction.val('none');
		instance.folderControlsMessageMover.val('none');
	},

	refreshFolderInputs: function() {
 		var instance = this;

 		instance.manageFoldersNameInput.val('');
	},

	refreshMessageAttachments: function() {
		var instance = this;

		instance.sendAttachmentsDiv.html('');
		instance.sendForwardAttachmentIdsHidden.val('');
		instance.sendForwardMessageIdHidden.val('');

		if (instance.isComposingMessage()) {
			if (instance.isMessageSaved() || (!instance.isMessageSaved() && instance.getMessageResponseType() == 'forward')) {

				// Determine if attachments are "pseudo" attachments used by forwarded messages or not
				
				var pseudoForwardedAttachment = (!instance.isMessageSaved() && instance.getMessageResponseType() == 'forward');
				
				// Display saved attachments

				var message = instance.getCurrentMessage();
	
				if (message == '') {
					return;
				}

				var messageHasAttachments = message.attachments;
				var messageAttachmentSummary = message.attachmentSummary;

				if (messageHasAttachments) {
					for (i = 0; i < messageAttachmentSummary.length; i++) {
						instance.addAttachmentPlaceholder(
							message.messageId,
							messageAttachmentSummary[i].attachmentId,
							messageAttachmentSummary[i].filename,
							messageAttachmentSummary[i].size, pseudoForwardedAttachment);
					}
				}
			}
		}
	},

	refreshNavigationHighlighting: function() {
		var instance = this;

		var view = instance.getView();
		var highlightClasses = 'folder-selected results-header';

		// Remove highlighting

		jQuery('.email-left-column .folder').removeClass(highlightClasses);
		instance.composeMessageLink.removeClass(highlightClasses);
		instance.manageFoldersLink.removeClass(highlightClasses);
		instance.manageContactsLink.removeClass(highlightClasses);

		// Add highlighting to folder

		if ((view == 'viewFolder') ||
				(view == 'viewMessage') ||
				(view == 'replyOrForwardMessage') ||
				(view == 'editMessageDraft')) {

			jQuery(".email-left-column .folder[folderId='" + instance.getCurrentFolderId() + "']").addClass(highlightClasses);
		}

		// Add highlighting to special actions

		if (view == 'manageFolders') {
			instance.manageFoldersLink.addClass(highlightClasses);
		}
		else if (view == 'manageContacts') {
			instance.manageContactsLink.addClass(highlightClasses);
		}
		else if (view == 'composeMessage') {
			instance.composeMessageLink.addClass(highlightClasses);
		}
	},

	refreshMessageControlsNavigation: function() {
		var instance = this;

		instance.messageControlsNewerLink.css('display', 'inline');
		instance.messageControlsOlderLink.css('display', 'inline');

		// If on first message

		if (instance.getCurrentMessage().messageNumber == 1) {
			instance.messageControlsNewerLink.hide();
		}

		// If on last message

		if (instance.getCurrentMessage().messageNumber == instance.getTotalMessages()) {
			instance.messageControlsOlderLink.hide();
		}

		// Update page count status

		instance.messageControlsStatus.html('<span class="status-number">' + instance.getCurrentMessage().messageNumber + '</span> of <span class="status-number">' + instance.getTotalMessages() + '</span>');
	},

	renameFolder: function(folderId, newFolderName) {
		var instance = this;

		instance.setStatus('info', Liferay.Language.get('renaming-folder'));

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/update_folder',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					folderId: folderId,
					newFolderName: newFolderName
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonResult) {
					if (jsonResult.success) {
						instance.loadFolders();
						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}
				},
				type: 'POST'
			}
		);
	},

	saveMessage: function() {
		var instance = this;

		if (instance._lockSaveAndSend) {
			return;
		}

		instance.lockSaveAndSend();

		instance._oldDraftMessageSummary = instance.getDraftMessageSummary();

		instance.sendBodyHidden.val(instance.getEditorHTML());

		var currentAccountEntry = instance.getCurrentAccountEntry();

		// Save message

		instance.sendMessageHidden.val('false');

		instance.sendForm.ajaxSubmit(
			{
				iframe: true,
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));

					instance.unlockSaveAndSend();
				},
				success: function(responseText, statusText) {
					var jsonResult = eval('(' + responseText + ')');

					if (jsonResult.success) {
						var draftMessageId = jsonResult.value;

						if ((parseInt(draftMessageId, 10) == draftMessageId) && draftMessageId != 0) {
							instance.sendDraftMessageIdHidden.val(draftMessageId);
						}

						// Change file inputs so they arent saved twice

						var attachmentInputs = jQuery('.attachment-input');

						jQuery.each(attachmentInputs, function() {
							var filename = jQuery(this).val();

							if (filename != '') {
								jQuery(this).parents('.attachment-row:first').html(Liferay.Language.get('saving-x', eval('["' + filename + '"]')));
							}
						});

						instance.refreshMessageAttachments();

						instance.loadFolders();

						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}

					instance.unlockSaveAndSend();
				}
			}
		);
	},

	sendMessage: function() {
		var instance = this;

		if (instance._lockSaveAndSend) {
			return;
		}

		instance.sendBodyHidden.val(instance.getEditorHTML());

		var currentAccountEntry = instance.getCurrentAccountEntry();

		// Send message

		instance.sendMessageHidden.val('true');

		instance.setStatus('info', Liferay.Language.get('sending-message'));

		instance.lockSaveAndSend();

		instance.sendForm.ajaxSubmit(
			{
				iframe: true,
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));

					instance.unlockSaveAndSend();
				},
				success: function(responseText, statusText) {
					var jsonResult = eval('(' + responseText + ')');

					if (jsonResult.success) {
						instance.setCurrentFolderId(instance.getCurrentAccountEntry().inboxFolderId);
						instance.setCurrentPageNumber(1);

						instance.loadMessagesDelayed('', false, .5);

						instance.loadContacts();

						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}

					instance.unlockSaveAndSend();
				}
			}
		);
	},

	sendUpdateMessage: function(accountEntryId) {
		var instance = this;

		if (instance.sessionExpirationCheck()) {
			return false;
		}

		// Only send update message if account can be updated

		var accountEntry = instance.getAccountEntry(accountEntryId);

		if (!accountEntry.requiresSynchronization) {
			return;
		}

		instance.updateAccountEntryId.val(accountEntryId);

		instance.updateForm.ajaxSubmit(
			{
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.sendMessage('error', 'unable-to-connect-with-mail-server');
				},
				success: function(jsonResult) {
					setTimeout('Liferay.Mail.sendUpdateMessage("' + accountEntryId + '")', instance._synchronizeInterval * 60000);
				}
			}
		);
	},

	sessionExpirationCheck: function() {
		var instance = this;

		var val = Liferay.Session.getCookie();

		if (val == null || val == 'expired') {
			instance.setStatus('error', Liferay.Language.get('your-session-has-expired'));

			return true;
		}
		else {
			return false;
		}
	},

	setAttachmentCount: function(count) {
		var instance = this;

		instance.sendAttachmentCount.val(count);
	},

	setCurrentAccountEntryId: function(accountEntryId, forceResetUI) {
		var instance = this;

		if ((accountEntryId != instance._currentAccountEntryId) || forceResetUI) {
			instance._currentAccountEntryId = accountEntryId;

			// Set UI

			instance.accountEntrySelectionSelect.val(accountEntryId);
			instance.sendAccountEntryIdHidden.val(accountEntryId);

			var currentAccountEntry = instance.getCurrentAccountEntry();

			if (currentAccountEntry.type == 'private') {
				instance.manageContactsLink.hide();
			}
			else if (currentAccountEntry.type == 'imap') {
				instance.manageContactsLink.show();
			}
		}
	},

	setCurrentFolderId: function(folderId) {
		var instance = this;

		instance._currentFolderId = folderId;
	},

	setCurrentMessage: function(jsonMessage) {
		var instance = this;

		instance._currentMessage = jsonMessage;
	},

	setCurrentMessages: function(jsonMessages) {
		var instance = this;

		instance._jsonMessages = jsonMessages;
	},

	setCurrentPageNumber: function(pageNumber) {
		var instance = this;

		instance._currentPageNumber = parseInt(pageNumber, 10);
	},

	setEditorHTML: function(html) {
		var instance = this;

		instance._editorHTML = html;

		if (instance.getEditorInitialized()) {
			var updateEditor = function() {
				try {
					if (Liferay.Browser.isIe()) {
						setTimeout('Liferay.Mail.sendBodyEditor.setHTML(Liferay.Mail._editorHTML)', 0);
					}
					else {
						Liferay.Mail.sendBodyEditor.setHTML(Liferay.Mail._editorHTML);
					}
				}
				catch (ex) {
					setTimeout(updateEditor, 500);
				}
			};

			updateEditor();
		}
		else {

			// Try later when editor is initialized

			setTimeout('Liferay.Mail.setEditorHTML(Liferay.Mail._editorHTML)', 500);
		}

	},

	setEditorInitialized: function(value) {
		var instance = this;

		instance._editorInitialized = value;
	},

	setInitialDraftMessageSummary: function(summary) {
		var instance = this;

		instance._initialDraftMessageSummary = summary;
	},

	setMessageFlags: function(messageIds, flag, value, silentUpdate) {
		var instance = this;

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/update_message_flags',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					folderId: instance.getCurrentFolderId(),
					messageIds: messageIds,
					flag: flag,
					value: value
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonSuccess) {
					if (!silentUpdate) {
						instance.loadMessagesDelayed('', silentUpdate, 1);
					}

					instance.loadFolders();
					instance.clearStatus();
				},
				type: 'POST'
			}
		);
	},

	setMessageResponseType: function(responseType) {
		var instance = this;

		// Possible values include: 'reply', 'forward' and 'new'

		instance._messageResponseType = responseType;
	},

	setOldDraftMessageSummary: function(summary) {
		var instance = this;

		instance._oldDraftMessageSummary = summary;
	},

	setSearchMode: function(isSearchMode) {
		var instance = this;

		instance._isSearchMode = isSearchMode;
	},

	setStatus: function(type, message) {
		var instance = this;

		var messageType = 'portlet-msg-error';

		if (type == 'success') {
			messageType = 'portlet-msg-success';
		}
		else if (type == 'info') {
			messageType = 'portlet-msg-info';
		}

		instance.statusDiv.html('<table style="margin: 0 auto;"><tr><td>&nbsp;</td><td><span class="message ' + messageType + '">' + message + '</span></td><td>&nbsp;</td></tr></table>');
	},

	setTotalMessages: function(totalMessages) {
		var instance = this;

		instance._totalMessages = totalMessages;
	},

	setTotalPages: function(totalPages) {
		var instance = this;

		instance._totalPages = parseInt(totalPages, 10);
	},

	setView: function(viewMode) {
		var instance = this;

		instance._previousView = instance._currentView;
		instance._currentView = viewMode;

		// Hide everything

		instance.configurationPromptDiv.hide();
		instance.folderDiv.hide();
		instance.manageContactsContainerDiv.hide();
		instance.manageFoldersContainerDiv.hide();
		instance.messageDiv.hide();

		instance.messageControlsButtonsDiv.hide();
		instance.messageControlsDiv.hide();
		instance.messageControlsNavigationCol.hide();
		instance.messageReadDiv.hide();
		instance.messageOptionsDiv.hide();
		instance.messageSendDiv.hide();

		instance.refreshNavigationHighlighting();

		// Show desired windows

		if (viewMode == 'viewAccountConfiguration') {
			instance.accountContainerDiv.hide();
			instance.configurationPromptDiv.show();
			instance.emailContainerDiv.hide();
		}
		else {
			instance.accountContainerDiv.show();
			instance.emailContainerDiv.show();

			if (viewMode == 'viewFolder') {
				instance.clearIncomingMessage();
				instance.folderDiv.show();
			}
			else if (viewMode == 'manageContacts') {
				instance.manageContactsContainerDiv.show();

				instance.refreshContactInputs();
			}
			else if (viewMode == 'manageFolders') {
				instance.manageFoldersContainerDiv.show();

				instance.refreshFolderInputs();
			}
			else {
				if ((instance._previousView != 'replyOrForwardMessage') || (instance._currentView != 'replyOrForwardMessage')) {
					instance.clearOutgoingMessage();
				}

				instance.messageDiv.show();

				jQuery('#' + instance.namespace + 'message-options td').css('background-color', '#F7F7F7');

				if (viewMode == 'viewMessage') {
					instance.messageControlsNavigationCol.show();
					instance.messageControlsActions.css('float', 'left');
					instance.messageControlsButtonsDiv.show();
					instance.messageControlsDiv.show();
					instance.messageReadDiv.show();
					instance.messageOptionsDiv.show();
				}
				else {
					instance.sendBccRow.hide();
					instance.sendCcRow.hide();
					instance.sendFromRow.hide();

					// Only show the fields appropriate for current account type

					if (instance.getCurrentAccountEntryId() !== null) {
						var currentAccountEntry = instance.getCurrentAccountEntry();

						if (currentAccountEntry.type == 'private') {
						}
						else if (currentAccountEntry.type == 'imap') {
							instance.sendBccRow.show();
							instance.sendCcRow.show();
							instance.sendFromRow.show();
						}
						else {
							alert('unknown account type: ' + currentAccountEntry.type);
						}
					}

					if (viewMode == 'replyOrForwardMessage') {
						instance.messageControlsNavigationCol.show();
						instance.messageControlsActions.css('float', 'left');
						instance.messageControlsButtonsDiv.show();
						instance.messageControlsDiv.show();
						instance.messageReadDiv.show();
						instance.messageOptionsDiv.show();
						instance.messageSendDiv.show();
					}
					else if (viewMode == 'composeMessage') {
						instance.clearOutgoingMessage();

						instance.setCurrentFolderId(null);
					}
					else if (viewMode == 'editMessageDraft') {
						instance.clearOutgoingMessage();

						instance.messageControlsActions.css('float', 'none');
						instance.messageControlsNavigationCol.hide();
						instance.messageControlsDiv.show();
					}
					else {
						alert('setView(), unknown view: ' + viewMode);
					}

					instance.messageSendDiv.show();

					try {
						instance.sendBodySpan.show();
						//instance.setEditorHTML('');
					}
					catch (ex) {
						console.log('Error preparing sendBody: ' + ex);
					}
				}
			}

			instance.clearStatus();
		}
	},

	updateContact: function(contactId, name, messageAddress) {
		var instance = this;

		instance.setStatus('info', Liferay.Language.get('updating-contact'));

		jQuery.ajax(
			{
				url: themeDisplay.getLayoutURL() + '/-/mail/update_contact',
				data: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					contactId: contactId,
					messageAddress: messageAddress,
					name: name
				},
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
				},
				success: function(jsonResult) {
					if (jsonResult.success) {
						instance.loadContacts();
						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}
				},
				type: 'POST'
			}
		);
	},

	_assignEvents: function() {
		var instance = this;

		jQuery('.delete-attachment').livequery('click', function() {
			var attachmentRow = jQuery(this).parents('.attachment-row')
			var attachmentId = attachmentRow.attr('attachmentId');
			var pseudoForwardedAttachment = attachmentRow.attr('pseudoForwardedAttachment');

			if (instance._lockSaveAndSend) {
				return;
			}

			instance.lockSaveAndSend();

			if (pseudoForwardedAttachment) {

				// Remove pseudo attachment

				var attachmentIds = instance.sendForwardAttachmentIdsHidden.val();

				instance.sendForwardAttachmentIdsHidden.val(attachmentIds.replace(attachmentId + ',', ''));

				attachmentRow.hide();

				instance.unlockSaveAndSend();
			}
			else {

				// Remove real attachment

				jQuery.ajax(
					{
						url: themeDisplay.getLayoutURL() + '/-/mail/delete_attachment',
						data: {
							accountEntryId: instance.getCurrentAccountEntryId(),
							messageId: instance.getCurrentMessage().messageId,
							attachmentId: attachmentId
						},
						dataType: 'json',
						error: function (XMLHttpRequest, textStatus, errorThrown) {
							instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));

							instance.unlockSaveAndSend();
						},
						success: function(jsonResult) {
							if (jsonResult.success) {
								attachmentRow.hide();
							}
							else {
								instance.refreshMessageAttachments();
							}

							instance.unlockSaveAndSend();
						},
						type: 'POST'
					}
				);
			}
		});
		
		jQuery('.message td:not(:first-child)').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			// Load message

			var messageId = jQuery(this).parent('.message:first').attr('messageId');
			var messageNumber = jQuery(this).parent('.message:first').attr('messageNumber');

			instance.loadMessageNumber(parseInt(messageNumber, 10), 0, false);

			// Show message

			if (instance.isCurrentFolderDraftFolder()) {
				instance.setView('editMessageDraft');
			}
			else {
				instance.setView('viewMessage');
			}

			return false;
		});

		jQuery('.column-sorter').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			// Get attributes

			if (instance._orderByField == jQuery(this).attr('orderByField')) {
				if (instance._orderByType == 'asc') {
					instance._orderByType = 'desc';
				}
				else {
					instance._orderByType = 'asc';
				}
			}
			else {
				instance._orderByType = jQuery(this).attr('orderByType');
				instance._orderByField = jQuery(this).attr('orderByField');
			}

			// Load messages by page

			instance.loadMessages(instance.getSelectedMessageIds(), true);
		});
		
		jQuery('.email-left-column .folder').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.clearMessages();

			instance.setSearchMode(false);
			instance.setCurrentFolderId(jQuery(this).attr('folderId'));
			instance.setCurrentPageNumber(1);

			instance.loadMessages('', false);

			return false;
		});

		jQuery('.manage-folders-container .delete-folder').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setStatus('info', Liferay.Language.get('deleting-folder'));

			jQuery.ajax(
				{
					url: themeDisplay.getLayoutURL() + '/-/mail/delete_folder',
					data: {
						accountEntryId: instance.getCurrentAccountEntryId(),
						folderId: jQuery(this).parents('.folder:first').attr('folderId')
					},
					dataType: 'json',
					error: function (XMLHttpRequest, textStatus, errorThrown) {
						instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
					},
					success: function(jsonResult) {
						if (jsonResult.success) {
							instance.loadFolders();
							instance.setStatus('success', jsonResult.message);
						}
						else {
							instance.setStatus('error', jsonResult.message);
						}
					},
					type: 'POST'
				}
			);
		});

		jQuery('.manage-folders-container .rename-folder').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var folderElement = jQuery(this).parents('.folder:first');

			var folderNameElement = folderElement.find('.name:first');
			var oldFolderName = folderElement.attr('folderName');
			var folderId = folderElement.attr('folderId');

			// Reset all folder renaming

			jQuery.each(jQuery('.manage-folders-container .folder'), function() {
				var tempOldFolderName = jQuery(this).attr('folderName');

				jQuery(this).find('.name').html(tempOldFolderName);
			});

			// Display input box for new folder name

			folderNameElement.html('<input class="name" type="text" value="' + oldFolderName + '"/><a class="icon-save save" href="javascript:;">' + Liferay.Language.get('save') + '</a>');

			folderNameElement.find('.name').focus();

			jQuery('.save').click(function() {
				instance.renameFolder(folderId, folderNameElement.find('.name').val());
			});
		});
		
		jQuery('.contacts-container .delete-contact').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setStatus('info', Liferay.Language.get('deleting-contact'));

			jQuery.ajax(
				{
					url: themeDisplay.getLayoutURL() + '/-/mail/delete_contact',
					data: {
						accountEntryId: instance.getCurrentAccountEntryId(),
						contactId: jQuery(this).parents('.contact:first').attr('contactId')
					},
					dataType: 'json',
					error: function (XMLHttpRequest, textStatus, errorThrown) {
						instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
					},
					success: function(jsonResult) {
						if (jsonResult.success) {
							instance.loadContacts();
							instance.setStatus('success', jsonResult.message);
						}
						else {
							instance.setStatus('error', jsonResult.message);
						}
					},
					type: 'POST'
				}
			);
		});

		jQuery('.contacts-container .edit-contact').livequery('click', function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var contactElement = jQuery(this).parents('.contact:first');

			var contactMessageAddressElement = contactElement.find('.message-address:first');
			var oldContactMessageAddress = contactElement.attr('contactMessageAddress');

			var contactNameElement = contactElement.find('.name:first');
			var oldContactName = contactElement.attr('contactName');

			var contactId = contactElement.attr('contactId');

			// Reset all contact renaming

			jQuery.each(jQuery('.contacts-container .contact'), function() {
				var tempOldContactName = jQuery(this).attr('contactName');
				var tempOldContactMessageAddress = jQuery(this).attr('contactMessageAddress');

				jQuery(this).find('.name').html(tempOldContactName);
				jQuery(this).find('.message-address').html(tempOldContactMessageAddress);
			});

			// Display input box for new contact name

			contactMessageAddressElement.html('<input class="message-address" type="text" value="' + oldContactMessageAddress + '"/>');

			contactNameElement.html('<input class="name" type="text" value="' + oldContactName + '"/>' + '<a class="icon-save save" href="javascript:;">' + Liferay.Language.get('save') + '</a>');

			contactNameElement.find('.name').focus();

			contactNameElement.find('.save').click(function() {
				instance.updateContact(contactId, contactNameElement.find('.name').val(), contactMessageAddressElement.find('.message-address').val());
			});
		});
		
		jQuery('.message-send .to .label a').click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			Liferay.Popup({
				modal: true,
				title: Liferay.Language.get('to') + ":",
				url: themeDisplay.getLayoutURL() + '/-/mail/recipient_popup',
				urlData: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					recipients: instance.sendToInput.val(),
					type: 'to'
				},
				width: 400
			})
		});

		jQuery('.message-send .cc .label a').click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			Liferay.Popup({
				modal: true,
				title: Liferay.Language.get('cc') + ":",
				url: themeDisplay.getLayoutURL() + '/-/mail/recipient_popup',
				urlData: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					recipients: instance.sendCcInput.val(),
					type: 'cc'
				},
				width: 400
			})
		});

		jQuery('.message-send .bcc .label a').click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			Liferay.Popup({
				modal: true,
				title: Liferay.Language.get('bcc') + ":",
				url: themeDisplay.getLayoutURL() + '/-/mail/recipient_popup',
				urlData: {
					accountEntryId: instance.getCurrentAccountEntryId(),
					recipients: instance.sendBccInput.val(),
					type: 'bcc'
				},
				width: 400
			})
		});

		instance.accountEntrySelectionSelect.change(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var newAccountEntryId = jQuery(this).val();

			// Load account via page refresh

			var renderURL = Liferay.PortletURL.createRenderURL();

			renderURL.setPortletId('1_WAR_mailportlet');
			renderURL.setWindowState('MAXIMIZED');
			renderURL.setParameter('initialAccountEntryId', newAccountEntryId);

			location.href = renderURL.toString();

			// Load account via javascript

			//instance.loadCompleteAccountEntryPreAction(newAccountEntryId);

			return false;
		});

		instance.composeMessageLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var accountEntry = instance.getAccountEntry(instance._initialAccountEntryId);
			var signature = accountEntry.signature.replace(/\n/g,'<br />');;
			var defaultMessageBody = signature;

			instance.setView('composeMessage');
			instance.setMessageResponseType('new');
			instance.setEditorHTML('<br /><br />' + defaultMessageBody);
			instance.setCurrentMessage('');

			return false;
		});

		instance.folderControlsDeleteButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var messageIds = instance.getSelectedMessageIds();
			var preMessage = Liferay.Language.get('deleting-messages');

			instance.deleteMessages(
				messageIds,
				preMessage,
				function(jsonResult) {
					if (jsonResult.success) {
						instance.sendUpdateMessage(instance.getCurrentAccountEntryId());

						if (instance._currentView != 'viewMessage') {
							instance.loadMessagesDelayed('', false, .5);
						}

						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}
				}
			);

			return false;
		});

		instance.folderControlsMessageMover.change(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var destinationFolderId = parseInt(instance.folderControlsMessageMover.val(), 10);
			var messageIds = instance.getSelectedMessageIds();
			var sourceFolderId = parseInt(instance.getCurrentFolderId(), 10);

			instance.moveMessages(messageIds, sourceFolderId, destinationFolderId);

			return false;
		});

		instance.folderControlsNewerLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setCurrentPageNumber(instance.getCurrentPageNumber() - 1);

			instance.loadMessages('', false);

			return false;
		});

		instance.folderControlsNewestLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setCurrentPageNumber(1);

			instance.loadMessages('', false);

			return false;
		});

		instance.folderControlsOlderLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setCurrentPageNumber(instance.getCurrentPageNumber() + 1);

			instance.loadMessages('', false);

			return false;
		});

		instance.folderControlsOldestLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setCurrentPageNumber(instance.getTotalPages());

			instance.loadMessages('', false);

			return false;
		});

		instance.folderControlsSelectAction.change(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			// Do nothing if action not recognized

			var option = instance.folderControlsSelectAction.val().split(",");

			var flag = option[0];
			var value = option[1];

			if (flag === '') {
				instance.refreshFolderControls();

				return false;
			}

			// Do nothing if no messages are selected

			var messageIds = instance.getSelectedMessageIds();

			if (messageIds === '') {
				instance.refreshFolderControls();

				instance.setStatus('error', Liferay.Language.get('no-messages-selected'));

				return false;
			}

			// Do selected folder action

			if (flag == instance._flagSeen) {
				if (value == 'true') {
					instance.setStatus('info', Liferay.Language.get('marking-messages-as-read'));
				}
				else {
					instance.setStatus('info', Liferay.Language.get('marking-messages-as-unread'));
				}

				instance.setMessageFlags(messageIds, flag, value, false);
			}

			if (flag == instance._flagFlagged) {
				if (value == 'true') {
					instance.setStatus('info', Liferay.Language.get('flagging-messages-as-important'));
				}
				else {
					instance.setStatus('info', Liferay.Language.get('clearing-flags'));
				}

				instance.setMessageFlags(messageIds, flag, value, false);
			}
		});

		instance.folderControlsSelectAllLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			jQuery('.message-checkbox').attr('checked', 'true');

			return false;
		});

		instance.folderControlsSelectNoneLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			jQuery('.message-checkbox').attr('checked', '');

			return false;
		});

		instance.folderControlsSelectReadLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			jQuery('.read .message-checkbox').attr('checked', 'true');
			jQuery('.unread .message-checkbox').attr('checked', '');

			return false;
		});

		instance.folderControlsSelectUnreadLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			jQuery('.read .message-checkbox').attr('checked', '');
			jQuery('.unread .message-checkbox').attr('checked', 'true');

			return false;
		});

		instance.manageContactsCreateButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setStatus('info', Liferay.Language.get('creating-contact'));

			jQuery.ajax(
				{
					url: themeDisplay.getLayoutURL() + '/-/mail/create_contact',
					data: {
						accountEntryId: instance.getCurrentAccountEntryId(),
						name: instance.manageContactsNameInput.val(),
						messageAddress: instance.manageContactsMessageAddressInput.val()
					},
					dataType: 'json',
					error: function (XMLHttpRequest, textStatus, errorThrown) {
						instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
					},
					success: function(jsonResult) {
						if (jsonResult.success) {
							instance.setStatus('success', jsonResult.message);

							instance.refreshContactInputs();

							instance.loadContacts();
						}
						else {
							instance.setStatus('error', jsonResult.message);
						}
					},
					type: 'POST'
				}
			);

			return false;
		});

		instance.manageContactsLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setView('manageContacts');

			return false;
		});

		instance.manageFoldersCreateButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setStatus('info', Liferay.Language.get('creating-folder'));

			jQuery.ajax(
				{
					url: themeDisplay.getLayoutURL() + '/-/mail/create_folder',
					data: {
						accountEntryId: instance.getCurrentAccountEntryId(),
						folderName: instance.manageFoldersNameInput.val()
					},
					dataType: 'json',
					error: function (XMLHttpRequest, textStatus, errorThrown) {
						instance.setStatus('error', Liferay.Language.get('unable-to-connect-with-mail-server'));
					},
					success: function(jsonResult) {
						if (jsonResult.success) {
							instance.setStatus('success', jsonResult.message);

							instance.refreshFolderInputs();

							instance.loadFolders();
						}
						else {
							instance.setStatus('error', jsonResult.message);
						}
					},
					type: 'POST'
				}
			);

			return false;
		});

		instance.manageFoldersLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setView('manageFolders');

			return false;
		});

		instance.messageControlsBackLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.loadMessages('', false);

			return false;
		});

		instance.messageControlsDeleteButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			var statusMessage = jQuery('#p_p_id' + instance.namespace + ' .status .message:visible');

			if (statusMessage.length > 0) {
				return false;
			}

			if (!confirm((Liferay.Language.get('are-you-sure-you-want-to-delete-this')))) {
				return false;
			}

			var messageId = instance.getCurrentMessage().messageId || [];
			var preMessage = Liferay.Language.get('deleting-messages');

			instance.deleteMessages(
				messageId,
				preMessage,
				function(jsonResult) {
					if (jsonResult.success) {
						instance.sendUpdateMessage(instance.getCurrentAccountEntryId());

						instance.loadMessagesDelayed('', false, .5);

						instance.setStatus('success', jsonResult.message);
					}
					else {
						instance.setStatus('error', jsonResult.message);
					}
				}
			);

			return false;
		});

		instance.messageControlsNewerLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setView('viewMessage');

			instance.loadMessageNumber(parseInt(instance.getCurrentMessage().messageNumber, 10), -1, false);

			return false;
		});

		instance.messageControlsOlderLink.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setView('viewMessage');

			instance.loadMessageNumber(parseInt(instance.getCurrentMessage().messageNumber, 10), 1, false);

			return false;
		});

		instance.messageOptionsRespondDivs.click(function () {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			// Show message send

			instance.setView('replyOrForwardMessage');

			instance.messageOptionsRespondDivs.removeClass('selected-response-type results-header');
			jQuery(this).addClass('selected-response-type results-header');

			// Load default values for response message based on original message

			var originalMessage = instance.getCurrentMessage();
			
			var accountEntry = instance.getAccountEntry(instance._initialAccountEntryId);	
			var signature = accountEntry.signature.replace(/\n/g,'<br />');;
			
			var originalMessageId = originalMessage.id;
			var originalMessageFrom = originalMessage.from;
			var originalMessageTo = originalMessage.to;
			var originalMessageCc = originalMessage.cc;
			var originalMessageSubject = originalMessage.subject;
			var originalMessageBody = '<blockquote>' + originalMessage.body + '</blockquote>';
			var originalMessageDate = originalMessage.date;
			var originalMessageFullDate = originalMessage.fullDate;

			// Set response types

			if (jQuery(this).attr('responseType') == 'forward') {
				instance.setMessageResponseType('forward');
			}
			else {
				instance.setMessageResponseType('reply');
			}

			// Reset message composition if applicable

			if (!instance.isMessageSaved() && !instance.isMessageModifiedSinceInitialLoad()) {

				// Reset initial messages (this way it wont be treated as a modified message)

				instance.setInitialDraftMessageSummary(null);
				instance.setOldDraftMessageSummary(null);

				// Reset defaults based on response type

				var newMessageTo = '';
				var newMessageCc = '';
				var newMessageBcc = '';
				var newMessageSubject = '';
				var newMessageBody = '';
				
				if (jQuery(this).attr('responseType') == 'forward') {
					newMessageSubject = 'Fwd: ' + originalMessageSubject;
					
					newMessageBody = '<br /><br />' + signature + '<br />';
					newMessageBody += '<br />---------- ' + Liferay.Language.get('forwarded-message') + ' ----------<br />';
					newMessageBody += Liferay.Language.get('from') + ': ' + originalMessageFrom + '<br />';
					newMessageBody += Liferay.Language.get('date') + ': ' + originalMessageFullDate + '<br />';
					newMessageBody += Liferay.Language.get('subject') + ': ' + originalMessageSubject + '<br />';
					newMessageBody += Liferay.Language.get('to') + ': ' + originalMessageTo + '<br />';
					newMessageBody += originalMessageBody;
				}
				else {
					if (jQuery(this).attr('responseType') == 'reply') {
						newMessageTo = originalMessageFrom;
					}
					else if (jQuery(this).attr('responseType') == 'reply-all') {
						newMessageTo = originalMessageFrom;
						newMessageCc = originalMessageTo + ', ' + originalMessageCc;
					}
					else {
						alert('Unknown Message Response Type. Reply? Reply All? Forward?');
					}

					newMessageSubject = 'Re: ' + originalMessageSubject;

					newMessageBody = '<br /><br />';
					newMessageBody += signature + '<br />';
					newMessageBody += '<br />' + Liferay.Language.get('on-x-x-wrote', eval('["' + originalMessageFullDate + '","' + originalMessageFrom + '"]'));
					newMessageBody += '<br />';
					newMessageBody += '<br /><br />';
					newMessageBody += originalMessageBody;
				}

				instance.sendToInput.attr('value', newMessageTo);
				instance.sendCcInput.attr('value', newMessageCc);
				instance.sendBccInput.attr('value', newMessageBcc);
				instance.sendSubjectInput.attr('value', newMessageSubject);
				instance.setEditorHTML(newMessageBody);

				instance.refreshMessageAttachments();

				instance.sendBodySpan.show();
			}

			return false;
		});

		instance.messageSendDiscardButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setEditorHTML('');

			if (instance.isMessageSaved()) {
				var messageIds = instance.sendDraftMessageIdHidden.val();
				var preMessage = Liferay.Language.get('discarding-draft');

				instance.deleteMessages(
					messageIds,
					preMessage,
					function(jsonResult) {
						if (jsonResult.success) {
							instance.sendUpdateMessage(instance.getCurrentAccountEntryId());

							instance.setStatus('success', jsonResult.message);
						}
						else {
							instance.setStatus('error', jsonResult.message);
						}
					}
				);
			}

			if ((instance.getCurrentMessage() === null) || instance.getCurrentMessage() === '') {
				jQuery('.email-left-column .folder:first').trigger('click');
			}
			else {
				instance.setView('viewMessage');
			}

			return false;
		});

		instance.messageSendSaveButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setStatus('info', Liferay.Language.get('saving-message'));

			instance.saveMessage();

			return false;
		});

		instance.messageSendSendButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setStatus('info', Liferay.Language.get('sending-message'));

			instance.sendMessage();

			return false;
		});

		instance.searchButton.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.setSearchMode(true);
			instance.setCurrentPageNumber(1);

			instance.loadMessages('', false);

			return false;
		});

		instance.searchTextInput.keydown(function(e) {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			if (e.which == Liferay.Mail.KEYS.ENTER) {
				instance.searchButton.trigger('click');

				return false;
			}
		});

		instance.sendAttachmentsAdd.click(function() {
			if (instance.sessionExpirationCheck()) {
				return false;
			}

			instance.addAttachmentInputField();

			return false;
		});
	},

	_currentAccountEntryId: null,
	_currentFolderId: null,
	_currentMessage: null,
	_currentPageNumber: null,
	_currentView: 'viewFolder',
	_editorInitialized: false,
	_editorHTML: '',
	_initialDraftMessageSummary: null,
	_isSearchMode: false,
	_lockSaveAndSend: false,
	_messageResponseType: null,
	_oldDraftMessageSummary: null,
	_orderByField: 'date',
	_orderByType: 'desc',
	_previousView: 'viewFolder',
	_totalMessages: null,
	_totalPages: null,

	_flagAnswered: null,
	_flagDraft: null,
	_flagFlagged: null,
	_flagSeen: null,
	_initialAccountEntryId: '',
	_messagesPerPage: 0,
	_orderByAddress: null,
	_orderByDate: null,
	_orderBySize: null,
	_orderBySubject: null,
	_synchronizeInterval: null,

	_jsonAccountEntries: {},
	_jsonContacts: {},
	_jsonFolders: {},
	_jsonMessages: {}

};

Liferay.Mail.KEYS = {
	ALT: 18,
	ENTER: 13,
	LEFT_ARROW: 37,
	RIGHT_ARROW: 39,
	ESC: 27
};

try {
	jQuery.Autocompleter._SelectionBackup = jQuery.Autocompleter.Selection;

	jQuery.Autocompleter.Selection = function(field){
		if(field == document.activeElement){
			jQuery.Autocompleter._SelectionBackup.apply(jQuery.Autocompleter._SelectionBackup, arguments);
		}
	};
}
catch (ex) {
}