<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/init.jsp" %>

<%
long accountEntryId = ParamUtil.getLong(request, "accountEntryId");
String unparsedRecipients = ParamUtil.getString(request, "recipients");
String type = ParamUtil.getString(request, "type");

MessageManager messageManager = MessageManager.getInstance(request);
%>

<div class="contact-list" id="<portlet:namespace />contactsList">
<liferay-ui:message key="search" />: <input class="lfr-tag-search-input" id="<portlet:namespace />contactSearchField" type="text" />
<fieldset>
	<div class="contact-labels">

	<%
	List<Recipient> contacts = messageManager.getContacts(accountEntryId);
	List<Recipient> parsedRecipients = messageManager.parseRecipients(unparsedRecipients);

	String nonContactRecipients = StringPool.BLANK;

	for (Recipient recipient : parsedRecipients) {
		if (!contacts.contains(recipient)) {
			String recipientDisplay = recipient.getMessageAddress();

			if (Validator.isNotNull(recipient.getName())) {
				recipientDisplay = recipient.getName() + " <" + recipient.getMessageAddress() + ">";
			}

			nonContactRecipients += recipientDisplay + ", ";
		}
	}

	for (Recipient recipient : contacts) {
		String recipientDisplay = recipient.getMessageAddress();

		if (!recipient.getName().equals(StringPool.BLANK)) {
			recipientDisplay = recipient.getName() + " &lt;" + recipient.getMessageAddress() + "&gt;";
		}
	%>

		<c:choose>
			<c:when test="<%= parsedRecipients.contains(recipient) %>">
				<label data-userMetaData="<%= recipientDisplay %>"><input type="checkbox" checked="checked" value="<%= recipientDisplay %>" /> <%= recipientDisplay %><br /></label>
			</c:when>
			<c:otherwise>
				<label data-userMetaData="<%= recipientDisplay %>"><input type="checkbox" value="<%= recipientDisplay %>" /> <%= recipientDisplay %><br /></label>
			</c:otherwise>
		</c:choose>

	<%
	}
	%>

	</div>
</fieldset>
<input id="<portlet:namespace />saveBtn" type="button" value="<liferay-ui:message key="save" />" />

</div>
<script type="text/javascript">
jQuery(
	function(){
		var inputSearch = jQuery('#<portlet:namespace />contactSearchField');
		var container = jQuery('#<portlet:namespace />contactsList');
		var type = '<%= HtmlUtil.escape(type) %>';

		var options = {
			data: function() {
				var value = jQuery(this).attr('data-userMetaData');

				return value.toLowerCase();
			},
			list: '#<portlet:namespace />contactsList label',
			after: function() {
				var visibleEntries = container.find('label:visible');

				if (visibleEntries.length == 0) {
					container.addClass('no-matches');
				}
				else {
					container.removeClass('no-matches');
				}
			}
		};

		inputSearch.liveSearch(options);


		var saveBtn = jQuery('#<portlet:namespace />saveBtn');

		saveBtn.click(
			function(){
				var buffer = [];
				container.find('input:checked').each(
					function(){
						buffer.push(this.value);
					}
				);

				if (type == 'to') {
					Liferay.Mail.sendToInput.val('<%= nonContactRecipients %>' + buffer.join(', '));
				}
				else if (type == 'cc') {
					Liferay.Mail.sendCcInput.val('<%= nonContactRecipients %>' + buffer.join(', '));
				}
				else if (type == 'bcc') {
					Liferay.Mail.sendBccInput.val('<%= nonContactRecipients %>' + buffer.join(', '));
				}
			}
		);
	}
);
</script>