<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/init.jsp" %>

<%
MessageManager messageManager = MessageManager.getInstance(request);
%>

<script type="text/javascript">
	function <portlet:namespace />initEditor() {
		Liferay.Mail.setEditorInitialized(true);

		return '';
	}

	jQuery(
		function() {
			Liferay.Mail.init(
				{
					jsonAccountEntries: <%= messageManager.getJSONAccounts(enableMailAccountEntries, enablePrivateAccountEntry) %>,
					initialAccountEntryId: '<%= ParamUtil.getString(request, "initialAccountEntryId") %>',
					flagAnswered: '<%= Mailbox.FLAG_ANSWERED %>',
					flagDraft: '<%= Mailbox.FLAG_DRAFT %>',
					flagFlagged: '<%= Mailbox.FLAG_FLAGGED %>',
					flagSeen: '<%= Mailbox.FLAG_SEEN %>',
					orderByAddress: '<%= Mailbox.ORDER_BY_ADDRESS %>',
					orderByDate: '<%= Mailbox.ORDER_BY_DATE %>',
					orderBySize: '<%= Mailbox.ORDER_BY_SIZE %>',
					orderBySubject: '<%= Mailbox.ORDER_BY_SUBJECT %>',
					messagesPerPage: <%= PortletProps.get("messages.per.page") %>,
					mailAccountConfigurationURL: '<%= portletDisplay.getURLEdit() %>',
					namespace: '<portlet:namespace />',
					sendBodyEditor: window.<portlet:namespace />editor,
					synchronizeInterval: <%= PortletProps.get("synchronize.interval.minutes") %>
				}
			);
		}
	);
</script>

<c:if test="<%= enableMailAccountEntries %>">
	<div class="configuration-prompt" id="<portlet:namespace />configuration-prompt">
		<liferay-ui:message key="configure-email-accounts" />

		<br /><br />

		<liferay-ui:icon image="edit" message="setup-email-accounts" url="<%= portletDisplay.getURLEdit() %>" />
	</div>
</c:if>

<table class="header-row">
<tr>
	<td class="selection">
		<c:if test="<%= enableMailAccountEntries %>">
			<select id="<portlet:namespace />accountEntrySelection"></select>
			<a href="<%= portletDisplay.getURLEdit() %>"><liferay-ui:message key="configure-email-accounts" /></a>
		</c:if>
	</td>

	<td>
		<div class="status">
			&nbsp;
		</div>
	</td>

	<td class="search">
		<table>
		<tr>
			<td>
				<input class="text">
			</td>

			<td>
				<input class="button" type="button" value="<liferay-ui:message key="search" />" />
			</td>
		</tr>
		</table>
	</td>
</tr>
</table>

<table class="email-container">
<tr>
	<td class="email-left-column">
		<div id="<portlet:namespace />update">
			<form action="<portlet:actionURL name="sendUpdateMessage" />" method="post">
				<input id="<portlet:namespace />updateAccountEntryId" name="<portlet:namespace />accountEntryId" type="hidden" value="" />
			</form>
		</div>

		<div class="compose-message">
			<span class="icon-compose"><liferay-ui:message key="compose-message" /></span>
		</div>

		<div id="<portlet:namespace />folders">
			<div class="folder">
				<a class="icon-inbox" href="javascript:;"><liferay-ui:message key="inbox" /></a>
			</div>

			<div class="folder">
				<a class="icon-draft" href="javascript:;"><liferay-ui:message key="drafts" /></a>
			</div>

			<div class="folder">
				<a class="icon-sent" href="javascript:;"><liferay-ui:message key="sent-messages" /></a>
			</div>

			<div class="folder">
				<a class="icon-trash" href="javascript:;"><liferay-ui:message key="trash" /></a>
			</div>
		</div>

		<div class="manage-folders">
			<span class="icon-manage-folder"><liferay-ui:message key="manage-folders" /></span>
		</div>

		<div class="manage-contacts">
			<span class="icon-contacts"><liferay-ui:message key="manage-contacts" /></span>
		</div>
	</td>
	<td class="email-right-column">
		<div class="contacts-container">
			<div class="controls">
				<div class="create-contact">
					<table>
					<tr style="vertical-align: bottom;">
						<td style="width: 140px;">
							<label style="font-weight: bold;"><liferay-ui:message key="message-address" /></label>

							<input class="message-address" type="text" />
						</td>
						<td style="width: 140px;">
							<label style="font-weight: bold;"><liferay-ui:message key="name" /></label>

							<input class="name" type="text" />
						</td>
						<td>
							<input class="create" type="button" value="<liferay-ui:message key="create-new-contact" />" />
						</td>
					</tr>
					</table>
				</div>
			</div>

			<div class="listing">
			</div>

			<div class="controls">
				&nbsp;
			</div>
		</div>

		<div class="manage-folders-container">
			<div class="controls">
				<div class="create-folder">
					<table>
					<tr style="vertical-align: bottom;">
						<td style="width: 140px;">
							<label style="font-weight: bold;"><liferay-ui:message key="folder-name" /></label>

							<input class="name" type="text" />
						</td>
						<td>
							<input class="create" type="button" value="<liferay-ui:message key="create-new-folder" />" />
						</td>
					</tr>
					</table>
				</div>
			</div>

			<div class="listing">
			</div>

			<div class="controls">
				&nbsp;
			</div>
		</div>

		<div class="folder-container" id="<portlet:namespace />folder">
			<table class="folder-controls results-header">
			<tr>
				<td class="actions">
					<div>
						<input class="delete" type="button" value="<liferay-ui:message key="delete" />" />

						<select class="select-actions">
							<option value="none"><liferay-ui:message key="mark" /></option>

							<option value="<%= Mailbox.FLAG_SEEN %>,true">- <liferay-ui:message key="mark-as-read" /></option>

							<option value="<%= Mailbox.FLAG_SEEN %>,false">- <liferay-ui:message key="mark-as-unread" /></option>

							<option value="<%= Mailbox.FLAG_FLAGGED %>,true">- <liferay-ui:message key="flag-as-important" /></option>

							<option value="<%= Mailbox.FLAG_FLAGGED %>,false">- <liferay-ui:message key="clear-flag" /></option>
						</select>

						<select class="message-mover">
						</select>
					</div>

					<div>
						<liferay-ui:message key="select" />:

						<a class="select-all" href="javascript:;"><liferay-ui:message key="all" /></a>,

						<a class="select-none" href="javascript:;"><liferay-ui:message key="none" /></a>,

						<a class="select-read" href="javascript:;"><liferay-ui:message key="read" /></a>,

						<a class="select-unread" href="javascript:;"><liferay-ui:message key="unread" /></a>
					</div>
				</td>
				<td class="navigation">
					<a class="newest" href="javascript:;">&laquo; <liferay-ui:message key="newest" /></a>

					<a class="newer" href="javascript:;">&lt; <liferay-ui:message key="newer" /></a>

					<span class="status">? - ? of ???</span>

					<a class="older" href="javascript:;"><liferay-ui:message key="older" /> &gt;</a>

					<!--<a class="oldest" href="javascript:;"><liferay-ui:message key="oldest" /> &raquo;</a>-->
				</td>
			</tr>
			</table>

			<table class="message-list" id="<portlet:namespace />message-list">
			<tr>
				<td class="alert"><liferay-ui:message key="no-messages-found" /></td>
			</tr>
			</table>

			<table class="folder-controls results-header">
			<tr>
				<td class="actions">
					<div>
						<liferay-ui:message key="select" />:

						<a class="select-all" href="javascript:;"><liferay-ui:message key="all" /></a>,

						<a class="select-none" href="javascript:;"><liferay-ui:message key="none" /></a>,

						<a class="select-read" href="javascript:;"><liferay-ui:message key="read" /></a>,

						<a class="select-unread" href="javascript:;"><liferay-ui:message key="unread" /></a>
					</div>

					<div>
						<input class="delete" type="button" value="<liferay-ui:message key="delete" />" />

						<select class="select-actions">
							<option value="none"><liferay-ui:message key="mark" /></option>

							<option value="<%= Mailbox.FLAG_SEEN %>,true">- <liferay-ui:message key="mark-as-read" /></option>

							<option value="<%= Mailbox.FLAG_SEEN %>,false">- <liferay-ui:message key="mark-as-unread" /></option>

							<option value="<%= Mailbox.FLAG_FLAGGED %>,true">- <liferay-ui:message key="flag-as-important" /></option>

							<option value="<%= Mailbox.FLAG_FLAGGED %>,false">- <liferay-ui:message key="clear-flag" /></option>
						</select>

						<select class="message-mover">
						</select>
					</div>
				</td>
				<td class="navigation">
					<a class="newest" href="javascript:;">&laquo; <liferay-ui:message key="newest" /></a>

					<a class="newer" href="javascript:;">&lt; <liferay-ui:message key="newer" /></a>

					<span class="status">? - ? of ???</span>

					<a class="older" href="javascript:;"><liferay-ui:message key="older" /> &gt;</a>

					<!--<a class="oldest" href="javascript:;"><liferay-ui:message key="oldest" /> &raquo;</a>-->
				</td>
			</tr>
			</table>
		</div>

		<div class="message-container" id="<portlet:namespace />message">
			<div class="message-controls results-header">
				<div class="actions">
					<div class="back">
						&laquo; <%= LanguageUtil.format(pageContext, "back-to-x", "<span class=\"folder-name\">INBOX</span>") %>
					</div>
				</div>
				<div class="buttons">
					<input class="delete" type="button" value="<liferay-ui:message key="delete" />" />
				</div>
				<div class="navigation">
					<div class="navigation-links">
						<span class="newer">&lt; <liferay-ui:message key="newer" /></span>

						<span class="status">? of ???</span>

						<span class="older"><liferay-ui:message key="older" /> &gt;</span>
					</div>
				</div>
			</div>

			<div class="message-read" id="<portlet:namespace />messageRead">
				<div class="details">
					<table>
						<tr>
							<td class="label">
								<liferay-ui:message key="from" />
							</td>
							<td>
								<span id="<portlet:namespace />read-from"></span>
							</td>
						</tr>
						<tr>
							<td class="label">
								<liferay-ui:message key="reply-to" />
							</td>
							<td>
								<span id="<portlet:namespace />read-reply-to"></span>
							</td>
						</tr>
						<tr>
							<td class="label">
								<liferay-ui:message key="to" />
							</td>
							<td>
								<span id="<portlet:namespace />read-to"></span>
							</td>
						</tr>
						<tr>
							<td class="label">
								<liferay-ui:message key="cc" />
							</td>
							<td>
								<span id="<portlet:namespace />read-cc"></span>
							</td>
						</tr>
						<tr>
							<td class="label">
								<liferay-ui:message key="date" />
							</td>
							<td>
								<span id="<portlet:namespace />read-date"></span>
							</td>
						</tr>
						<tr>
							<td class="label">
								<liferay-ui:message key="subject" />
							</td>
							<td>
								<span id="<portlet:namespace />read-subject"></span>
							</td>
						</tr>
						<tr style="display: none">
							<td class="label">
								<liferay-ui:message key="mailed-by" />
							</td>
							<td>
								<span id="<portlet:namespace />read-mailed-by"></span>
							</td>
						</tr>
					</table>
				</div>

				<div id="<portlet:namespace />read-body" class="read-body">
				</div>
			</div>

			<div class="message-options">
				<table id="<portlet:namespace />messageOptions" name="message-options">
				<tr>
					<td id="<portlet:namespace />reply" responseType="reply">
						<a href="#message-options"><liferay-ui:message key="reply" /></a>
					</td>
					<td id="<portlet:namespace />reply-all" responseType="reply-all">
						<a href="#message-options"><liferay-ui:message key="reply-all" /></a>
					</td>
					<td id="<portlet:namespace />forward" responseType="forward">
						<a href="#message-options"><liferay-ui:message key="forward" /></a>
					</td>
				</tr>
				</table>
			</div>

			<form action="<portlet:actionURL name="saveOrSendMessage" />" enctype="multipart/form-data" id="<portlet:namespace />fm" method="post" name="<portlet:namespace />fm">
			<input id="<portlet:namespace />sendDraftMessageId" name="<portlet:namespace />sendDraftMessageId" type="hidden" value="">
			<input id="<portlet:namespace />sendAccountEntryId" name="<portlet:namespace />sendAccountEntryId" type="hidden" value="">
			<input id="<portlet:namespace />sendForwardMessageId" name="<portlet:namespace />sendForwardMessageId" type="hidden" value="">
			<input id="<portlet:namespace />sendForwardAttachmentIds" name="<portlet:namespace />sendForwardAttachmentIds" type="hidden" value="">
			<input id="<portlet:namespace />sendMessage" name="<portlet:namespace />sendMessage" type="hidden" value="">

			<div class="message-send results-header" id="<portlet:namespace />messageSend">
				<div class="options">
					<input class="send" type="button" value="<liferay-ui:message key="send" />">

					<input class="save" type="button" value="<liferay-ui:message key="save" />">

					<input class="discard" type="button" value="<liferay-ui:message key="discard" />">
				</div>

				<div class="details">
					<table>
					<tr class="to">
						<td class="label">
							<a href="javascript:;"><liferay-ui:message key="to" /></a>:
						</td>
						<td>
							<textarea class="send-to" id="<portlet:namespace />sendTo" name="<portlet:namespace />sendTo"></textarea>
						</td>
					</tr>
					<tr class="cc">
						<td class="label">
							<a href="javascript:;"><liferay-ui:message key="cc" /></a>:
						</td>
						<td>
							<input id="<portlet:namespace />sendCc" name="<portlet:namespace />sendCc" type="text">
						</td>
					</tr>
					<tr class="bcc">
						<td class="label">
							<a href="javascript:;"><liferay-ui:message key="bcc" /></a>:
						</td>
						<td>
							<input id="<portlet:namespace />sendBcc" name="<portlet:namespace />sendBcc" type="text">
						</td>
					</tr>
					<tr class="subject">
						<td class="label">
							<liferay-ui:message key="subject" />:
						</td>
						<td>
							<input id="<portlet:namespace />sendSubject" name="<portlet:namespace />sendSubject" type="text">
						</td>
					</tr>
					<tr class="attachments">
						<td class="label">
							<liferay-ui:message key="attachments" />:
						</td>
						<td>
							<input id="<portlet:namespace />sendAttachmentCount" name="<portlet:namespace />sendAttachmentCount" type="hidden" value="1" />
							<div id="<portlet:namespace />sendAttachments">
								<input id="<portlet:namespace />sendAttachment1" name="<portlet:namespace />sendAttachment1" size="50" type="file" />
							</div>
							<a href="javascript:;" class="add-attachment"><liferay-ui:message key="add-attachment" /></a>
						</td>
					</tr>
					</table>

					<span class="send-body-span">
						<liferay-ui:input-editor height="500px" width="95%" />

						<input id="<portlet:namespace />sendBody" name="<portlet:namespace />sendBody" type="hidden" />
					</span>
				</div>

				<div class="options">
					<input class="send" type="button" value="<liferay-ui:message key="send" />">

					<input class="save" type="button" value="<liferay-ui:message key="save" />">

					<input class="discard" type="button" value="<liferay-ui:message key="discard" />">
				</div>
			</div>
			</form>

			<div class="message-controls results-header">
				<div class="actions">
					<span class="back">&laquo; <%= LanguageUtil.format(pageContext, "back-to-x", "<span class=\"folder-name\">INBOX</span>") %></span>
				</div>

				<div class="navigation">
					<span class="newer">&lt; <liferay-ui:message key="newer" /></span>

					<span class="status">? of ???</span>

					<span class="older"><liferay-ui:message key="older" /> &gt;</span>
				</div>
			</div>
		</div>
	</td>
</tr>
</table>