<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/init.jsp" %>

<portlet:renderURL windowState="<%= WindowState.MAXIMIZED.toString() %>" var="viewAccountInitialURL">
	<portlet:param name="view" value="viewAccountURL" />
	<portlet:param name="initialAccountEntryId" value="" />
</portlet:renderURL>

<%
MessageManager messageManager = MessageManager.getInstance(request);
%>

<div class="new-messages-summary">
</div>

<div class="summary">
	<c:choose>
		<c:when test="<%= !enableMailAccountEntries && !enablePrivateAccountEntry %>">
			<liferay-ui:message key="please-contact-the-administrator-to-setup-this-portlet" />
		</c:when>
		<c:otherwise>
			<portlet:renderURL var="viewAccountInitialURL" windowState="<%= WindowState.MAXIMIZED.toString() %>">
				<portlet:param name="initialAccountEntryId" value="" />
			</portlet:renderURL>

			<c:if test="<%= enablePrivateAccountEntry %>">
				<div class="private-message-summary">

				<%
				List<AccountEntry> accountEntires = messageManager.getAccountEntries(false, true);

				for (AccountEntry messageAccountEnrty : accountEntires) {
				%>

					<a href="<%= viewAccountInitialURL %><%= messageAccountEnrty.getAccountEntryId() %>">
						<liferay-ui:message key="private-messages" /> (<%= messageManager.getUnreadMessageCountByAccountEntryId(messageAccountEnrty.getAccountEntryId()) %> <liferay-ui:message key="new-messages" />)
					</a>

				<%
				}
				%>

				</div>
			</c:if>

			<c:if test="<%= enableMailAccountEntries %>">
				<div class="mail-message-summary">
					<%
					List<AccountEntry> accountEntires = messageManager.getAccountEntries(true, false);
					%>

					<c:choose>
						<c:when test="<%= accountEntires.isEmpty() %>">
							<a href="<%= portletDisplay.getURLEdit() %>"><liferay-ui:message key="configure-email-accounts" /></a>
						</c:when>
						<c:otherwise>
							<liferay-ui:message key="mail-messages" /> (<a href="<%= portletDisplay.getURLEdit() %>"><liferay-ui:message key="configure-email-accounts" /></a>)

							<%
							for (AccountEntry messageAccountEnrty : accountEntires) {
							%>

								<div class="message-summary-listing">
									<a href="<%= viewAccountInitialURL %><%= messageAccountEnrty.getAccountEntryId() %>">
										<%= messageAccountEnrty.getMessageAddress() %> (<%= messageManager.getUnreadMessageCountByAccountEntryId(messageAccountEnrty.getAccountEntryId()) %> <liferay-ui:message key="new-messages" />)
									</a>
								</div>

							<%
							}
							%>
						</c:otherwise>
					</c:choose>
				</div>
			</c:if>
		</c:otherwise>
	</c:choose>
</div>